/* Data generated from the table of named character references found at
 *
 *   http://www.w3.org/TR/html5/named-character-references.html
 *
 * Files that #include this file must #define NAMED_CHARACTER_REFERENCE as a
 * macro of five parameters:
 *
 *   1.  a unique integer N identifying the Nth [0,1,..] macro expansion in this file,
 *   2.  a comma-separated sequence of characters comprising the character name,
 *   3.  the length of this sequence of characters,
 *   4.  a comma-separated sequence of PRUnichar literals (high to low) corresponding
 *       to the code-point of the named character, and
 *   5.  the length of this sequence of literals (either 1 or 2).
 *
 * The macro expansion doesn't have to refer to all or any of these parameters,
 * but common sense dictates that it should involve at least one of them.
 */

// This #define allows the NAMED_CHARACTER_REFERENCE macro to accept comma-
// separated sequences as single macro arguments.  Using commas directly would
// split the sequence into multiple macro arguments.
#define _ ,

NAMED_CHARACTER_REFERENCE(0, 'A' _ 'E' _ 'l' _ 'i' _ 'g', 5, 0x00c6, 1)
NAMED_CHARACTER_REFERENCE(1, 'A' _ 'E' _ 'l' _ 'i' _ 'g' _ ';', 6, 0x00c6, 1)
NAMED_CHARACTER_REFERENCE(2, 'A' _ 'M' _ 'P', 3, 0x0026, 1)
NAMED_CHARACTER_REFERENCE(3, 'A' _ 'M' _ 'P' _ ';', 4, 0x0026, 1)
NAMED_CHARACTER_REFERENCE(4, 'A' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00c1, 1)
NAMED_CHARACTER_REFERENCE(5, 'A' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00c1, 1)
NAMED_CHARACTER_REFERENCE(6, 'A' _ 'b' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 7, 0x0102, 1)
NAMED_CHARACTER_REFERENCE(7, 'A' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00c2, 1)
NAMED_CHARACTER_REFERENCE(8, 'A' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00c2, 1)
NAMED_CHARACTER_REFERENCE(9, 'A' _ 'c' _ 'y' _ ';', 4, 0x0410, 1)
NAMED_CHARACTER_REFERENCE(10, 'A' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd04, 2)
NAMED_CHARACTER_REFERENCE(11, 'A' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00c0, 1)
NAMED_CHARACTER_REFERENCE(12, 'A' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00c0, 1)
NAMED_CHARACTER_REFERENCE(13, 'A' _ 'l' _ 'p' _ 'h' _ 'a' _ ';', 6, 0x0391, 1)
NAMED_CHARACTER_REFERENCE(14, 'A' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x0100, 1)
NAMED_CHARACTER_REFERENCE(15, 'A' _ 'n' _ 'd' _ ';', 4, 0x2a53, 1)
NAMED_CHARACTER_REFERENCE(16, 'A' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x0104, 1)
NAMED_CHARACTER_REFERENCE(17, 'A' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd38, 2)
NAMED_CHARACTER_REFERENCE(18, 'A' _ 'p' _ 'p' _ 'l' _ 'y' _ 'F' _ 'u' _ 'n' _ 'c' _ 't' _ 'i' _ 'o' _ 'n' _ ';', 14, 0x2061, 1)
NAMED_CHARACTER_REFERENCE(19, 'A' _ 'r' _ 'i' _ 'n' _ 'g', 5, 0x00c5, 1)
NAMED_CHARACTER_REFERENCE(20, 'A' _ 'r' _ 'i' _ 'n' _ 'g' _ ';', 6, 0x00c5, 1)
NAMED_CHARACTER_REFERENCE(21, 'A' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdc9c, 2)
NAMED_CHARACTER_REFERENCE(22, 'A' _ 's' _ 's' _ 'i' _ 'g' _ 'n' _ ';', 7, 0x2254, 1)
NAMED_CHARACTER_REFERENCE(23, 'A' _ 't' _ 'i' _ 'l' _ 'd' _ 'e', 6, 0x00c3, 1)
NAMED_CHARACTER_REFERENCE(24, 'A' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x00c3, 1)
NAMED_CHARACTER_REFERENCE(25, 'A' _ 'u' _ 'm' _ 'l', 4, 0x00c4, 1)
NAMED_CHARACTER_REFERENCE(26, 'A' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00c4, 1)
NAMED_CHARACTER_REFERENCE(27, 'B' _ 'a' _ 'c' _ 'k' _ 's' _ 'l' _ 'a' _ 's' _ 'h' _ ';', 10, 0x2216, 1)
NAMED_CHARACTER_REFERENCE(28, 'B' _ 'a' _ 'r' _ 'v' _ ';', 5, 0x2ae7, 1)
NAMED_CHARACTER_REFERENCE(29, 'B' _ 'a' _ 'r' _ 'w' _ 'e' _ 'd' _ ';', 7, 0x2306, 1)
NAMED_CHARACTER_REFERENCE(30, 'B' _ 'c' _ 'y' _ ';', 4, 0x0411, 1)
NAMED_CHARACTER_REFERENCE(31, 'B' _ 'e' _ 'c' _ 'a' _ 'u' _ 's' _ 'e' _ ';', 8, 0x2235, 1)
NAMED_CHARACTER_REFERENCE(32, 'B' _ 'e' _ 'r' _ 'n' _ 'o' _ 'u' _ 'l' _ 'l' _ 'i' _ 's' _ ';', 11, 0x212c, 1)
NAMED_CHARACTER_REFERENCE(33, 'B' _ 'e' _ 't' _ 'a' _ ';', 5, 0x0392, 1)
NAMED_CHARACTER_REFERENCE(34, 'B' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd05, 2)
NAMED_CHARACTER_REFERENCE(35, 'B' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd39, 2)
NAMED_CHARACTER_REFERENCE(36, 'B' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 6, 0x02d8, 1)
NAMED_CHARACTER_REFERENCE(37, 'B' _ 's' _ 'c' _ 'r' _ ';', 5, 0x212c, 1)
NAMED_CHARACTER_REFERENCE(38, 'B' _ 'u' _ 'm' _ 'p' _ 'e' _ 'q' _ ';', 7, 0x224e, 1)
NAMED_CHARACTER_REFERENCE(39, 'C' _ 'H' _ 'c' _ 'y' _ ';', 5, 0x0427, 1)
NAMED_CHARACTER_REFERENCE(40, 'C' _ 'O' _ 'P' _ 'Y', 4, 0x00a9, 1)
NAMED_CHARACTER_REFERENCE(41, 'C' _ 'O' _ 'P' _ 'Y' _ ';', 5, 0x00a9, 1)
NAMED_CHARACTER_REFERENCE(42, 'C' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0106, 1)
NAMED_CHARACTER_REFERENCE(43, 'C' _ 'a' _ 'p' _ ';', 4, 0x22d2, 1)
NAMED_CHARACTER_REFERENCE(44, 'C' _ 'a' _ 'p' _ 'i' _ 't' _ 'a' _ 'l' _ 'D' _ 'i' _ 'f' _ 'f' _ 'e' _ 'r' _ 'e' _ 'n' _ 't' _ 'i' _ 'a' _ 'l' _ 'D' _ ';', 21, 0x2145, 1)
NAMED_CHARACTER_REFERENCE(45, 'C' _ 'a' _ 'y' _ 'l' _ 'e' _ 'y' _ 's' _ ';', 8, 0x212d, 1)
NAMED_CHARACTER_REFERENCE(46, 'C' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x010c, 1)
NAMED_CHARACTER_REFERENCE(47, 'C' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l', 6, 0x00c7, 1)
NAMED_CHARACTER_REFERENCE(48, 'C' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x00c7, 1)
NAMED_CHARACTER_REFERENCE(49, 'C' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0108, 1)
NAMED_CHARACTER_REFERENCE(50, 'C' _ 'c' _ 'o' _ 'n' _ 'i' _ 'n' _ 't' _ ';', 8, 0x2230, 1)
NAMED_CHARACTER_REFERENCE(51, 'C' _ 'd' _ 'o' _ 't' _ ';', 5, 0x010a, 1)
NAMED_CHARACTER_REFERENCE(52, 'C' _ 'e' _ 'd' _ 'i' _ 'l' _ 'l' _ 'a' _ ';', 8, 0x00b8, 1)
NAMED_CHARACTER_REFERENCE(53, 'C' _ 'e' _ 'n' _ 't' _ 'e' _ 'r' _ 'D' _ 'o' _ 't' _ ';', 10, 0x00b7, 1)
NAMED_CHARACTER_REFERENCE(54, 'C' _ 'f' _ 'r' _ ';', 4, 0x212d, 1)
NAMED_CHARACTER_REFERENCE(55, 'C' _ 'h' _ 'i' _ ';', 4, 0x03a7, 1)
NAMED_CHARACTER_REFERENCE(56, 'C' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'D' _ 'o' _ 't' _ ';', 10, 0x2299, 1)
NAMED_CHARACTER_REFERENCE(57, 'C' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'M' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 12, 0x2296, 1)
NAMED_CHARACTER_REFERENCE(58, 'C' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'P' _ 'l' _ 'u' _ 's' _ ';', 11, 0x2295, 1)
NAMED_CHARACTER_REFERENCE(59, 'C' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'T' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 12, 0x2297, 1)
NAMED_CHARACTER_REFERENCE(60, 'C' _ 'l' _ 'o' _ 'c' _ 'k' _ 'w' _ 'i' _ 's' _ 'e' _ 'C' _ 'o' _ 'n' _ 't' _ 'o' _ 'u' _ 'r' _ 'I' _ 'n' _ 't' _ 'e' _ 'g' _ 'r' _ 'a' _ 'l' _ ';', 25, 0x2232, 1)
NAMED_CHARACTER_REFERENCE(61, 'C' _ 'l' _ 'o' _ 's' _ 'e' _ 'C' _ 'u' _ 'r' _ 'l' _ 'y' _ 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'Q' _ 'u' _ 'o' _ 't' _ 'e' _ ';', 22, 0x201d, 1)
NAMED_CHARACTER_REFERENCE(62, 'C' _ 'l' _ 'o' _ 's' _ 'e' _ 'C' _ 'u' _ 'r' _ 'l' _ 'y' _ 'Q' _ 'u' _ 'o' _ 't' _ 'e' _ ';', 16, 0x2019, 1)
NAMED_CHARACTER_REFERENCE(63, 'C' _ 'o' _ 'l' _ 'o' _ 'n' _ ';', 6, 0x2237, 1)
NAMED_CHARACTER_REFERENCE(64, 'C' _ 'o' _ 'l' _ 'o' _ 'n' _ 'e' _ ';', 7, 0x2a74, 1)
NAMED_CHARACTER_REFERENCE(65, 'C' _ 'o' _ 'n' _ 'g' _ 'r' _ 'u' _ 'e' _ 'n' _ 't' _ ';', 10, 0x2261, 1)
NAMED_CHARACTER_REFERENCE(66, 'C' _ 'o' _ 'n' _ 'i' _ 'n' _ 't' _ ';', 7, 0x222f, 1)
NAMED_CHARACTER_REFERENCE(67, 'C' _ 'o' _ 'n' _ 't' _ 'o' _ 'u' _ 'r' _ 'I' _ 'n' _ 't' _ 'e' _ 'g' _ 'r' _ 'a' _ 'l' _ ';', 16, 0x222e, 1)
NAMED_CHARACTER_REFERENCE(68, 'C' _ 'o' _ 'p' _ 'f' _ ';', 5, 0x2102, 1)
NAMED_CHARACTER_REFERENCE(69, 'C' _ 'o' _ 'p' _ 'r' _ 'o' _ 'd' _ 'u' _ 'c' _ 't' _ ';', 10, 0x2210, 1)
NAMED_CHARACTER_REFERENCE(70, 'C' _ 'o' _ 'u' _ 'n' _ 't' _ 'e' _ 'r' _ 'C' _ 'l' _ 'o' _ 'c' _ 'k' _ 'w' _ 'i' _ 's' _ 'e' _ 'C' _ 'o' _ 'n' _ 't' _ 'o' _ 'u' _ 'r' _ 'I' _ 'n' _ 't' _ 'e' _ 'g' _ 'r' _ 'a' _ 'l' _ ';', 32, 0x2233, 1)
NAMED_CHARACTER_REFERENCE(71, 'C' _ 'r' _ 'o' _ 's' _ 's' _ ';', 6, 0x2a2f, 1)
NAMED_CHARACTER_REFERENCE(72, 'C' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdc9e, 2)
NAMED_CHARACTER_REFERENCE(73, 'C' _ 'u' _ 'p' _ ';', 4, 0x22d3, 1)
NAMED_CHARACTER_REFERENCE(74, 'C' _ 'u' _ 'p' _ 'C' _ 'a' _ 'p' _ ';', 7, 0x224d, 1)
NAMED_CHARACTER_REFERENCE(75, 'D' _ 'D' _ ';', 3, 0x2145, 1)
NAMED_CHARACTER_REFERENCE(76, 'D' _ 'D' _ 'o' _ 't' _ 'r' _ 'a' _ 'h' _ 'd' _ ';', 9, 0x2911, 1)
NAMED_CHARACTER_REFERENCE(77, 'D' _ 'J' _ 'c' _ 'y' _ ';', 5, 0x0402, 1)
NAMED_CHARACTER_REFERENCE(78, 'D' _ 'S' _ 'c' _ 'y' _ ';', 5, 0x0405, 1)
NAMED_CHARACTER_REFERENCE(79, 'D' _ 'Z' _ 'c' _ 'y' _ ';', 5, 0x040f, 1)
NAMED_CHARACTER_REFERENCE(80, 'D' _ 'a' _ 'g' _ 'g' _ 'e' _ 'r' _ ';', 7, 0x2021, 1)
NAMED_CHARACTER_REFERENCE(81, 'D' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x21a1, 1)
NAMED_CHARACTER_REFERENCE(82, 'D' _ 'a' _ 's' _ 'h' _ 'v' _ ';', 6, 0x2ae4, 1)
NAMED_CHARACTER_REFERENCE(83, 'D' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x010e, 1)
NAMED_CHARACTER_REFERENCE(84, 'D' _ 'c' _ 'y' _ ';', 4, 0x0414, 1)
NAMED_CHARACTER_REFERENCE(85, 'D' _ 'e' _ 'l' _ ';', 4, 0x2207, 1)
NAMED_CHARACTER_REFERENCE(86, 'D' _ 'e' _ 'l' _ 't' _ 'a' _ ';', 6, 0x0394, 1)
NAMED_CHARACTER_REFERENCE(87, 'D' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd07, 2)
NAMED_CHARACTER_REFERENCE(88, 'D' _ 'i' _ 'a' _ 'c' _ 'r' _ 'i' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'A' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 17, 0x00b4, 1)
NAMED_CHARACTER_REFERENCE(89, 'D' _ 'i' _ 'a' _ 'c' _ 'r' _ 'i' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'D' _ 'o' _ 't' _ ';', 15, 0x02d9, 1)
NAMED_CHARACTER_REFERENCE(90, 'D' _ 'i' _ 'a' _ 'c' _ 'r' _ 'i' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'A' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 23, 0x02dd, 1)
NAMED_CHARACTER_REFERENCE(91, 'D' _ 'i' _ 'a' _ 'c' _ 'r' _ 'i' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'G' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 17, 0x0060, 1)
NAMED_CHARACTER_REFERENCE(92, 'D' _ 'i' _ 'a' _ 'c' _ 'r' _ 'i' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 17, 0x02dc, 1)
NAMED_CHARACTER_REFERENCE(93, 'D' _ 'i' _ 'a' _ 'm' _ 'o' _ 'n' _ 'd' _ ';', 8, 0x22c4, 1)
NAMED_CHARACTER_REFERENCE(94, 'D' _ 'i' _ 'f' _ 'f' _ 'e' _ 'r' _ 'e' _ 'n' _ 't' _ 'i' _ 'a' _ 'l' _ 'D' _ ';', 14, 0x2146, 1)
NAMED_CHARACTER_REFERENCE(95, 'D' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd3b, 2)
NAMED_CHARACTER_REFERENCE(96, 'D' _ 'o' _ 't' _ ';', 4, 0x00a8, 1)
NAMED_CHARACTER_REFERENCE(97, 'D' _ 'o' _ 't' _ 'D' _ 'o' _ 't' _ ';', 7, 0x20dc, 1)
NAMED_CHARACTER_REFERENCE(98, 'D' _ 'o' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 9, 0x2250, 1)
NAMED_CHARACTER_REFERENCE(99, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'C' _ 'o' _ 'n' _ 't' _ 'o' _ 'u' _ 'r' _ 'I' _ 'n' _ 't' _ 'e' _ 'g' _ 'r' _ 'a' _ 'l' _ ';', 22, 0x222f, 1)
NAMED_CHARACTER_REFERENCE(100, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'D' _ 'o' _ 't' _ ';', 10, 0x00a8, 1)
NAMED_CHARACTER_REFERENCE(101, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x21d3, 1)
NAMED_CHARACTER_REFERENCE(102, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x21d0, 1)
NAMED_CHARACTER_REFERENCE(103, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'L' _ 'e' _ 'f' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 21, 0x21d4, 1)
NAMED_CHARACTER_REFERENCE(104, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'e' _ 'e' _ ';', 14, 0x2ae4, 1)
NAMED_CHARACTER_REFERENCE(105, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'L' _ 'o' _ 'n' _ 'g' _ 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 20, 0x27f8, 1)
NAMED_CHARACTER_REFERENCE(106, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'L' _ 'o' _ 'n' _ 'g' _ 'L' _ 'e' _ 'f' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 25, 0x27fa, 1)
NAMED_CHARACTER_REFERENCE(107, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'L' _ 'o' _ 'n' _ 'g' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 21, 0x27f9, 1)
NAMED_CHARACTER_REFERENCE(108, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 17, 0x21d2, 1)
NAMED_CHARACTER_REFERENCE(109, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'e' _ 'e' _ ';', 15, 0x22a8, 1)
NAMED_CHARACTER_REFERENCE(110, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'U' _ 'p' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 14, 0x21d1, 1)
NAMED_CHARACTER_REFERENCE(111, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'U' _ 'p' _ 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 18, 0x21d5, 1)
NAMED_CHARACTER_REFERENCE(112, 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'V' _ 'e' _ 'r' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'B' _ 'a' _ 'r' _ ';', 18, 0x2225, 1)
NAMED_CHARACTER_REFERENCE(113, 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 10, 0x2193, 1)
NAMED_CHARACTER_REFERENCE(114, 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'B' _ 'a' _ 'r' _ ';', 13, 0x2913, 1)
NAMED_CHARACTER_REFERENCE(115, 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'U' _ 'p' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 17, 0x21f5, 1)
NAMED_CHARACTER_REFERENCE(116, 'D' _ 'o' _ 'w' _ 'n' _ 'B' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 10, 0x0311, 1)
NAMED_CHARACTER_REFERENCE(117, 'D' _ 'o' _ 'w' _ 'n' _ 'L' _ 'e' _ 'f' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 20, 0x2950, 1)
NAMED_CHARACTER_REFERENCE(118, 'D' _ 'o' _ 'w' _ 'n' _ 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 18, 0x295e, 1)
NAMED_CHARACTER_REFERENCE(119, 'D' _ 'o' _ 'w' _ 'n' _ 'L' _ 'e' _ 'f' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 15, 0x21bd, 1)
NAMED_CHARACTER_REFERENCE(120, 'D' _ 'o' _ 'w' _ 'n' _ 'L' _ 'e' _ 'f' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 18, 0x2956, 1)
NAMED_CHARACTER_REFERENCE(121, 'D' _ 'o' _ 'w' _ 'n' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 19, 0x295f, 1)
NAMED_CHARACTER_REFERENCE(122, 'D' _ 'o' _ 'w' _ 'n' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 16, 0x21c1, 1)
NAMED_CHARACTER_REFERENCE(123, 'D' _ 'o' _ 'w' _ 'n' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 19, 0x2957, 1)
NAMED_CHARACTER_REFERENCE(124, 'D' _ 'o' _ 'w' _ 'n' _ 'T' _ 'e' _ 'e' _ ';', 8, 0x22a4, 1)
NAMED_CHARACTER_REFERENCE(125, 'D' _ 'o' _ 'w' _ 'n' _ 'T' _ 'e' _ 'e' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 13, 0x21a7, 1)
NAMED_CHARACTER_REFERENCE(126, 'D' _ 'o' _ 'w' _ 'n' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 10, 0x21d3, 1)
NAMED_CHARACTER_REFERENCE(127, 'D' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdc9f, 2)
NAMED_CHARACTER_REFERENCE(128, 'D' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0110, 1)
NAMED_CHARACTER_REFERENCE(129, 'E' _ 'N' _ 'G' _ ';', 4, 0x014a, 1)
NAMED_CHARACTER_REFERENCE(130, 'E' _ 'T' _ 'H', 3, 0x00d0, 1)
NAMED_CHARACTER_REFERENCE(131, 'E' _ 'T' _ 'H' _ ';', 4, 0x00d0, 1)
NAMED_CHARACTER_REFERENCE(132, 'E' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00c9, 1)
NAMED_CHARACTER_REFERENCE(133, 'E' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00c9, 1)
NAMED_CHARACTER_REFERENCE(134, 'E' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x011a, 1)
NAMED_CHARACTER_REFERENCE(135, 'E' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00ca, 1)
NAMED_CHARACTER_REFERENCE(136, 'E' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00ca, 1)
NAMED_CHARACTER_REFERENCE(137, 'E' _ 'c' _ 'y' _ ';', 4, 0x042d, 1)
NAMED_CHARACTER_REFERENCE(138, 'E' _ 'd' _ 'o' _ 't' _ ';', 5, 0x0116, 1)
NAMED_CHARACTER_REFERENCE(139, 'E' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd08, 2)
NAMED_CHARACTER_REFERENCE(140, 'E' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00c8, 1)
NAMED_CHARACTER_REFERENCE(141, 'E' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00c8, 1)
NAMED_CHARACTER_REFERENCE(142, 'E' _ 'l' _ 'e' _ 'm' _ 'e' _ 'n' _ 't' _ ';', 8, 0x2208, 1)
NAMED_CHARACTER_REFERENCE(143, 'E' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x0112, 1)
NAMED_CHARACTER_REFERENCE(144, 'E' _ 'm' _ 'p' _ 't' _ 'y' _ 'S' _ 'm' _ 'a' _ 'l' _ 'l' _ 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 17, 0x25fb, 1)
NAMED_CHARACTER_REFERENCE(145, 'E' _ 'm' _ 'p' _ 't' _ 'y' _ 'V' _ 'e' _ 'r' _ 'y' _ 'S' _ 'm' _ 'a' _ 'l' _ 'l' _ 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 21, 0x25ab, 1)
NAMED_CHARACTER_REFERENCE(146, 'E' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x0118, 1)
NAMED_CHARACTER_REFERENCE(147, 'E' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd3c, 2)
NAMED_CHARACTER_REFERENCE(148, 'E' _ 'p' _ 's' _ 'i' _ 'l' _ 'o' _ 'n' _ ';', 8, 0x0395, 1)
NAMED_CHARACTER_REFERENCE(149, 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 6, 0x2a75, 1)
NAMED_CHARACTER_REFERENCE(150, 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 11, 0x2242, 1)
NAMED_CHARACTER_REFERENCE(151, 'E' _ 'q' _ 'u' _ 'i' _ 'l' _ 'i' _ 'b' _ 'r' _ 'i' _ 'u' _ 'm' _ ';', 12, 0x21cc, 1)
NAMED_CHARACTER_REFERENCE(152, 'E' _ 's' _ 'c' _ 'r' _ ';', 5, 0x2130, 1)
NAMED_CHARACTER_REFERENCE(153, 'E' _ 's' _ 'i' _ 'm' _ ';', 5, 0x2a73, 1)
NAMED_CHARACTER_REFERENCE(154, 'E' _ 't' _ 'a' _ ';', 4, 0x0397, 1)
NAMED_CHARACTER_REFERENCE(155, 'E' _ 'u' _ 'm' _ 'l', 4, 0x00cb, 1)
NAMED_CHARACTER_REFERENCE(156, 'E' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00cb, 1)
NAMED_CHARACTER_REFERENCE(157, 'E' _ 'x' _ 'i' _ 's' _ 't' _ 's' _ ';', 7, 0x2203, 1)
NAMED_CHARACTER_REFERENCE(158, 'E' _ 'x' _ 'p' _ 'o' _ 'n' _ 'e' _ 'n' _ 't' _ 'i' _ 'a' _ 'l' _ 'E' _ ';', 13, 0x2147, 1)
NAMED_CHARACTER_REFERENCE(159, 'F' _ 'c' _ 'y' _ ';', 4, 0x0424, 1)
NAMED_CHARACTER_REFERENCE(160, 'F' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd09, 2)
NAMED_CHARACTER_REFERENCE(161, 'F' _ 'i' _ 'l' _ 'l' _ 'e' _ 'd' _ 'S' _ 'm' _ 'a' _ 'l' _ 'l' _ 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 18, 0x25fc, 1)
NAMED_CHARACTER_REFERENCE(162, 'F' _ 'i' _ 'l' _ 'l' _ 'e' _ 'd' _ 'V' _ 'e' _ 'r' _ 'y' _ 'S' _ 'm' _ 'a' _ 'l' _ 'l' _ 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 22, 0x25aa, 1)
NAMED_CHARACTER_REFERENCE(163, 'F' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd3d, 2)
NAMED_CHARACTER_REFERENCE(164, 'F' _ 'o' _ 'r' _ 'A' _ 'l' _ 'l' _ ';', 7, 0x2200, 1)
NAMED_CHARACTER_REFERENCE(165, 'F' _ 'o' _ 'u' _ 'r' _ 'i' _ 'e' _ 'r' _ 't' _ 'r' _ 'f' _ ';', 11, 0x2131, 1)
NAMED_CHARACTER_REFERENCE(166, 'F' _ 's' _ 'c' _ 'r' _ ';', 5, 0x2131, 1)
NAMED_CHARACTER_REFERENCE(167, 'G' _ 'J' _ 'c' _ 'y' _ ';', 5, 0x0403, 1)
NAMED_CHARACTER_REFERENCE(168, 'G' _ 'T', 2, 0x003e, 1)
NAMED_CHARACTER_REFERENCE(169, 'G' _ 'T' _ ';', 3, 0x003e, 1)
NAMED_CHARACTER_REFERENCE(170, 'G' _ 'a' _ 'm' _ 'm' _ 'a' _ ';', 6, 0x0393, 1)
NAMED_CHARACTER_REFERENCE(171, 'G' _ 'a' _ 'm' _ 'm' _ 'a' _ 'd' _ ';', 7, 0x03dc, 1)
NAMED_CHARACTER_REFERENCE(172, 'G' _ 'b' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 7, 0x011e, 1)
NAMED_CHARACTER_REFERENCE(173, 'G' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0122, 1)
NAMED_CHARACTER_REFERENCE(174, 'G' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x011c, 1)
NAMED_CHARACTER_REFERENCE(175, 'G' _ 'c' _ 'y' _ ';', 4, 0x0413, 1)
NAMED_CHARACTER_REFERENCE(176, 'G' _ 'd' _ 'o' _ 't' _ ';', 5, 0x0120, 1)
NAMED_CHARACTER_REFERENCE(177, 'G' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd0a, 2)
NAMED_CHARACTER_REFERENCE(178, 'G' _ 'g' _ ';', 3, 0x22d9, 1)
NAMED_CHARACTER_REFERENCE(179, 'G' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd3e, 2)
NAMED_CHARACTER_REFERENCE(180, 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 13, 0x2265, 1)
NAMED_CHARACTER_REFERENCE(181, 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ 'L' _ 'e' _ 's' _ 's' _ ';', 17, 0x22db, 1)
NAMED_CHARACTER_REFERENCE(182, 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'F' _ 'u' _ 'l' _ 'l' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 17, 0x2267, 1)
NAMED_CHARACTER_REFERENCE(183, 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ ';', 15, 0x2aa2, 1)
NAMED_CHARACTER_REFERENCE(184, 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'L' _ 'e' _ 's' _ 's' _ ';', 12, 0x2277, 1)
NAMED_CHARACTER_REFERENCE(185, 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'S' _ 'l' _ 'a' _ 'n' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 18, 0x2a7e, 1)
NAMED_CHARACTER_REFERENCE(186, 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 13, 0x2273, 1)
NAMED_CHARACTER_REFERENCE(187, 'G' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdca2, 2)
NAMED_CHARACTER_REFERENCE(188, 'G' _ 't' _ ';', 3, 0x226b, 1)
NAMED_CHARACTER_REFERENCE(189, 'H' _ 'A' _ 'R' _ 'D' _ 'c' _ 'y' _ ';', 7, 0x042a, 1)
NAMED_CHARACTER_REFERENCE(190, 'H' _ 'a' _ 'c' _ 'e' _ 'k' _ ';', 6, 0x02c7, 1)
NAMED_CHARACTER_REFERENCE(191, 'H' _ 'a' _ 't' _ ';', 4, 0x005e, 1)
NAMED_CHARACTER_REFERENCE(192, 'H' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0124, 1)
NAMED_CHARACTER_REFERENCE(193, 'H' _ 'f' _ 'r' _ ';', 4, 0x210c, 1)
NAMED_CHARACTER_REFERENCE(194, 'H' _ 'i' _ 'l' _ 'b' _ 'e' _ 'r' _ 't' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 13, 0x210b, 1)
NAMED_CHARACTER_REFERENCE(195, 'H' _ 'o' _ 'p' _ 'f' _ ';', 5, 0x210d, 1)
NAMED_CHARACTER_REFERENCE(196, 'H' _ 'o' _ 'r' _ 'i' _ 'z' _ 'o' _ 'n' _ 't' _ 'a' _ 'l' _ 'L' _ 'i' _ 'n' _ 'e' _ ';', 15, 0x2500, 1)
NAMED_CHARACTER_REFERENCE(197, 'H' _ 's' _ 'c' _ 'r' _ ';', 5, 0x210b, 1)
NAMED_CHARACTER_REFERENCE(198, 'H' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0126, 1)
NAMED_CHARACTER_REFERENCE(199, 'H' _ 'u' _ 'm' _ 'p' _ 'D' _ 'o' _ 'w' _ 'n' _ 'H' _ 'u' _ 'm' _ 'p' _ ';', 13, 0x224e, 1)
NAMED_CHARACTER_REFERENCE(200, 'H' _ 'u' _ 'm' _ 'p' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 10, 0x224f, 1)
NAMED_CHARACTER_REFERENCE(201, 'I' _ 'E' _ 'c' _ 'y' _ ';', 5, 0x0415, 1)
NAMED_CHARACTER_REFERENCE(202, 'I' _ 'J' _ 'l' _ 'i' _ 'g' _ ';', 6, 0x0132, 1)
NAMED_CHARACTER_REFERENCE(203, 'I' _ 'O' _ 'c' _ 'y' _ ';', 5, 0x0401, 1)
NAMED_CHARACTER_REFERENCE(204, 'I' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00cd, 1)
NAMED_CHARACTER_REFERENCE(205, 'I' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00cd, 1)
NAMED_CHARACTER_REFERENCE(206, 'I' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00ce, 1)
NAMED_CHARACTER_REFERENCE(207, 'I' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00ce, 1)
NAMED_CHARACTER_REFERENCE(208, 'I' _ 'c' _ 'y' _ ';', 4, 0x0418, 1)
NAMED_CHARACTER_REFERENCE(209, 'I' _ 'd' _ 'o' _ 't' _ ';', 5, 0x0130, 1)
NAMED_CHARACTER_REFERENCE(210, 'I' _ 'f' _ 'r' _ ';', 4, 0x2111, 1)
NAMED_CHARACTER_REFERENCE(211, 'I' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00cc, 1)
NAMED_CHARACTER_REFERENCE(212, 'I' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00cc, 1)
NAMED_CHARACTER_REFERENCE(213, 'I' _ 'm' _ ';', 3, 0x2111, 1)
NAMED_CHARACTER_REFERENCE(214, 'I' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x012a, 1)
NAMED_CHARACTER_REFERENCE(215, 'I' _ 'm' _ 'a' _ 'g' _ 'i' _ 'n' _ 'a' _ 'r' _ 'y' _ 'I' _ ';', 11, 0x2148, 1)
NAMED_CHARACTER_REFERENCE(216, 'I' _ 'm' _ 'p' _ 'l' _ 'i' _ 'e' _ 's' _ ';', 8, 0x21d2, 1)
NAMED_CHARACTER_REFERENCE(217, 'I' _ 'n' _ 't' _ ';', 4, 0x222c, 1)
NAMED_CHARACTER_REFERENCE(218, 'I' _ 'n' _ 't' _ 'e' _ 'g' _ 'r' _ 'a' _ 'l' _ ';', 9, 0x222b, 1)
NAMED_CHARACTER_REFERENCE(219, 'I' _ 'n' _ 't' _ 'e' _ 'r' _ 's' _ 'e' _ 'c' _ 't' _ 'i' _ 'o' _ 'n' _ ';', 13, 0x22c2, 1)
NAMED_CHARACTER_REFERENCE(220, 'I' _ 'n' _ 'v' _ 'i' _ 's' _ 'i' _ 'b' _ 'l' _ 'e' _ 'C' _ 'o' _ 'm' _ 'm' _ 'a' _ ';', 15, 0x2063, 1)
NAMED_CHARACTER_REFERENCE(221, 'I' _ 'n' _ 'v' _ 'i' _ 's' _ 'i' _ 'b' _ 'l' _ 'e' _ 'T' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 15, 0x2062, 1)
NAMED_CHARACTER_REFERENCE(222, 'I' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x012e, 1)
NAMED_CHARACTER_REFERENCE(223, 'I' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd40, 2)
NAMED_CHARACTER_REFERENCE(224, 'I' _ 'o' _ 't' _ 'a' _ ';', 5, 0x0399, 1)
NAMED_CHARACTER_REFERENCE(225, 'I' _ 's' _ 'c' _ 'r' _ ';', 5, 0x2110, 1)
NAMED_CHARACTER_REFERENCE(226, 'I' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x0128, 1)
NAMED_CHARACTER_REFERENCE(227, 'I' _ 'u' _ 'k' _ 'c' _ 'y' _ ';', 6, 0x0406, 1)
NAMED_CHARACTER_REFERENCE(228, 'I' _ 'u' _ 'm' _ 'l', 4, 0x00cf, 1)
NAMED_CHARACTER_REFERENCE(229, 'I' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00cf, 1)
NAMED_CHARACTER_REFERENCE(230, 'J' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0134, 1)
NAMED_CHARACTER_REFERENCE(231, 'J' _ 'c' _ 'y' _ ';', 4, 0x0419, 1)
NAMED_CHARACTER_REFERENCE(232, 'J' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd0d, 2)
NAMED_CHARACTER_REFERENCE(233, 'J' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd41, 2)
NAMED_CHARACTER_REFERENCE(234, 'J' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdca5, 2)
NAMED_CHARACTER_REFERENCE(235, 'J' _ 's' _ 'e' _ 'r' _ 'c' _ 'y' _ ';', 7, 0x0408, 1)
NAMED_CHARACTER_REFERENCE(236, 'J' _ 'u' _ 'k' _ 'c' _ 'y' _ ';', 6, 0x0404, 1)
NAMED_CHARACTER_REFERENCE(237, 'K' _ 'H' _ 'c' _ 'y' _ ';', 5, 0x0425, 1)
NAMED_CHARACTER_REFERENCE(238, 'K' _ 'J' _ 'c' _ 'y' _ ';', 5, 0x040c, 1)
NAMED_CHARACTER_REFERENCE(239, 'K' _ 'a' _ 'p' _ 'p' _ 'a' _ ';', 6, 0x039a, 1)
NAMED_CHARACTER_REFERENCE(240, 'K' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0136, 1)
NAMED_CHARACTER_REFERENCE(241, 'K' _ 'c' _ 'y' _ ';', 4, 0x041a, 1)
NAMED_CHARACTER_REFERENCE(242, 'K' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd0e, 2)
NAMED_CHARACTER_REFERENCE(243, 'K' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd42, 2)
NAMED_CHARACTER_REFERENCE(244, 'K' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdca6, 2)
NAMED_CHARACTER_REFERENCE(245, 'L' _ 'J' _ 'c' _ 'y' _ ';', 5, 0x0409, 1)
NAMED_CHARACTER_REFERENCE(246, 'L' _ 'T', 2, 0x003c, 1)
NAMED_CHARACTER_REFERENCE(247, 'L' _ 'T' _ ';', 3, 0x003c, 1)
NAMED_CHARACTER_REFERENCE(248, 'L' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0139, 1)
NAMED_CHARACTER_REFERENCE(249, 'L' _ 'a' _ 'm' _ 'b' _ 'd' _ 'a' _ ';', 7, 0x039b, 1)
NAMED_CHARACTER_REFERENCE(250, 'L' _ 'a' _ 'n' _ 'g' _ ';', 5, 0x27ea, 1)
NAMED_CHARACTER_REFERENCE(251, 'L' _ 'a' _ 'p' _ 'l' _ 'a' _ 'c' _ 'e' _ 't' _ 'r' _ 'f' _ ';', 11, 0x2112, 1)
NAMED_CHARACTER_REFERENCE(252, 'L' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x219e, 1)
NAMED_CHARACTER_REFERENCE(253, 'L' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x013d, 1)
NAMED_CHARACTER_REFERENCE(254, 'L' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x013b, 1)
NAMED_CHARACTER_REFERENCE(255, 'L' _ 'c' _ 'y' _ ';', 4, 0x041b, 1)
NAMED_CHARACTER_REFERENCE(256, 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'n' _ 'g' _ 'l' _ 'e' _ 'B' _ 'r' _ 'a' _ 'c' _ 'k' _ 'e' _ 't' _ ';', 17, 0x27e8, 1)
NAMED_CHARACTER_REFERENCE(257, 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 10, 0x2190, 1)
NAMED_CHARACTER_REFERENCE(258, 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'B' _ 'a' _ 'r' _ ';', 13, 0x21e4, 1)
NAMED_CHARACTER_REFERENCE(259, 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 20, 0x21c6, 1)
NAMED_CHARACTER_REFERENCE(260, 'L' _ 'e' _ 'f' _ 't' _ 'C' _ 'e' _ 'i' _ 'l' _ 'i' _ 'n' _ 'g' _ ';', 12, 0x2308, 1)
NAMED_CHARACTER_REFERENCE(261, 'L' _ 'e' _ 'f' _ 't' _ 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'B' _ 'r' _ 'a' _ 'c' _ 'k' _ 'e' _ 't' _ ';', 18, 0x27e6, 1)
NAMED_CHARACTER_REFERENCE(262, 'L' _ 'e' _ 'f' _ 't' _ 'D' _ 'o' _ 'w' _ 'n' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 18, 0x2961, 1)
NAMED_CHARACTER_REFERENCE(263, 'L' _ 'e' _ 'f' _ 't' _ 'D' _ 'o' _ 'w' _ 'n' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 15, 0x21c3, 1)
NAMED_CHARACTER_REFERENCE(264, 'L' _ 'e' _ 'f' _ 't' _ 'D' _ 'o' _ 'w' _ 'n' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 18, 0x2959, 1)
NAMED_CHARACTER_REFERENCE(265, 'L' _ 'e' _ 'f' _ 't' _ 'F' _ 'l' _ 'o' _ 'o' _ 'r' _ ';', 10, 0x230a, 1)
NAMED_CHARACTER_REFERENCE(266, 'L' _ 'e' _ 'f' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x2194, 1)
NAMED_CHARACTER_REFERENCE(267, 'L' _ 'e' _ 'f' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 16, 0x294e, 1)
NAMED_CHARACTER_REFERENCE(268, 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'e' _ 'e' _ ';', 8, 0x22a3, 1)
NAMED_CHARACTER_REFERENCE(269, 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'e' _ 'e' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 13, 0x21a4, 1)
NAMED_CHARACTER_REFERENCE(270, 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 14, 0x295a, 1)
NAMED_CHARACTER_REFERENCE(271, 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 13, 0x22b2, 1)
NAMED_CHARACTER_REFERENCE(272, 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'B' _ 'a' _ 'r' _ ';', 16, 0x29cf, 1)
NAMED_CHARACTER_REFERENCE(273, 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 18, 0x22b4, 1)
NAMED_CHARACTER_REFERENCE(274, 'L' _ 'e' _ 'f' _ 't' _ 'U' _ 'p' _ 'D' _ 'o' _ 'w' _ 'n' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 17, 0x2951, 1)
NAMED_CHARACTER_REFERENCE(275, 'L' _ 'e' _ 'f' _ 't' _ 'U' _ 'p' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 16, 0x2960, 1)
NAMED_CHARACTER_REFERENCE(276, 'L' _ 'e' _ 'f' _ 't' _ 'U' _ 'p' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 13, 0x21bf, 1)
NAMED_CHARACTER_REFERENCE(277, 'L' _ 'e' _ 'f' _ 't' _ 'U' _ 'p' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 16, 0x2958, 1)
NAMED_CHARACTER_REFERENCE(278, 'L' _ 'e' _ 'f' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 11, 0x21bc, 1)
NAMED_CHARACTER_REFERENCE(279, 'L' _ 'e' _ 'f' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 14, 0x2952, 1)
NAMED_CHARACTER_REFERENCE(280, 'L' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 10, 0x21d0, 1)
NAMED_CHARACTER_REFERENCE(281, 'L' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x21d4, 1)
NAMED_CHARACTER_REFERENCE(282, 'L' _ 'e' _ 's' _ 's' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ ';', 17, 0x22da, 1)
NAMED_CHARACTER_REFERENCE(283, 'L' _ 'e' _ 's' _ 's' _ 'F' _ 'u' _ 'l' _ 'l' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 14, 0x2266, 1)
NAMED_CHARACTER_REFERENCE(284, 'L' _ 'e' _ 's' _ 's' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ ';', 12, 0x2276, 1)
NAMED_CHARACTER_REFERENCE(285, 'L' _ 'e' _ 's' _ 's' _ 'L' _ 'e' _ 's' _ 's' _ ';', 9, 0x2aa1, 1)
NAMED_CHARACTER_REFERENCE(286, 'L' _ 'e' _ 's' _ 's' _ 'S' _ 'l' _ 'a' _ 'n' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 15, 0x2a7d, 1)
NAMED_CHARACTER_REFERENCE(287, 'L' _ 'e' _ 's' _ 's' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 10, 0x2272, 1)
NAMED_CHARACTER_REFERENCE(288, 'L' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd0f, 2)
NAMED_CHARACTER_REFERENCE(289, 'L' _ 'l' _ ';', 3, 0x22d8, 1)
NAMED_CHARACTER_REFERENCE(290, 'L' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 11, 0x21da, 1)
NAMED_CHARACTER_REFERENCE(291, 'L' _ 'm' _ 'i' _ 'd' _ 'o' _ 't' _ ';', 7, 0x013f, 1)
NAMED_CHARACTER_REFERENCE(292, 'L' _ 'o' _ 'n' _ 'g' _ 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 14, 0x27f5, 1)
NAMED_CHARACTER_REFERENCE(293, 'L' _ 'o' _ 'n' _ 'g' _ 'L' _ 'e' _ 'f' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 19, 0x27f7, 1)
NAMED_CHARACTER_REFERENCE(294, 'L' _ 'o' _ 'n' _ 'g' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x27f6, 1)
NAMED_CHARACTER_REFERENCE(295, 'L' _ 'o' _ 'n' _ 'g' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 14, 0x27f8, 1)
NAMED_CHARACTER_REFERENCE(296, 'L' _ 'o' _ 'n' _ 'g' _ 'l' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 19, 0x27fa, 1)
NAMED_CHARACTER_REFERENCE(297, 'L' _ 'o' _ 'n' _ 'g' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x27f9, 1)
NAMED_CHARACTER_REFERENCE(298, 'L' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd43, 2)
NAMED_CHARACTER_REFERENCE(299, 'L' _ 'o' _ 'w' _ 'e' _ 'r' _ 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x2199, 1)
NAMED_CHARACTER_REFERENCE(300, 'L' _ 'o' _ 'w' _ 'e' _ 'r' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x2198, 1)
NAMED_CHARACTER_REFERENCE(301, 'L' _ 's' _ 'c' _ 'r' _ ';', 5, 0x2112, 1)
NAMED_CHARACTER_REFERENCE(302, 'L' _ 's' _ 'h' _ ';', 4, 0x21b0, 1)
NAMED_CHARACTER_REFERENCE(303, 'L' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0141, 1)
NAMED_CHARACTER_REFERENCE(304, 'L' _ 't' _ ';', 3, 0x226a, 1)
NAMED_CHARACTER_REFERENCE(305, 'M' _ 'a' _ 'p' _ ';', 4, 0x2905, 1)
NAMED_CHARACTER_REFERENCE(306, 'M' _ 'c' _ 'y' _ ';', 4, 0x041c, 1)
NAMED_CHARACTER_REFERENCE(307, 'M' _ 'e' _ 'd' _ 'i' _ 'u' _ 'm' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 12, 0x205f, 1)
NAMED_CHARACTER_REFERENCE(308, 'M' _ 'e' _ 'l' _ 'l' _ 'i' _ 'n' _ 't' _ 'r' _ 'f' _ ';', 10, 0x2133, 1)
NAMED_CHARACTER_REFERENCE(309, 'M' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd10, 2)
NAMED_CHARACTER_REFERENCE(310, 'M' _ 'i' _ 'n' _ 'u' _ 's' _ 'P' _ 'l' _ 'u' _ 's' _ ';', 10, 0x2213, 1)
NAMED_CHARACTER_REFERENCE(311, 'M' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd44, 2)
NAMED_CHARACTER_REFERENCE(312, 'M' _ 's' _ 'c' _ 'r' _ ';', 5, 0x2133, 1)
NAMED_CHARACTER_REFERENCE(313, 'M' _ 'u' _ ';', 3, 0x039c, 1)
NAMED_CHARACTER_REFERENCE(314, 'N' _ 'J' _ 'c' _ 'y' _ ';', 5, 0x040a, 1)
NAMED_CHARACTER_REFERENCE(315, 'N' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0143, 1)
NAMED_CHARACTER_REFERENCE(316, 'N' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0147, 1)
NAMED_CHARACTER_REFERENCE(317, 'N' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0145, 1)
NAMED_CHARACTER_REFERENCE(318, 'N' _ 'c' _ 'y' _ ';', 4, 0x041d, 1)
NAMED_CHARACTER_REFERENCE(319, 'N' _ 'e' _ 'g' _ 'a' _ 't' _ 'i' _ 'v' _ 'e' _ 'M' _ 'e' _ 'd' _ 'i' _ 'u' _ 'm' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 20, 0x200b, 1)
NAMED_CHARACTER_REFERENCE(320, 'N' _ 'e' _ 'g' _ 'a' _ 't' _ 'i' _ 'v' _ 'e' _ 'T' _ 'h' _ 'i' _ 'c' _ 'k' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 19, 0x200b, 1)
NAMED_CHARACTER_REFERENCE(321, 'N' _ 'e' _ 'g' _ 'a' _ 't' _ 'i' _ 'v' _ 'e' _ 'T' _ 'h' _ 'i' _ 'n' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 18, 0x200b, 1)
NAMED_CHARACTER_REFERENCE(322, 'N' _ 'e' _ 'g' _ 'a' _ 't' _ 'i' _ 'v' _ 'e' _ 'V' _ 'e' _ 'r' _ 'y' _ 'T' _ 'h' _ 'i' _ 'n' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 22, 0x200b, 1)
NAMED_CHARACTER_REFERENCE(323, 'N' _ 'e' _ 's' _ 't' _ 'e' _ 'd' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ ';', 21, 0x226b, 1)
NAMED_CHARACTER_REFERENCE(324, 'N' _ 'e' _ 's' _ 't' _ 'e' _ 'd' _ 'L' _ 'e' _ 's' _ 's' _ 'L' _ 'e' _ 's' _ 's' _ ';', 15, 0x226a, 1)
NAMED_CHARACTER_REFERENCE(325, 'N' _ 'e' _ 'w' _ 'L' _ 'i' _ 'n' _ 'e' _ ';', 8, 0x000a, 1)
NAMED_CHARACTER_REFERENCE(326, 'N' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd11, 2)
NAMED_CHARACTER_REFERENCE(327, 'N' _ 'o' _ 'B' _ 'r' _ 'e' _ 'a' _ 'k' _ ';', 8, 0x2060, 1)
NAMED_CHARACTER_REFERENCE(328, 'N' _ 'o' _ 'n' _ 'B' _ 'r' _ 'e' _ 'a' _ 'k' _ 'i' _ 'n' _ 'g' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 17, 0x00a0, 1)
NAMED_CHARACTER_REFERENCE(329, 'N' _ 'o' _ 'p' _ 'f' _ ';', 5, 0x2115, 1)
NAMED_CHARACTER_REFERENCE(330, 'N' _ 'o' _ 't' _ ';', 4, 0x2aec, 1)
NAMED_CHARACTER_REFERENCE(331, 'N' _ 'o' _ 't' _ 'C' _ 'o' _ 'n' _ 'g' _ 'r' _ 'u' _ 'e' _ 'n' _ 't' _ ';', 13, 0x2262, 1)
NAMED_CHARACTER_REFERENCE(332, 'N' _ 'o' _ 't' _ 'C' _ 'u' _ 'p' _ 'C' _ 'a' _ 'p' _ ';', 10, 0x226d, 1)
NAMED_CHARACTER_REFERENCE(333, 'N' _ 'o' _ 't' _ 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'V' _ 'e' _ 'r' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'B' _ 'a' _ 'r' _ ';', 21, 0x2226, 1)
NAMED_CHARACTER_REFERENCE(334, 'N' _ 'o' _ 't' _ 'E' _ 'l' _ 'e' _ 'm' _ 'e' _ 'n' _ 't' _ ';', 11, 0x2209, 1)
NAMED_CHARACTER_REFERENCE(335, 'N' _ 'o' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 9, 0x2260, 1)
NAMED_CHARACTER_REFERENCE(336, 'N' _ 'o' _ 't' _ 'E' _ 'x' _ 'i' _ 's' _ 't' _ 's' _ ';', 10, 0x2204, 1)
NAMED_CHARACTER_REFERENCE(337, 'N' _ 'o' _ 't' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ ';', 11, 0x226f, 1)
NAMED_CHARACTER_REFERENCE(338, 'N' _ 'o' _ 't' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 16, 0x2271, 1)
NAMED_CHARACTER_REFERENCE(339, 'N' _ 'o' _ 't' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'L' _ 'e' _ 's' _ 's' _ ';', 15, 0x2279, 1)
NAMED_CHARACTER_REFERENCE(340, 'N' _ 'o' _ 't' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 16, 0x2275, 1)
NAMED_CHARACTER_REFERENCE(341, 'N' _ 'o' _ 't' _ 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 16, 0x22ea, 1)
NAMED_CHARACTER_REFERENCE(342, 'N' _ 'o' _ 't' _ 'L' _ 'e' _ 'f' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 21, 0x22ec, 1)
NAMED_CHARACTER_REFERENCE(343, 'N' _ 'o' _ 't' _ 'L' _ 'e' _ 's' _ 's' _ ';', 8, 0x226e, 1)
NAMED_CHARACTER_REFERENCE(344, 'N' _ 'o' _ 't' _ 'L' _ 'e' _ 's' _ 's' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 13, 0x2270, 1)
NAMED_CHARACTER_REFERENCE(345, 'N' _ 'o' _ 't' _ 'L' _ 'e' _ 's' _ 's' _ 'G' _ 'r' _ 'e' _ 'a' _ 't' _ 'e' _ 'r' _ ';', 15, 0x2278, 1)
NAMED_CHARACTER_REFERENCE(346, 'N' _ 'o' _ 't' _ 'L' _ 'e' _ 's' _ 's' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 13, 0x2274, 1)
NAMED_CHARACTER_REFERENCE(347, 'N' _ 'o' _ 't' _ 'P' _ 'r' _ 'e' _ 'c' _ 'e' _ 'd' _ 'e' _ 's' _ ';', 12, 0x2280, 1)
NAMED_CHARACTER_REFERENCE(348, 'N' _ 'o' _ 't' _ 'P' _ 'r' _ 'e' _ 'c' _ 'e' _ 'd' _ 'e' _ 's' _ 'S' _ 'l' _ 'a' _ 'n' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 22, 0x22e0, 1)
NAMED_CHARACTER_REFERENCE(349, 'N' _ 'o' _ 't' _ 'R' _ 'e' _ 'v' _ 'e' _ 'r' _ 's' _ 'e' _ 'E' _ 'l' _ 'e' _ 'm' _ 'e' _ 'n' _ 't' _ ';', 18, 0x220c, 1)
NAMED_CHARACTER_REFERENCE(350, 'N' _ 'o' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 17, 0x22eb, 1)
NAMED_CHARACTER_REFERENCE(351, 'N' _ 'o' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 22, 0x22ed, 1)
NAMED_CHARACTER_REFERENCE(352, 'N' _ 'o' _ 't' _ 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'S' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 21, 0x22e2, 1)
NAMED_CHARACTER_REFERENCE(353, 'N' _ 'o' _ 't' _ 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'S' _ 'u' _ 'p' _ 'e' _ 'r' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 23, 0x22e3, 1)
NAMED_CHARACTER_REFERENCE(354, 'N' _ 'o' _ 't' _ 'S' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 15, 0x2288, 1)
NAMED_CHARACTER_REFERENCE(355, 'N' _ 'o' _ 't' _ 'S' _ 'u' _ 'c' _ 'c' _ 'e' _ 'e' _ 'd' _ 's' _ ';', 12, 0x2281, 1)
NAMED_CHARACTER_REFERENCE(356, 'N' _ 'o' _ 't' _ 'S' _ 'u' _ 'c' _ 'c' _ 'e' _ 'e' _ 'd' _ 's' _ 'S' _ 'l' _ 'a' _ 'n' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 22, 0x22e1, 1)
NAMED_CHARACTER_REFERENCE(357, 'N' _ 'o' _ 't' _ 'S' _ 'u' _ 'p' _ 'e' _ 'r' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 17, 0x2289, 1)
NAMED_CHARACTER_REFERENCE(358, 'N' _ 'o' _ 't' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 9, 0x2241, 1)
NAMED_CHARACTER_REFERENCE(359, 'N' _ 'o' _ 't' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 14, 0x2244, 1)
NAMED_CHARACTER_REFERENCE(360, 'N' _ 'o' _ 't' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ 'F' _ 'u' _ 'l' _ 'l' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 18, 0x2247, 1)
NAMED_CHARACTER_REFERENCE(361, 'N' _ 'o' _ 't' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 14, 0x2249, 1)
NAMED_CHARACTER_REFERENCE(362, 'N' _ 'o' _ 't' _ 'V' _ 'e' _ 'r' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'B' _ 'a' _ 'r' _ ';', 15, 0x2224, 1)
NAMED_CHARACTER_REFERENCE(363, 'N' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdca9, 2)
NAMED_CHARACTER_REFERENCE(364, 'N' _ 't' _ 'i' _ 'l' _ 'd' _ 'e', 6, 0x00d1, 1)
NAMED_CHARACTER_REFERENCE(365, 'N' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x00d1, 1)
NAMED_CHARACTER_REFERENCE(366, 'N' _ 'u' _ ';', 3, 0x039d, 1)
NAMED_CHARACTER_REFERENCE(367, 'O' _ 'E' _ 'l' _ 'i' _ 'g' _ ';', 6, 0x0152, 1)
NAMED_CHARACTER_REFERENCE(368, 'O' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00d3, 1)
NAMED_CHARACTER_REFERENCE(369, 'O' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00d3, 1)
NAMED_CHARACTER_REFERENCE(370, 'O' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00d4, 1)
NAMED_CHARACTER_REFERENCE(371, 'O' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00d4, 1)
NAMED_CHARACTER_REFERENCE(372, 'O' _ 'c' _ 'y' _ ';', 4, 0x041e, 1)
NAMED_CHARACTER_REFERENCE(373, 'O' _ 'd' _ 'b' _ 'l' _ 'a' _ 'c' _ ';', 7, 0x0150, 1)
NAMED_CHARACTER_REFERENCE(374, 'O' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd12, 2)
NAMED_CHARACTER_REFERENCE(375, 'O' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00d2, 1)
NAMED_CHARACTER_REFERENCE(376, 'O' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00d2, 1)
NAMED_CHARACTER_REFERENCE(377, 'O' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x014c, 1)
NAMED_CHARACTER_REFERENCE(378, 'O' _ 'm' _ 'e' _ 'g' _ 'a' _ ';', 6, 0x03a9, 1)
NAMED_CHARACTER_REFERENCE(379, 'O' _ 'm' _ 'i' _ 'c' _ 'r' _ 'o' _ 'n' _ ';', 8, 0x039f, 1)
NAMED_CHARACTER_REFERENCE(380, 'O' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd46, 2)
NAMED_CHARACTER_REFERENCE(381, 'O' _ 'p' _ 'e' _ 'n' _ 'C' _ 'u' _ 'r' _ 'l' _ 'y' _ 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'Q' _ 'u' _ 'o' _ 't' _ 'e' _ ';', 21, 0x201c, 1)
NAMED_CHARACTER_REFERENCE(382, 'O' _ 'p' _ 'e' _ 'n' _ 'C' _ 'u' _ 'r' _ 'l' _ 'y' _ 'Q' _ 'u' _ 'o' _ 't' _ 'e' _ ';', 15, 0x2018, 1)
NAMED_CHARACTER_REFERENCE(383, 'O' _ 'r' _ ';', 3, 0x2a54, 1)
NAMED_CHARACTER_REFERENCE(384, 'O' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcaa, 2)
NAMED_CHARACTER_REFERENCE(385, 'O' _ 's' _ 'l' _ 'a' _ 's' _ 'h', 6, 0x00d8, 1)
NAMED_CHARACTER_REFERENCE(386, 'O' _ 's' _ 'l' _ 'a' _ 's' _ 'h' _ ';', 7, 0x00d8, 1)
NAMED_CHARACTER_REFERENCE(387, 'O' _ 't' _ 'i' _ 'l' _ 'd' _ 'e', 6, 0x00d5, 1)
NAMED_CHARACTER_REFERENCE(388, 'O' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x00d5, 1)
NAMED_CHARACTER_REFERENCE(389, 'O' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 7, 0x2a37, 1)
NAMED_CHARACTER_REFERENCE(390, 'O' _ 'u' _ 'm' _ 'l', 4, 0x00d6, 1)
NAMED_CHARACTER_REFERENCE(391, 'O' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00d6, 1)
NAMED_CHARACTER_REFERENCE(392, 'O' _ 'v' _ 'e' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 8, 0x203e, 1)
NAMED_CHARACTER_REFERENCE(393, 'O' _ 'v' _ 'e' _ 'r' _ 'B' _ 'r' _ 'a' _ 'c' _ 'e' _ ';', 10, 0x23de, 1)
NAMED_CHARACTER_REFERENCE(394, 'O' _ 'v' _ 'e' _ 'r' _ 'B' _ 'r' _ 'a' _ 'c' _ 'k' _ 'e' _ 't' _ ';', 12, 0x23b4, 1)
NAMED_CHARACTER_REFERENCE(395, 'O' _ 'v' _ 'e' _ 'r' _ 'P' _ 'a' _ 'r' _ 'e' _ 'n' _ 't' _ 'h' _ 'e' _ 's' _ 'i' _ 's' _ ';', 16, 0x23dc, 1)
NAMED_CHARACTER_REFERENCE(396, 'P' _ 'a' _ 'r' _ 't' _ 'i' _ 'a' _ 'l' _ 'D' _ ';', 9, 0x2202, 1)
NAMED_CHARACTER_REFERENCE(397, 'P' _ 'c' _ 'y' _ ';', 4, 0x041f, 1)
NAMED_CHARACTER_REFERENCE(398, 'P' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd13, 2)
NAMED_CHARACTER_REFERENCE(399, 'P' _ 'h' _ 'i' _ ';', 4, 0x03a6, 1)
NAMED_CHARACTER_REFERENCE(400, 'P' _ 'i' _ ';', 3, 0x03a0, 1)
NAMED_CHARACTER_REFERENCE(401, 'P' _ 'l' _ 'u' _ 's' _ 'M' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 10, 0x00b1, 1)
NAMED_CHARACTER_REFERENCE(402, 'P' _ 'o' _ 'i' _ 'n' _ 'c' _ 'a' _ 'r' _ 'e' _ 'p' _ 'l' _ 'a' _ 'n' _ 'e' _ ';', 14, 0x210c, 1)
NAMED_CHARACTER_REFERENCE(403, 'P' _ 'o' _ 'p' _ 'f' _ ';', 5, 0x2119, 1)
NAMED_CHARACTER_REFERENCE(404, 'P' _ 'r' _ ';', 3, 0x2abb, 1)
NAMED_CHARACTER_REFERENCE(405, 'P' _ 'r' _ 'e' _ 'c' _ 'e' _ 'd' _ 'e' _ 's' _ ';', 9, 0x227a, 1)
NAMED_CHARACTER_REFERENCE(406, 'P' _ 'r' _ 'e' _ 'c' _ 'e' _ 'd' _ 'e' _ 's' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 14, 0x2aaf, 1)
NAMED_CHARACTER_REFERENCE(407, 'P' _ 'r' _ 'e' _ 'c' _ 'e' _ 'd' _ 'e' _ 's' _ 'S' _ 'l' _ 'a' _ 'n' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 19, 0x227c, 1)
NAMED_CHARACTER_REFERENCE(408, 'P' _ 'r' _ 'e' _ 'c' _ 'e' _ 'd' _ 'e' _ 's' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 14, 0x227e, 1)
NAMED_CHARACTER_REFERENCE(409, 'P' _ 'r' _ 'i' _ 'm' _ 'e' _ ';', 6, 0x2033, 1)
NAMED_CHARACTER_REFERENCE(410, 'P' _ 'r' _ 'o' _ 'd' _ 'u' _ 'c' _ 't' _ ';', 8, 0x220f, 1)
NAMED_CHARACTER_REFERENCE(411, 'P' _ 'r' _ 'o' _ 'p' _ 'o' _ 'r' _ 't' _ 'i' _ 'o' _ 'n' _ ';', 11, 0x2237, 1)
NAMED_CHARACTER_REFERENCE(412, 'P' _ 'r' _ 'o' _ 'p' _ 'o' _ 'r' _ 't' _ 'i' _ 'o' _ 'n' _ 'a' _ 'l' _ ';', 13, 0x221d, 1)
NAMED_CHARACTER_REFERENCE(413, 'P' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcab, 2)
NAMED_CHARACTER_REFERENCE(414, 'P' _ 's' _ 'i' _ ';', 4, 0x03a8, 1)
NAMED_CHARACTER_REFERENCE(415, 'Q' _ 'U' _ 'O' _ 'T', 4, 0x0022, 1)
NAMED_CHARACTER_REFERENCE(416, 'Q' _ 'U' _ 'O' _ 'T' _ ';', 5, 0x0022, 1)
NAMED_CHARACTER_REFERENCE(417, 'Q' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd14, 2)
NAMED_CHARACTER_REFERENCE(418, 'Q' _ 'o' _ 'p' _ 'f' _ ';', 5, 0x211a, 1)
NAMED_CHARACTER_REFERENCE(419, 'Q' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcac, 2)
NAMED_CHARACTER_REFERENCE(420, 'R' _ 'B' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2910, 1)
NAMED_CHARACTER_REFERENCE(421, 'R' _ 'E' _ 'G', 3, 0x00ae, 1)
NAMED_CHARACTER_REFERENCE(422, 'R' _ 'E' _ 'G' _ ';', 4, 0x00ae, 1)
NAMED_CHARACTER_REFERENCE(423, 'R' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0154, 1)
NAMED_CHARACTER_REFERENCE(424, 'R' _ 'a' _ 'n' _ 'g' _ ';', 5, 0x27eb, 1)
NAMED_CHARACTER_REFERENCE(425, 'R' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x21a0, 1)
NAMED_CHARACTER_REFERENCE(426, 'R' _ 'a' _ 'r' _ 'r' _ 't' _ 'l' _ ';', 7, 0x2916, 1)
NAMED_CHARACTER_REFERENCE(427, 'R' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0158, 1)
NAMED_CHARACTER_REFERENCE(428, 'R' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0156, 1)
NAMED_CHARACTER_REFERENCE(429, 'R' _ 'c' _ 'y' _ ';', 4, 0x0420, 1)
NAMED_CHARACTER_REFERENCE(430, 'R' _ 'e' _ ';', 3, 0x211c, 1)
NAMED_CHARACTER_REFERENCE(431, 'R' _ 'e' _ 'v' _ 'e' _ 'r' _ 's' _ 'e' _ 'E' _ 'l' _ 'e' _ 'm' _ 'e' _ 'n' _ 't' _ ';', 15, 0x220b, 1)
NAMED_CHARACTER_REFERENCE(432, 'R' _ 'e' _ 'v' _ 'e' _ 'r' _ 's' _ 'e' _ 'E' _ 'q' _ 'u' _ 'i' _ 'l' _ 'i' _ 'b' _ 'r' _ 'i' _ 'u' _ 'm' _ ';', 19, 0x21cb, 1)
NAMED_CHARACTER_REFERENCE(433, 'R' _ 'e' _ 'v' _ 'e' _ 'r' _ 's' _ 'e' _ 'U' _ 'p' _ 'E' _ 'q' _ 'u' _ 'i' _ 'l' _ 'i' _ 'b' _ 'r' _ 'i' _ 'u' _ 'm' _ ';', 21, 0x296f, 1)
NAMED_CHARACTER_REFERENCE(434, 'R' _ 'f' _ 'r' _ ';', 4, 0x211c, 1)
NAMED_CHARACTER_REFERENCE(435, 'R' _ 'h' _ 'o' _ ';', 4, 0x03a1, 1)
NAMED_CHARACTER_REFERENCE(436, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'n' _ 'g' _ 'l' _ 'e' _ 'B' _ 'r' _ 'a' _ 'c' _ 'k' _ 'e' _ 't' _ ';', 18, 0x27e9, 1)
NAMED_CHARACTER_REFERENCE(437, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 11, 0x2192, 1)
NAMED_CHARACTER_REFERENCE(438, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'B' _ 'a' _ 'r' _ ';', 14, 0x21e5, 1)
NAMED_CHARACTER_REFERENCE(439, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 20, 0x21c4, 1)
NAMED_CHARACTER_REFERENCE(440, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'C' _ 'e' _ 'i' _ 'l' _ 'i' _ 'n' _ 'g' _ ';', 13, 0x2309, 1)
NAMED_CHARACTER_REFERENCE(441, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'D' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'B' _ 'r' _ 'a' _ 'c' _ 'k' _ 'e' _ 't' _ ';', 19, 0x27e7, 1)
NAMED_CHARACTER_REFERENCE(442, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'D' _ 'o' _ 'w' _ 'n' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 19, 0x295d, 1)
NAMED_CHARACTER_REFERENCE(443, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'D' _ 'o' _ 'w' _ 'n' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 16, 0x21c2, 1)
NAMED_CHARACTER_REFERENCE(444, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'D' _ 'o' _ 'w' _ 'n' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 19, 0x2955, 1)
NAMED_CHARACTER_REFERENCE(445, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'F' _ 'l' _ 'o' _ 'o' _ 'r' _ ';', 11, 0x230b, 1)
NAMED_CHARACTER_REFERENCE(446, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'e' _ 'e' _ ';', 9, 0x22a2, 1)
NAMED_CHARACTER_REFERENCE(447, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'e' _ 'e' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 14, 0x21a6, 1)
NAMED_CHARACTER_REFERENCE(448, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 15, 0x295b, 1)
NAMED_CHARACTER_REFERENCE(449, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 14, 0x22b3, 1)
NAMED_CHARACTER_REFERENCE(450, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'B' _ 'a' _ 'r' _ ';', 17, 0x29d0, 1)
NAMED_CHARACTER_REFERENCE(451, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'T' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 19, 0x22b5, 1)
NAMED_CHARACTER_REFERENCE(452, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'U' _ 'p' _ 'D' _ 'o' _ 'w' _ 'n' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 18, 0x294f, 1)
NAMED_CHARACTER_REFERENCE(453, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'U' _ 'p' _ 'T' _ 'e' _ 'e' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 17, 0x295c, 1)
NAMED_CHARACTER_REFERENCE(454, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'U' _ 'p' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 14, 0x21be, 1)
NAMED_CHARACTER_REFERENCE(455, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'U' _ 'p' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 17, 0x2954, 1)
NAMED_CHARACTER_REFERENCE(456, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ ';', 12, 0x21c0, 1)
NAMED_CHARACTER_REFERENCE(457, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'V' _ 'e' _ 'c' _ 't' _ 'o' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 15, 0x2953, 1)
NAMED_CHARACTER_REFERENCE(458, 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 11, 0x21d2, 1)
NAMED_CHARACTER_REFERENCE(459, 'R' _ 'o' _ 'p' _ 'f' _ ';', 5, 0x211d, 1)
NAMED_CHARACTER_REFERENCE(460, 'R' _ 'o' _ 'u' _ 'n' _ 'd' _ 'I' _ 'm' _ 'p' _ 'l' _ 'i' _ 'e' _ 's' _ ';', 13, 0x2970, 1)
NAMED_CHARACTER_REFERENCE(461, 'R' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 12, 0x21db, 1)
NAMED_CHARACTER_REFERENCE(462, 'R' _ 's' _ 'c' _ 'r' _ ';', 5, 0x211b, 1)
NAMED_CHARACTER_REFERENCE(463, 'R' _ 's' _ 'h' _ ';', 4, 0x21b1, 1)
NAMED_CHARACTER_REFERENCE(464, 'R' _ 'u' _ 'l' _ 'e' _ 'D' _ 'e' _ 'l' _ 'a' _ 'y' _ 'e' _ 'd' _ ';', 12, 0x29f4, 1)
NAMED_CHARACTER_REFERENCE(465, 'S' _ 'H' _ 'C' _ 'H' _ 'c' _ 'y' _ ';', 7, 0x0429, 1)
NAMED_CHARACTER_REFERENCE(466, 'S' _ 'H' _ 'c' _ 'y' _ ';', 5, 0x0428, 1)
NAMED_CHARACTER_REFERENCE(467, 'S' _ 'O' _ 'F' _ 'T' _ 'c' _ 'y' _ ';', 7, 0x042c, 1)
NAMED_CHARACTER_REFERENCE(468, 'S' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x015a, 1)
NAMED_CHARACTER_REFERENCE(469, 'S' _ 'c' _ ';', 3, 0x2abc, 1)
NAMED_CHARACTER_REFERENCE(470, 'S' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0160, 1)
NAMED_CHARACTER_REFERENCE(471, 'S' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x015e, 1)
NAMED_CHARACTER_REFERENCE(472, 'S' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x015c, 1)
NAMED_CHARACTER_REFERENCE(473, 'S' _ 'c' _ 'y' _ ';', 4, 0x0421, 1)
NAMED_CHARACTER_REFERENCE(474, 'S' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd16, 2)
NAMED_CHARACTER_REFERENCE(475, 'S' _ 'h' _ 'o' _ 'r' _ 't' _ 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x2193, 1)
NAMED_CHARACTER_REFERENCE(476, 'S' _ 'h' _ 'o' _ 'r' _ 't' _ 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x2190, 1)
NAMED_CHARACTER_REFERENCE(477, 'S' _ 'h' _ 'o' _ 'r' _ 't' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x2192, 1)
NAMED_CHARACTER_REFERENCE(478, 'S' _ 'h' _ 'o' _ 'r' _ 't' _ 'U' _ 'p' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 13, 0x2191, 1)
NAMED_CHARACTER_REFERENCE(479, 'S' _ 'i' _ 'g' _ 'm' _ 'a' _ ';', 6, 0x03a3, 1)
NAMED_CHARACTER_REFERENCE(480, 'S' _ 'm' _ 'a' _ 'l' _ 'l' _ 'C' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ ';', 12, 0x2218, 1)
NAMED_CHARACTER_REFERENCE(481, 'S' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd4a, 2)
NAMED_CHARACTER_REFERENCE(482, 'S' _ 'q' _ 'r' _ 't' _ ';', 5, 0x221a, 1)
NAMED_CHARACTER_REFERENCE(483, 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 7, 0x25a1, 1)
NAMED_CHARACTER_REFERENCE(484, 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'I' _ 'n' _ 't' _ 'e' _ 'r' _ 's' _ 'e' _ 'c' _ 't' _ 'i' _ 'o' _ 'n' _ ';', 19, 0x2293, 1)
NAMED_CHARACTER_REFERENCE(485, 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'S' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ ';', 13, 0x228f, 1)
NAMED_CHARACTER_REFERENCE(486, 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'S' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 18, 0x2291, 1)
NAMED_CHARACTER_REFERENCE(487, 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'S' _ 'u' _ 'p' _ 'e' _ 'r' _ 's' _ 'e' _ 't' _ ';', 15, 0x2290, 1)
NAMED_CHARACTER_REFERENCE(488, 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'S' _ 'u' _ 'p' _ 'e' _ 'r' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 20, 0x2292, 1)
NAMED_CHARACTER_REFERENCE(489, 'S' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ 'U' _ 'n' _ 'i' _ 'o' _ 'n' _ ';', 12, 0x2294, 1)
NAMED_CHARACTER_REFERENCE(490, 'S' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcae, 2)
NAMED_CHARACTER_REFERENCE(491, 'S' _ 't' _ 'a' _ 'r' _ ';', 5, 0x22c6, 1)
NAMED_CHARACTER_REFERENCE(492, 'S' _ 'u' _ 'b' _ ';', 4, 0x22d0, 1)
NAMED_CHARACTER_REFERENCE(493, 'S' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ ';', 7, 0x22d0, 1)
NAMED_CHARACTER_REFERENCE(494, 'S' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 12, 0x2286, 1)
NAMED_CHARACTER_REFERENCE(495, 'S' _ 'u' _ 'c' _ 'c' _ 'e' _ 'e' _ 'd' _ 's' _ ';', 9, 0x227b, 1)
NAMED_CHARACTER_REFERENCE(496, 'S' _ 'u' _ 'c' _ 'c' _ 'e' _ 'e' _ 'd' _ 's' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 14, 0x2ab0, 1)
NAMED_CHARACTER_REFERENCE(497, 'S' _ 'u' _ 'c' _ 'c' _ 'e' _ 'e' _ 'd' _ 's' _ 'S' _ 'l' _ 'a' _ 'n' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 19, 0x227d, 1)
NAMED_CHARACTER_REFERENCE(498, 'S' _ 'u' _ 'c' _ 'c' _ 'e' _ 'e' _ 'd' _ 's' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 14, 0x227f, 1)
NAMED_CHARACTER_REFERENCE(499, 'S' _ 'u' _ 'c' _ 'h' _ 'T' _ 'h' _ 'a' _ 't' _ ';', 9, 0x220b, 1)
NAMED_CHARACTER_REFERENCE(500, 'S' _ 'u' _ 'm' _ ';', 4, 0x2211, 1)
NAMED_CHARACTER_REFERENCE(501, 'S' _ 'u' _ 'p' _ ';', 4, 0x22d1, 1)
NAMED_CHARACTER_REFERENCE(502, 'S' _ 'u' _ 'p' _ 'e' _ 'r' _ 's' _ 'e' _ 't' _ ';', 9, 0x2283, 1)
NAMED_CHARACTER_REFERENCE(503, 'S' _ 'u' _ 'p' _ 'e' _ 'r' _ 's' _ 'e' _ 't' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 14, 0x2287, 1)
NAMED_CHARACTER_REFERENCE(504, 'S' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ ';', 7, 0x22d1, 1)
NAMED_CHARACTER_REFERENCE(505, 'T' _ 'H' _ 'O' _ 'R' _ 'N', 5, 0x00de, 1)
NAMED_CHARACTER_REFERENCE(506, 'T' _ 'H' _ 'O' _ 'R' _ 'N' _ ';', 6, 0x00de, 1)
NAMED_CHARACTER_REFERENCE(507, 'T' _ 'R' _ 'A' _ 'D' _ 'E' _ ';', 6, 0x2122, 1)
NAMED_CHARACTER_REFERENCE(508, 'T' _ 'S' _ 'H' _ 'c' _ 'y' _ ';', 6, 0x040b, 1)
NAMED_CHARACTER_REFERENCE(509, 'T' _ 'S' _ 'c' _ 'y' _ ';', 5, 0x0426, 1)
NAMED_CHARACTER_REFERENCE(510, 'T' _ 'a' _ 'b' _ ';', 4, 0x0009, 1)
NAMED_CHARACTER_REFERENCE(511, 'T' _ 'a' _ 'u' _ ';', 4, 0x03a4, 1)
NAMED_CHARACTER_REFERENCE(512, 'T' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0164, 1)
NAMED_CHARACTER_REFERENCE(513, 'T' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0162, 1)
NAMED_CHARACTER_REFERENCE(514, 'T' _ 'c' _ 'y' _ ';', 4, 0x0422, 1)
NAMED_CHARACTER_REFERENCE(515, 'T' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd17, 2)
NAMED_CHARACTER_REFERENCE(516, 'T' _ 'h' _ 'e' _ 'r' _ 'e' _ 'f' _ 'o' _ 'r' _ 'e' _ ';', 10, 0x2234, 1)
NAMED_CHARACTER_REFERENCE(517, 'T' _ 'h' _ 'e' _ 't' _ 'a' _ ';', 6, 0x0398, 1)
NAMED_CHARACTER_REFERENCE(518, 'T' _ 'h' _ 'i' _ 'n' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 10, 0x2009, 1)
NAMED_CHARACTER_REFERENCE(519, 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 6, 0x223c, 1)
NAMED_CHARACTER_REFERENCE(520, 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 11, 0x2243, 1)
NAMED_CHARACTER_REFERENCE(521, 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ 'F' _ 'u' _ 'l' _ 'l' _ 'E' _ 'q' _ 'u' _ 'a' _ 'l' _ ';', 15, 0x2245, 1)
NAMED_CHARACTER_REFERENCE(522, 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 11, 0x2248, 1)
NAMED_CHARACTER_REFERENCE(523, 'T' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd4b, 2)
NAMED_CHARACTER_REFERENCE(524, 'T' _ 'r' _ 'i' _ 'p' _ 'l' _ 'e' _ 'D' _ 'o' _ 't' _ ';', 10, 0x20db, 1)
NAMED_CHARACTER_REFERENCE(525, 'T' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcaf, 2)
NAMED_CHARACTER_REFERENCE(526, 'T' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0166, 1)
NAMED_CHARACTER_REFERENCE(527, 'U' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00da, 1)
NAMED_CHARACTER_REFERENCE(528, 'U' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00da, 1)
NAMED_CHARACTER_REFERENCE(529, 'U' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x219f, 1)
NAMED_CHARACTER_REFERENCE(530, 'U' _ 'a' _ 'r' _ 'r' _ 'o' _ 'c' _ 'i' _ 'r' _ ';', 9, 0x2949, 1)
NAMED_CHARACTER_REFERENCE(531, 'U' _ 'b' _ 'r' _ 'c' _ 'y' _ ';', 6, 0x040e, 1)
NAMED_CHARACTER_REFERENCE(532, 'U' _ 'b' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 7, 0x016c, 1)
NAMED_CHARACTER_REFERENCE(533, 'U' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00db, 1)
NAMED_CHARACTER_REFERENCE(534, 'U' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00db, 1)
NAMED_CHARACTER_REFERENCE(535, 'U' _ 'c' _ 'y' _ ';', 4, 0x0423, 1)
NAMED_CHARACTER_REFERENCE(536, 'U' _ 'd' _ 'b' _ 'l' _ 'a' _ 'c' _ ';', 7, 0x0170, 1)
NAMED_CHARACTER_REFERENCE(537, 'U' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd18, 2)
NAMED_CHARACTER_REFERENCE(538, 'U' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00d9, 1)
NAMED_CHARACTER_REFERENCE(539, 'U' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00d9, 1)
NAMED_CHARACTER_REFERENCE(540, 'U' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x016a, 1)
NAMED_CHARACTER_REFERENCE(541, 'U' _ 'n' _ 'd' _ 'e' _ 'r' _ 'B' _ 'a' _ 'r' _ ';', 9, 0x005f, 1)
NAMED_CHARACTER_REFERENCE(542, 'U' _ 'n' _ 'd' _ 'e' _ 'r' _ 'B' _ 'r' _ 'a' _ 'c' _ 'e' _ ';', 11, 0x23df, 1)
NAMED_CHARACTER_REFERENCE(543, 'U' _ 'n' _ 'd' _ 'e' _ 'r' _ 'B' _ 'r' _ 'a' _ 'c' _ 'k' _ 'e' _ 't' _ ';', 13, 0x23b5, 1)
NAMED_CHARACTER_REFERENCE(544, 'U' _ 'n' _ 'd' _ 'e' _ 'r' _ 'P' _ 'a' _ 'r' _ 'e' _ 'n' _ 't' _ 'h' _ 'e' _ 's' _ 'i' _ 's' _ ';', 17, 0x23dd, 1)
NAMED_CHARACTER_REFERENCE(545, 'U' _ 'n' _ 'i' _ 'o' _ 'n' _ ';', 6, 0x22c3, 1)
NAMED_CHARACTER_REFERENCE(546, 'U' _ 'n' _ 'i' _ 'o' _ 'n' _ 'P' _ 'l' _ 'u' _ 's' _ ';', 10, 0x228e, 1)
NAMED_CHARACTER_REFERENCE(547, 'U' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x0172, 1)
NAMED_CHARACTER_REFERENCE(548, 'U' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd4c, 2)
NAMED_CHARACTER_REFERENCE(549, 'U' _ 'p' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x2191, 1)
NAMED_CHARACTER_REFERENCE(550, 'U' _ 'p' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'B' _ 'a' _ 'r' _ ';', 11, 0x2912, 1)
NAMED_CHARACTER_REFERENCE(551, 'U' _ 'p' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 17, 0x21c5, 1)
NAMED_CHARACTER_REFERENCE(552, 'U' _ 'p' _ 'D' _ 'o' _ 'w' _ 'n' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 12, 0x2195, 1)
NAMED_CHARACTER_REFERENCE(553, 'U' _ 'p' _ 'E' _ 'q' _ 'u' _ 'i' _ 'l' _ 'i' _ 'b' _ 'r' _ 'i' _ 'u' _ 'm' _ ';', 14, 0x296e, 1)
NAMED_CHARACTER_REFERENCE(554, 'U' _ 'p' _ 'T' _ 'e' _ 'e' _ ';', 6, 0x22a5, 1)
NAMED_CHARACTER_REFERENCE(555, 'U' _ 'p' _ 'T' _ 'e' _ 'e' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 11, 0x21a5, 1)
NAMED_CHARACTER_REFERENCE(556, 'U' _ 'p' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x21d1, 1)
NAMED_CHARACTER_REFERENCE(557, 'U' _ 'p' _ 'd' _ 'o' _ 'w' _ 'n' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 12, 0x21d5, 1)
NAMED_CHARACTER_REFERENCE(558, 'U' _ 'p' _ 'p' _ 'e' _ 'r' _ 'L' _ 'e' _ 'f' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x2196, 1)
NAMED_CHARACTER_REFERENCE(559, 'U' _ 'p' _ 'p' _ 'e' _ 'r' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'A' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x2197, 1)
NAMED_CHARACTER_REFERENCE(560, 'U' _ 'p' _ 's' _ 'i' _ ';', 5, 0x03d2, 1)
NAMED_CHARACTER_REFERENCE(561, 'U' _ 'p' _ 's' _ 'i' _ 'l' _ 'o' _ 'n' _ ';', 8, 0x03a5, 1)
NAMED_CHARACTER_REFERENCE(562, 'U' _ 'r' _ 'i' _ 'n' _ 'g' _ ';', 6, 0x016e, 1)
NAMED_CHARACTER_REFERENCE(563, 'U' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb0, 2)
NAMED_CHARACTER_REFERENCE(564, 'U' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x0168, 1)
NAMED_CHARACTER_REFERENCE(565, 'U' _ 'u' _ 'm' _ 'l', 4, 0x00dc, 1)
NAMED_CHARACTER_REFERENCE(566, 'U' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00dc, 1)
NAMED_CHARACTER_REFERENCE(567, 'V' _ 'D' _ 'a' _ 's' _ 'h' _ ';', 6, 0x22ab, 1)
NAMED_CHARACTER_REFERENCE(568, 'V' _ 'b' _ 'a' _ 'r' _ ';', 5, 0x2aeb, 1)
NAMED_CHARACTER_REFERENCE(569, 'V' _ 'c' _ 'y' _ ';', 4, 0x0412, 1)
NAMED_CHARACTER_REFERENCE(570, 'V' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 6, 0x22a9, 1)
NAMED_CHARACTER_REFERENCE(571, 'V' _ 'd' _ 'a' _ 's' _ 'h' _ 'l' _ ';', 7, 0x2ae6, 1)
NAMED_CHARACTER_REFERENCE(572, 'V' _ 'e' _ 'e' _ ';', 4, 0x22c1, 1)
NAMED_CHARACTER_REFERENCE(573, 'V' _ 'e' _ 'r' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x2016, 1)
NAMED_CHARACTER_REFERENCE(574, 'V' _ 'e' _ 'r' _ 't' _ ';', 5, 0x2016, 1)
NAMED_CHARACTER_REFERENCE(575, 'V' _ 'e' _ 'r' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'B' _ 'a' _ 'r' _ ';', 12, 0x2223, 1)
NAMED_CHARACTER_REFERENCE(576, 'V' _ 'e' _ 'r' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'L' _ 'i' _ 'n' _ 'e' _ ';', 13, 0x007c, 1)
NAMED_CHARACTER_REFERENCE(577, 'V' _ 'e' _ 'r' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'S' _ 'e' _ 'p' _ 'a' _ 'r' _ 'a' _ 't' _ 'o' _ 'r' _ ';', 18, 0x2758, 1)
NAMED_CHARACTER_REFERENCE(578, 'V' _ 'e' _ 'r' _ 't' _ 'i' _ 'c' _ 'a' _ 'l' _ 'T' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 14, 0x2240, 1)
NAMED_CHARACTER_REFERENCE(579, 'V' _ 'e' _ 'r' _ 'y' _ 'T' _ 'h' _ 'i' _ 'n' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 14, 0x200a, 1)
NAMED_CHARACTER_REFERENCE(580, 'V' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd19, 2)
NAMED_CHARACTER_REFERENCE(581, 'V' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd4d, 2)
NAMED_CHARACTER_REFERENCE(582, 'V' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb1, 2)
NAMED_CHARACTER_REFERENCE(583, 'V' _ 'v' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 7, 0x22aa, 1)
NAMED_CHARACTER_REFERENCE(584, 'W' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0174, 1)
NAMED_CHARACTER_REFERENCE(585, 'W' _ 'e' _ 'd' _ 'g' _ 'e' _ ';', 6, 0x22c0, 1)
NAMED_CHARACTER_REFERENCE(586, 'W' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd1a, 2)
NAMED_CHARACTER_REFERENCE(587, 'W' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd4e, 2)
NAMED_CHARACTER_REFERENCE(588, 'W' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb2, 2)
NAMED_CHARACTER_REFERENCE(589, 'X' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd1b, 2)
NAMED_CHARACTER_REFERENCE(590, 'X' _ 'i' _ ';', 3, 0x039e, 1)
NAMED_CHARACTER_REFERENCE(591, 'X' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd4f, 2)
NAMED_CHARACTER_REFERENCE(592, 'X' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb3, 2)
NAMED_CHARACTER_REFERENCE(593, 'Y' _ 'A' _ 'c' _ 'y' _ ';', 5, 0x042f, 1)
NAMED_CHARACTER_REFERENCE(594, 'Y' _ 'I' _ 'c' _ 'y' _ ';', 5, 0x0407, 1)
NAMED_CHARACTER_REFERENCE(595, 'Y' _ 'U' _ 'c' _ 'y' _ ';', 5, 0x042e, 1)
NAMED_CHARACTER_REFERENCE(596, 'Y' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00dd, 1)
NAMED_CHARACTER_REFERENCE(597, 'Y' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00dd, 1)
NAMED_CHARACTER_REFERENCE(598, 'Y' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0176, 1)
NAMED_CHARACTER_REFERENCE(599, 'Y' _ 'c' _ 'y' _ ';', 4, 0x042b, 1)
NAMED_CHARACTER_REFERENCE(600, 'Y' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd1c, 2)
NAMED_CHARACTER_REFERENCE(601, 'Y' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd50, 2)
NAMED_CHARACTER_REFERENCE(602, 'Y' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb4, 2)
NAMED_CHARACTER_REFERENCE(603, 'Y' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x0178, 1)
NAMED_CHARACTER_REFERENCE(604, 'Z' _ 'H' _ 'c' _ 'y' _ ';', 5, 0x0416, 1)
NAMED_CHARACTER_REFERENCE(605, 'Z' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0179, 1)
NAMED_CHARACTER_REFERENCE(606, 'Z' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x017d, 1)
NAMED_CHARACTER_REFERENCE(607, 'Z' _ 'c' _ 'y' _ ';', 4, 0x0417, 1)
NAMED_CHARACTER_REFERENCE(608, 'Z' _ 'd' _ 'o' _ 't' _ ';', 5, 0x017b, 1)
NAMED_CHARACTER_REFERENCE(609, 'Z' _ 'e' _ 'r' _ 'o' _ 'W' _ 'i' _ 'd' _ 't' _ 'h' _ 'S' _ 'p' _ 'a' _ 'c' _ 'e' _ ';', 15, 0x200b, 1)
NAMED_CHARACTER_REFERENCE(610, 'Z' _ 'e' _ 't' _ 'a' _ ';', 5, 0x0396, 1)
NAMED_CHARACTER_REFERENCE(611, 'Z' _ 'f' _ 'r' _ ';', 4, 0x2128, 1)
NAMED_CHARACTER_REFERENCE(612, 'Z' _ 'o' _ 'p' _ 'f' _ ';', 5, 0x2124, 1)
NAMED_CHARACTER_REFERENCE(613, 'Z' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb5, 2)
NAMED_CHARACTER_REFERENCE(614, 'a' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00e1, 1)
NAMED_CHARACTER_REFERENCE(615, 'a' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00e1, 1)
NAMED_CHARACTER_REFERENCE(616, 'a' _ 'b' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 7, 0x0103, 1)
NAMED_CHARACTER_REFERENCE(617, 'a' _ 'c' _ ';', 3, 0x223e, 1)
NAMED_CHARACTER_REFERENCE(618, 'a' _ 'c' _ 'd' _ ';', 4, 0x223f, 1)
NAMED_CHARACTER_REFERENCE(619, 'a' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00e2, 1)
NAMED_CHARACTER_REFERENCE(620, 'a' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00e2, 1)
NAMED_CHARACTER_REFERENCE(621, 'a' _ 'c' _ 'u' _ 't' _ 'e', 5, 0x00b4, 1)
NAMED_CHARACTER_REFERENCE(622, 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 6, 0x00b4, 1)
NAMED_CHARACTER_REFERENCE(623, 'a' _ 'c' _ 'y' _ ';', 4, 0x0430, 1)
NAMED_CHARACTER_REFERENCE(624, 'a' _ 'e' _ 'l' _ 'i' _ 'g', 5, 0x00e6, 1)
NAMED_CHARACTER_REFERENCE(625, 'a' _ 'e' _ 'l' _ 'i' _ 'g' _ ';', 6, 0x00e6, 1)
NAMED_CHARACTER_REFERENCE(626, 'a' _ 'f' _ ';', 3, 0x2061, 1)
NAMED_CHARACTER_REFERENCE(627, 'a' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd1e, 2)
NAMED_CHARACTER_REFERENCE(628, 'a' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00e0, 1)
NAMED_CHARACTER_REFERENCE(629, 'a' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00e0, 1)
NAMED_CHARACTER_REFERENCE(630, 'a' _ 'l' _ 'e' _ 'f' _ 's' _ 'y' _ 'm' _ ';', 8, 0x2135, 1)
NAMED_CHARACTER_REFERENCE(631, 'a' _ 'l' _ 'e' _ 'p' _ 'h' _ ';', 6, 0x2135, 1)
NAMED_CHARACTER_REFERENCE(632, 'a' _ 'l' _ 'p' _ 'h' _ 'a' _ ';', 6, 0x03b1, 1)
NAMED_CHARACTER_REFERENCE(633, 'a' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x0101, 1)
NAMED_CHARACTER_REFERENCE(634, 'a' _ 'm' _ 'a' _ 'l' _ 'g' _ ';', 6, 0x2a3f, 1)
NAMED_CHARACTER_REFERENCE(635, 'a' _ 'm' _ 'p', 3, 0x0026, 1)
NAMED_CHARACTER_REFERENCE(636, 'a' _ 'm' _ 'p' _ ';', 4, 0x0026, 1)
NAMED_CHARACTER_REFERENCE(637, 'a' _ 'n' _ 'd' _ ';', 4, 0x2227, 1)
NAMED_CHARACTER_REFERENCE(638, 'a' _ 'n' _ 'd' _ 'a' _ 'n' _ 'd' _ ';', 7, 0x2a55, 1)
NAMED_CHARACTER_REFERENCE(639, 'a' _ 'n' _ 'd' _ 'd' _ ';', 5, 0x2a5c, 1)
NAMED_CHARACTER_REFERENCE(640, 'a' _ 'n' _ 'd' _ 's' _ 'l' _ 'o' _ 'p' _ 'e' _ ';', 9, 0x2a58, 1)
NAMED_CHARACTER_REFERENCE(641, 'a' _ 'n' _ 'd' _ 'v' _ ';', 5, 0x2a5a, 1)
NAMED_CHARACTER_REFERENCE(642, 'a' _ 'n' _ 'g' _ ';', 4, 0x2220, 1)
NAMED_CHARACTER_REFERENCE(643, 'a' _ 'n' _ 'g' _ 'e' _ ';', 5, 0x29a4, 1)
NAMED_CHARACTER_REFERENCE(644, 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 6, 0x2220, 1)
NAMED_CHARACTER_REFERENCE(645, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ ';', 7, 0x2221, 1)
NAMED_CHARACTER_REFERENCE(646, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'a' _ ';', 9, 0x29a8, 1)
NAMED_CHARACTER_REFERENCE(647, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'b' _ ';', 9, 0x29a9, 1)
NAMED_CHARACTER_REFERENCE(648, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'c' _ ';', 9, 0x29aa, 1)
NAMED_CHARACTER_REFERENCE(649, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'd' _ ';', 9, 0x29ab, 1)
NAMED_CHARACTER_REFERENCE(650, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'e' _ ';', 9, 0x29ac, 1)
NAMED_CHARACTER_REFERENCE(651, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'f' _ ';', 9, 0x29ad, 1)
NAMED_CHARACTER_REFERENCE(652, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'g' _ ';', 9, 0x29ae, 1)
NAMED_CHARACTER_REFERENCE(653, 'a' _ 'n' _ 'g' _ 'm' _ 's' _ 'd' _ 'a' _ 'h' _ ';', 9, 0x29af, 1)
NAMED_CHARACTER_REFERENCE(654, 'a' _ 'n' _ 'g' _ 'r' _ 't' _ ';', 6, 0x221f, 1)
NAMED_CHARACTER_REFERENCE(655, 'a' _ 'n' _ 'g' _ 'r' _ 't' _ 'v' _ 'b' _ ';', 8, 0x22be, 1)
NAMED_CHARACTER_REFERENCE(656, 'a' _ 'n' _ 'g' _ 'r' _ 't' _ 'v' _ 'b' _ 'd' _ ';', 9, 0x299d, 1)
NAMED_CHARACTER_REFERENCE(657, 'a' _ 'n' _ 'g' _ 's' _ 'p' _ 'h' _ ';', 7, 0x2222, 1)
NAMED_CHARACTER_REFERENCE(658, 'a' _ 'n' _ 'g' _ 's' _ 't' _ ';', 6, 0x00c5, 1)
NAMED_CHARACTER_REFERENCE(659, 'a' _ 'n' _ 'g' _ 'z' _ 'a' _ 'r' _ 'r' _ ';', 8, 0x237c, 1)
NAMED_CHARACTER_REFERENCE(660, 'a' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x0105, 1)
NAMED_CHARACTER_REFERENCE(661, 'a' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd52, 2)
NAMED_CHARACTER_REFERENCE(662, 'a' _ 'p' _ ';', 3, 0x2248, 1)
NAMED_CHARACTER_REFERENCE(663, 'a' _ 'p' _ 'E' _ ';', 4, 0x2a70, 1)
NAMED_CHARACTER_REFERENCE(664, 'a' _ 'p' _ 'a' _ 'c' _ 'i' _ 'r' _ ';', 7, 0x2a6f, 1)
NAMED_CHARACTER_REFERENCE(665, 'a' _ 'p' _ 'e' _ ';', 4, 0x224a, 1)
NAMED_CHARACTER_REFERENCE(666, 'a' _ 'p' _ 'i' _ 'd' _ ';', 5, 0x224b, 1)
NAMED_CHARACTER_REFERENCE(667, 'a' _ 'p' _ 'o' _ 's' _ ';', 5, 0x0027, 1)
NAMED_CHARACTER_REFERENCE(668, 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 7, 0x2248, 1)
NAMED_CHARACTER_REFERENCE(669, 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ 'e' _ 'q' _ ';', 9, 0x224a, 1)
NAMED_CHARACTER_REFERENCE(670, 'a' _ 'r' _ 'i' _ 'n' _ 'g', 5, 0x00e5, 1)
NAMED_CHARACTER_REFERENCE(671, 'a' _ 'r' _ 'i' _ 'n' _ 'g' _ ';', 6, 0x00e5, 1)
NAMED_CHARACTER_REFERENCE(672, 'a' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb6, 2)
NAMED_CHARACTER_REFERENCE(673, 'a' _ 's' _ 't' _ ';', 4, 0x002a, 1)
NAMED_CHARACTER_REFERENCE(674, 'a' _ 's' _ 'y' _ 'm' _ 'p' _ ';', 6, 0x2248, 1)
NAMED_CHARACTER_REFERENCE(675, 'a' _ 's' _ 'y' _ 'm' _ 'p' _ 'e' _ 'q' _ ';', 8, 0x224d, 1)
NAMED_CHARACTER_REFERENCE(676, 'a' _ 't' _ 'i' _ 'l' _ 'd' _ 'e', 6, 0x00e3, 1)
NAMED_CHARACTER_REFERENCE(677, 'a' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x00e3, 1)
NAMED_CHARACTER_REFERENCE(678, 'a' _ 'u' _ 'm' _ 'l', 4, 0x00e4, 1)
NAMED_CHARACTER_REFERENCE(679, 'a' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00e4, 1)
NAMED_CHARACTER_REFERENCE(680, 'a' _ 'w' _ 'c' _ 'o' _ 'n' _ 'i' _ 'n' _ 't' _ ';', 9, 0x2233, 1)
NAMED_CHARACTER_REFERENCE(681, 'a' _ 'w' _ 'i' _ 'n' _ 't' _ ';', 6, 0x2a11, 1)
NAMED_CHARACTER_REFERENCE(682, 'b' _ 'N' _ 'o' _ 't' _ ';', 5, 0x2aed, 1)
NAMED_CHARACTER_REFERENCE(683, 'b' _ 'a' _ 'c' _ 'k' _ 'c' _ 'o' _ 'n' _ 'g' _ ';', 9, 0x224c, 1)
NAMED_CHARACTER_REFERENCE(684, 'b' _ 'a' _ 'c' _ 'k' _ 'e' _ 'p' _ 's' _ 'i' _ 'l' _ 'o' _ 'n' _ ';', 12, 0x03f6, 1)
NAMED_CHARACTER_REFERENCE(685, 'b' _ 'a' _ 'c' _ 'k' _ 'p' _ 'r' _ 'i' _ 'm' _ 'e' _ ';', 10, 0x2035, 1)
NAMED_CHARACTER_REFERENCE(686, 'b' _ 'a' _ 'c' _ 'k' _ 's' _ 'i' _ 'm' _ ';', 8, 0x223d, 1)
NAMED_CHARACTER_REFERENCE(687, 'b' _ 'a' _ 'c' _ 'k' _ 's' _ 'i' _ 'm' _ 'e' _ 'q' _ ';', 10, 0x22cd, 1)
NAMED_CHARACTER_REFERENCE(688, 'b' _ 'a' _ 'r' _ 'v' _ 'e' _ 'e' _ ';', 7, 0x22bd, 1)
NAMED_CHARACTER_REFERENCE(689, 'b' _ 'a' _ 'r' _ 'w' _ 'e' _ 'd' _ ';', 7, 0x2305, 1)
NAMED_CHARACTER_REFERENCE(690, 'b' _ 'a' _ 'r' _ 'w' _ 'e' _ 'd' _ 'g' _ 'e' _ ';', 9, 0x2305, 1)
NAMED_CHARACTER_REFERENCE(691, 'b' _ 'b' _ 'r' _ 'k' _ ';', 5, 0x23b5, 1)
NAMED_CHARACTER_REFERENCE(692, 'b' _ 'b' _ 'r' _ 'k' _ 't' _ 'b' _ 'r' _ 'k' _ ';', 9, 0x23b6, 1)
NAMED_CHARACTER_REFERENCE(693, 'b' _ 'c' _ 'o' _ 'n' _ 'g' _ ';', 6, 0x224c, 1)
NAMED_CHARACTER_REFERENCE(694, 'b' _ 'c' _ 'y' _ ';', 4, 0x0431, 1)
NAMED_CHARACTER_REFERENCE(695, 'b' _ 'd' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x201e, 1)
NAMED_CHARACTER_REFERENCE(696, 'b' _ 'e' _ 'c' _ 'a' _ 'u' _ 's' _ ';', 7, 0x2235, 1)
NAMED_CHARACTER_REFERENCE(697, 'b' _ 'e' _ 'c' _ 'a' _ 'u' _ 's' _ 'e' _ ';', 8, 0x2235, 1)
NAMED_CHARACTER_REFERENCE(698, 'b' _ 'e' _ 'm' _ 'p' _ 't' _ 'y' _ 'v' _ ';', 8, 0x29b0, 1)
NAMED_CHARACTER_REFERENCE(699, 'b' _ 'e' _ 'p' _ 's' _ 'i' _ ';', 6, 0x03f6, 1)
NAMED_CHARACTER_REFERENCE(700, 'b' _ 'e' _ 'r' _ 'n' _ 'o' _ 'u' _ ';', 7, 0x212c, 1)
NAMED_CHARACTER_REFERENCE(701, 'b' _ 'e' _ 't' _ 'a' _ ';', 5, 0x03b2, 1)
NAMED_CHARACTER_REFERENCE(702, 'b' _ 'e' _ 't' _ 'h' _ ';', 5, 0x2136, 1)
NAMED_CHARACTER_REFERENCE(703, 'b' _ 'e' _ 't' _ 'w' _ 'e' _ 'e' _ 'n' _ ';', 8, 0x226c, 1)
NAMED_CHARACTER_REFERENCE(704, 'b' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd1f, 2)
NAMED_CHARACTER_REFERENCE(705, 'b' _ 'i' _ 'g' _ 'c' _ 'a' _ 'p' _ ';', 7, 0x22c2, 1)
NAMED_CHARACTER_REFERENCE(706, 'b' _ 'i' _ 'g' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 8, 0x25ef, 1)
NAMED_CHARACTER_REFERENCE(707, 'b' _ 'i' _ 'g' _ 'c' _ 'u' _ 'p' _ ';', 7, 0x22c3, 1)
NAMED_CHARACTER_REFERENCE(708, 'b' _ 'i' _ 'g' _ 'o' _ 'd' _ 'o' _ 't' _ ';', 8, 0x2a00, 1)
NAMED_CHARACTER_REFERENCE(709, 'b' _ 'i' _ 'g' _ 'o' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 9, 0x2a01, 1)
NAMED_CHARACTER_REFERENCE(710, 'b' _ 'i' _ 'g' _ 'o' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 10, 0x2a02, 1)
NAMED_CHARACTER_REFERENCE(711, 'b' _ 'i' _ 'g' _ 's' _ 'q' _ 'c' _ 'u' _ 'p' _ ';', 9, 0x2a06, 1)
NAMED_CHARACTER_REFERENCE(712, 'b' _ 'i' _ 'g' _ 's' _ 't' _ 'a' _ 'r' _ ';', 8, 0x2605, 1)
NAMED_CHARACTER_REFERENCE(713, 'b' _ 'i' _ 'g' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'd' _ 'o' _ 'w' _ 'n' _ ';', 16, 0x25bd, 1)
NAMED_CHARACTER_REFERENCE(714, 'b' _ 'i' _ 'g' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'u' _ 'p' _ ';', 14, 0x25b3, 1)
NAMED_CHARACTER_REFERENCE(715, 'b' _ 'i' _ 'g' _ 'u' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 9, 0x2a04, 1)
NAMED_CHARACTER_REFERENCE(716, 'b' _ 'i' _ 'g' _ 'v' _ 'e' _ 'e' _ ';', 7, 0x22c1, 1)
NAMED_CHARACTER_REFERENCE(717, 'b' _ 'i' _ 'g' _ 'w' _ 'e' _ 'd' _ 'g' _ 'e' _ ';', 9, 0x22c0, 1)
NAMED_CHARACTER_REFERENCE(718, 'b' _ 'k' _ 'a' _ 'r' _ 'o' _ 'w' _ ';', 7, 0x290d, 1)
NAMED_CHARACTER_REFERENCE(719, 'b' _ 'l' _ 'a' _ 'c' _ 'k' _ 'l' _ 'o' _ 'z' _ 'e' _ 'n' _ 'g' _ 'e' _ ';', 13, 0x29eb, 1)
NAMED_CHARACTER_REFERENCE(720, 'b' _ 'l' _ 'a' _ 'c' _ 'k' _ 's' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 12, 0x25aa, 1)
NAMED_CHARACTER_REFERENCE(721, 'b' _ 'l' _ 'a' _ 'c' _ 'k' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 14, 0x25b4, 1)
NAMED_CHARACTER_REFERENCE(722, 'b' _ 'l' _ 'a' _ 'c' _ 'k' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'd' _ 'o' _ 'w' _ 'n' _ ';', 18, 0x25be, 1)
NAMED_CHARACTER_REFERENCE(723, 'b' _ 'l' _ 'a' _ 'c' _ 'k' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 18, 0x25c2, 1)
NAMED_CHARACTER_REFERENCE(724, 'b' _ 'l' _ 'a' _ 'c' _ 'k' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 19, 0x25b8, 1)
NAMED_CHARACTER_REFERENCE(725, 'b' _ 'l' _ 'a' _ 'n' _ 'k' _ ';', 6, 0x2423, 1)
NAMED_CHARACTER_REFERENCE(726, 'b' _ 'l' _ 'k' _ '1' _ '2' _ ';', 6, 0x2592, 1)
NAMED_CHARACTER_REFERENCE(727, 'b' _ 'l' _ 'k' _ '1' _ '4' _ ';', 6, 0x2591, 1)
NAMED_CHARACTER_REFERENCE(728, 'b' _ 'l' _ 'k' _ '3' _ '4' _ ';', 6, 0x2593, 1)
NAMED_CHARACTER_REFERENCE(729, 'b' _ 'l' _ 'o' _ 'c' _ 'k' _ ';', 6, 0x2588, 1)
NAMED_CHARACTER_REFERENCE(730, 'b' _ 'n' _ 'o' _ 't' _ ';', 5, 0x2310, 1)
NAMED_CHARACTER_REFERENCE(731, 'b' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd53, 2)
NAMED_CHARACTER_REFERENCE(732, 'b' _ 'o' _ 't' _ ';', 4, 0x22a5, 1)
NAMED_CHARACTER_REFERENCE(733, 'b' _ 'o' _ 't' _ 't' _ 'o' _ 'm' _ ';', 7, 0x22a5, 1)
NAMED_CHARACTER_REFERENCE(734, 'b' _ 'o' _ 'w' _ 't' _ 'i' _ 'e' _ ';', 7, 0x22c8, 1)
NAMED_CHARACTER_REFERENCE(735, 'b' _ 'o' _ 'x' _ 'D' _ 'L' _ ';', 6, 0x2557, 1)
NAMED_CHARACTER_REFERENCE(736, 'b' _ 'o' _ 'x' _ 'D' _ 'R' _ ';', 6, 0x2554, 1)
NAMED_CHARACTER_REFERENCE(737, 'b' _ 'o' _ 'x' _ 'D' _ 'l' _ ';', 6, 0x2556, 1)
NAMED_CHARACTER_REFERENCE(738, 'b' _ 'o' _ 'x' _ 'D' _ 'r' _ ';', 6, 0x2553, 1)
NAMED_CHARACTER_REFERENCE(739, 'b' _ 'o' _ 'x' _ 'H' _ ';', 5, 0x2550, 1)
NAMED_CHARACTER_REFERENCE(740, 'b' _ 'o' _ 'x' _ 'H' _ 'D' _ ';', 6, 0x2566, 1)
NAMED_CHARACTER_REFERENCE(741, 'b' _ 'o' _ 'x' _ 'H' _ 'U' _ ';', 6, 0x2569, 1)
NAMED_CHARACTER_REFERENCE(742, 'b' _ 'o' _ 'x' _ 'H' _ 'd' _ ';', 6, 0x2564, 1)
NAMED_CHARACTER_REFERENCE(743, 'b' _ 'o' _ 'x' _ 'H' _ 'u' _ ';', 6, 0x2567, 1)
NAMED_CHARACTER_REFERENCE(744, 'b' _ 'o' _ 'x' _ 'U' _ 'L' _ ';', 6, 0x255d, 1)
NAMED_CHARACTER_REFERENCE(745, 'b' _ 'o' _ 'x' _ 'U' _ 'R' _ ';', 6, 0x255a, 1)
NAMED_CHARACTER_REFERENCE(746, 'b' _ 'o' _ 'x' _ 'U' _ 'l' _ ';', 6, 0x255c, 1)
NAMED_CHARACTER_REFERENCE(747, 'b' _ 'o' _ 'x' _ 'U' _ 'r' _ ';', 6, 0x2559, 1)
NAMED_CHARACTER_REFERENCE(748, 'b' _ 'o' _ 'x' _ 'V' _ ';', 5, 0x2551, 1)
NAMED_CHARACTER_REFERENCE(749, 'b' _ 'o' _ 'x' _ 'V' _ 'H' _ ';', 6, 0x256c, 1)
NAMED_CHARACTER_REFERENCE(750, 'b' _ 'o' _ 'x' _ 'V' _ 'L' _ ';', 6, 0x2563, 1)
NAMED_CHARACTER_REFERENCE(751, 'b' _ 'o' _ 'x' _ 'V' _ 'R' _ ';', 6, 0x2560, 1)
NAMED_CHARACTER_REFERENCE(752, 'b' _ 'o' _ 'x' _ 'V' _ 'h' _ ';', 6, 0x256b, 1)
NAMED_CHARACTER_REFERENCE(753, 'b' _ 'o' _ 'x' _ 'V' _ 'l' _ ';', 6, 0x2562, 1)
NAMED_CHARACTER_REFERENCE(754, 'b' _ 'o' _ 'x' _ 'V' _ 'r' _ ';', 6, 0x255f, 1)
NAMED_CHARACTER_REFERENCE(755, 'b' _ 'o' _ 'x' _ 'b' _ 'o' _ 'x' _ ';', 7, 0x29c9, 1)
NAMED_CHARACTER_REFERENCE(756, 'b' _ 'o' _ 'x' _ 'd' _ 'L' _ ';', 6, 0x2555, 1)
NAMED_CHARACTER_REFERENCE(757, 'b' _ 'o' _ 'x' _ 'd' _ 'R' _ ';', 6, 0x2552, 1)
NAMED_CHARACTER_REFERENCE(758, 'b' _ 'o' _ 'x' _ 'd' _ 'l' _ ';', 6, 0x2510, 1)
NAMED_CHARACTER_REFERENCE(759, 'b' _ 'o' _ 'x' _ 'd' _ 'r' _ ';', 6, 0x250c, 1)
NAMED_CHARACTER_REFERENCE(760, 'b' _ 'o' _ 'x' _ 'h' _ ';', 5, 0x2500, 1)
NAMED_CHARACTER_REFERENCE(761, 'b' _ 'o' _ 'x' _ 'h' _ 'D' _ ';', 6, 0x2565, 1)
NAMED_CHARACTER_REFERENCE(762, 'b' _ 'o' _ 'x' _ 'h' _ 'U' _ ';', 6, 0x2568, 1)
NAMED_CHARACTER_REFERENCE(763, 'b' _ 'o' _ 'x' _ 'h' _ 'd' _ ';', 6, 0x252c, 1)
NAMED_CHARACTER_REFERENCE(764, 'b' _ 'o' _ 'x' _ 'h' _ 'u' _ ';', 6, 0x2534, 1)
NAMED_CHARACTER_REFERENCE(765, 'b' _ 'o' _ 'x' _ 'm' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 9, 0x229f, 1)
NAMED_CHARACTER_REFERENCE(766, 'b' _ 'o' _ 'x' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 8, 0x229e, 1)
NAMED_CHARACTER_REFERENCE(767, 'b' _ 'o' _ 'x' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 9, 0x22a0, 1)
NAMED_CHARACTER_REFERENCE(768, 'b' _ 'o' _ 'x' _ 'u' _ 'L' _ ';', 6, 0x255b, 1)
NAMED_CHARACTER_REFERENCE(769, 'b' _ 'o' _ 'x' _ 'u' _ 'R' _ ';', 6, 0x2558, 1)
NAMED_CHARACTER_REFERENCE(770, 'b' _ 'o' _ 'x' _ 'u' _ 'l' _ ';', 6, 0x2518, 1)
NAMED_CHARACTER_REFERENCE(771, 'b' _ 'o' _ 'x' _ 'u' _ 'r' _ ';', 6, 0x2514, 1)
NAMED_CHARACTER_REFERENCE(772, 'b' _ 'o' _ 'x' _ 'v' _ ';', 5, 0x2502, 1)
NAMED_CHARACTER_REFERENCE(773, 'b' _ 'o' _ 'x' _ 'v' _ 'H' _ ';', 6, 0x256a, 1)
NAMED_CHARACTER_REFERENCE(774, 'b' _ 'o' _ 'x' _ 'v' _ 'L' _ ';', 6, 0x2561, 1)
NAMED_CHARACTER_REFERENCE(775, 'b' _ 'o' _ 'x' _ 'v' _ 'R' _ ';', 6, 0x255e, 1)
NAMED_CHARACTER_REFERENCE(776, 'b' _ 'o' _ 'x' _ 'v' _ 'h' _ ';', 6, 0x253c, 1)
NAMED_CHARACTER_REFERENCE(777, 'b' _ 'o' _ 'x' _ 'v' _ 'l' _ ';', 6, 0x2524, 1)
NAMED_CHARACTER_REFERENCE(778, 'b' _ 'o' _ 'x' _ 'v' _ 'r' _ ';', 6, 0x251c, 1)
NAMED_CHARACTER_REFERENCE(779, 'b' _ 'p' _ 'r' _ 'i' _ 'm' _ 'e' _ ';', 7, 0x2035, 1)
NAMED_CHARACTER_REFERENCE(780, 'b' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 6, 0x02d8, 1)
NAMED_CHARACTER_REFERENCE(781, 'b' _ 'r' _ 'v' _ 'b' _ 'a' _ 'r', 6, 0x00a6, 1)
NAMED_CHARACTER_REFERENCE(782, 'b' _ 'r' _ 'v' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x00a6, 1)
NAMED_CHARACTER_REFERENCE(783, 'b' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb7, 2)
NAMED_CHARACTER_REFERENCE(784, 'b' _ 's' _ 'e' _ 'm' _ 'i' _ ';', 6, 0x204f, 1)
NAMED_CHARACTER_REFERENCE(785, 'b' _ 's' _ 'i' _ 'm' _ ';', 5, 0x223d, 1)
NAMED_CHARACTER_REFERENCE(786, 'b' _ 's' _ 'i' _ 'm' _ 'e' _ ';', 6, 0x22cd, 1)
NAMED_CHARACTER_REFERENCE(787, 'b' _ 's' _ 'o' _ 'l' _ ';', 5, 0x005c, 1)
NAMED_CHARACTER_REFERENCE(788, 'b' _ 's' _ 'o' _ 'l' _ 'b' _ ';', 6, 0x29c5, 1)
NAMED_CHARACTER_REFERENCE(789, 'b' _ 's' _ 'o' _ 'l' _ 'h' _ 's' _ 'u' _ 'b' _ ';', 9, 0x27c8, 1)
NAMED_CHARACTER_REFERENCE(790, 'b' _ 'u' _ 'l' _ 'l' _ ';', 5, 0x2022, 1)
NAMED_CHARACTER_REFERENCE(791, 'b' _ 'u' _ 'l' _ 'l' _ 'e' _ 't' _ ';', 7, 0x2022, 1)
NAMED_CHARACTER_REFERENCE(792, 'b' _ 'u' _ 'm' _ 'p' _ ';', 5, 0x224e, 1)
NAMED_CHARACTER_REFERENCE(793, 'b' _ 'u' _ 'm' _ 'p' _ 'E' _ ';', 6, 0x2aae, 1)
NAMED_CHARACTER_REFERENCE(794, 'b' _ 'u' _ 'm' _ 'p' _ 'e' _ ';', 6, 0x224f, 1)
NAMED_CHARACTER_REFERENCE(795, 'b' _ 'u' _ 'm' _ 'p' _ 'e' _ 'q' _ ';', 7, 0x224f, 1)
NAMED_CHARACTER_REFERENCE(796, 'c' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0107, 1)
NAMED_CHARACTER_REFERENCE(797, 'c' _ 'a' _ 'p' _ ';', 4, 0x2229, 1)
NAMED_CHARACTER_REFERENCE(798, 'c' _ 'a' _ 'p' _ 'a' _ 'n' _ 'd' _ ';', 7, 0x2a44, 1)
NAMED_CHARACTER_REFERENCE(799, 'c' _ 'a' _ 'p' _ 'b' _ 'r' _ 'c' _ 'u' _ 'p' _ ';', 9, 0x2a49, 1)
NAMED_CHARACTER_REFERENCE(800, 'c' _ 'a' _ 'p' _ 'c' _ 'a' _ 'p' _ ';', 7, 0x2a4b, 1)
NAMED_CHARACTER_REFERENCE(801, 'c' _ 'a' _ 'p' _ 'c' _ 'u' _ 'p' _ ';', 7, 0x2a47, 1)
NAMED_CHARACTER_REFERENCE(802, 'c' _ 'a' _ 'p' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2a40, 1)
NAMED_CHARACTER_REFERENCE(803, 'c' _ 'a' _ 'r' _ 'e' _ 't' _ ';', 6, 0x2041, 1)
NAMED_CHARACTER_REFERENCE(804, 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 6, 0x02c7, 1)
NAMED_CHARACTER_REFERENCE(805, 'c' _ 'c' _ 'a' _ 'p' _ 's' _ ';', 6, 0x2a4d, 1)
NAMED_CHARACTER_REFERENCE(806, 'c' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x010d, 1)
NAMED_CHARACTER_REFERENCE(807, 'c' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l', 6, 0x00e7, 1)
NAMED_CHARACTER_REFERENCE(808, 'c' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x00e7, 1)
NAMED_CHARACTER_REFERENCE(809, 'c' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0109, 1)
NAMED_CHARACTER_REFERENCE(810, 'c' _ 'c' _ 'u' _ 'p' _ 's' _ ';', 6, 0x2a4c, 1)
NAMED_CHARACTER_REFERENCE(811, 'c' _ 'c' _ 'u' _ 'p' _ 's' _ 's' _ 'm' _ ';', 8, 0x2a50, 1)
NAMED_CHARACTER_REFERENCE(812, 'c' _ 'd' _ 'o' _ 't' _ ';', 5, 0x010b, 1)
NAMED_CHARACTER_REFERENCE(813, 'c' _ 'e' _ 'd' _ 'i' _ 'l', 5, 0x00b8, 1)
NAMED_CHARACTER_REFERENCE(814, 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 6, 0x00b8, 1)
NAMED_CHARACTER_REFERENCE(815, 'c' _ 'e' _ 'm' _ 'p' _ 't' _ 'y' _ 'v' _ ';', 8, 0x29b2, 1)
NAMED_CHARACTER_REFERENCE(816, 'c' _ 'e' _ 'n' _ 't', 4, 0x00a2, 1)
NAMED_CHARACTER_REFERENCE(817, 'c' _ 'e' _ 'n' _ 't' _ ';', 5, 0x00a2, 1)
NAMED_CHARACTER_REFERENCE(818, 'c' _ 'e' _ 'n' _ 't' _ 'e' _ 'r' _ 'd' _ 'o' _ 't' _ ';', 10, 0x00b7, 1)
NAMED_CHARACTER_REFERENCE(819, 'c' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd20, 2)
NAMED_CHARACTER_REFERENCE(820, 'c' _ 'h' _ 'c' _ 'y' _ ';', 5, 0x0447, 1)
NAMED_CHARACTER_REFERENCE(821, 'c' _ 'h' _ 'e' _ 'c' _ 'k' _ ';', 6, 0x2713, 1)
NAMED_CHARACTER_REFERENCE(822, 'c' _ 'h' _ 'e' _ 'c' _ 'k' _ 'm' _ 'a' _ 'r' _ 'k' _ ';', 10, 0x2713, 1)
NAMED_CHARACTER_REFERENCE(823, 'c' _ 'h' _ 'i' _ ';', 4, 0x03c7, 1)
NAMED_CHARACTER_REFERENCE(824, 'c' _ 'i' _ 'r' _ ';', 4, 0x25cb, 1)
NAMED_CHARACTER_REFERENCE(825, 'c' _ 'i' _ 'r' _ 'E' _ ';', 5, 0x29c3, 1)
NAMED_CHARACTER_REFERENCE(826, 'c' _ 'i' _ 'r' _ 'c' _ ';', 5, 0x02c6, 1)
NAMED_CHARACTER_REFERENCE(827, 'c' _ 'i' _ 'r' _ 'c' _ 'e' _ 'q' _ ';', 7, 0x2257, 1)
NAMED_CHARACTER_REFERENCE(828, 'c' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 16, 0x21ba, 1)
NAMED_CHARACTER_REFERENCE(829, 'c' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 17, 0x21bb, 1)
NAMED_CHARACTER_REFERENCE(830, 'c' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'd' _ 'R' _ ';', 9, 0x00ae, 1)
NAMED_CHARACTER_REFERENCE(831, 'c' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'd' _ 'S' _ ';', 9, 0x24c8, 1)
NAMED_CHARACTER_REFERENCE(832, 'c' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'd' _ 'a' _ 's' _ 't' _ ';', 11, 0x229b, 1)
NAMED_CHARACTER_REFERENCE(833, 'c' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'd' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 12, 0x229a, 1)
NAMED_CHARACTER_REFERENCE(834, 'c' _ 'i' _ 'r' _ 'c' _ 'l' _ 'e' _ 'd' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 12, 0x229d, 1)
NAMED_CHARACTER_REFERENCE(835, 'c' _ 'i' _ 'r' _ 'e' _ ';', 5, 0x2257, 1)
NAMED_CHARACTER_REFERENCE(836, 'c' _ 'i' _ 'r' _ 'f' _ 'n' _ 'i' _ 'n' _ 't' _ ';', 9, 0x2a10, 1)
NAMED_CHARACTER_REFERENCE(837, 'c' _ 'i' _ 'r' _ 'm' _ 'i' _ 'd' _ ';', 7, 0x2aef, 1)
NAMED_CHARACTER_REFERENCE(838, 'c' _ 'i' _ 'r' _ 's' _ 'c' _ 'i' _ 'r' _ ';', 8, 0x29c2, 1)
NAMED_CHARACTER_REFERENCE(839, 'c' _ 'l' _ 'u' _ 'b' _ 's' _ ';', 6, 0x2663, 1)
NAMED_CHARACTER_REFERENCE(840, 'c' _ 'l' _ 'u' _ 'b' _ 's' _ 'u' _ 'i' _ 't' _ ';', 9, 0x2663, 1)
NAMED_CHARACTER_REFERENCE(841, 'c' _ 'o' _ 'l' _ 'o' _ 'n' _ ';', 6, 0x003a, 1)
NAMED_CHARACTER_REFERENCE(842, 'c' _ 'o' _ 'l' _ 'o' _ 'n' _ 'e' _ ';', 7, 0x2254, 1)
NAMED_CHARACTER_REFERENCE(843, 'c' _ 'o' _ 'l' _ 'o' _ 'n' _ 'e' _ 'q' _ ';', 8, 0x2254, 1)
NAMED_CHARACTER_REFERENCE(844, 'c' _ 'o' _ 'm' _ 'm' _ 'a' _ ';', 6, 0x002c, 1)
NAMED_CHARACTER_REFERENCE(845, 'c' _ 'o' _ 'm' _ 'm' _ 'a' _ 't' _ ';', 7, 0x0040, 1)
NAMED_CHARACTER_REFERENCE(846, 'c' _ 'o' _ 'm' _ 'p' _ ';', 5, 0x2201, 1)
NAMED_CHARACTER_REFERENCE(847, 'c' _ 'o' _ 'm' _ 'p' _ 'f' _ 'n' _ ';', 7, 0x2218, 1)
NAMED_CHARACTER_REFERENCE(848, 'c' _ 'o' _ 'm' _ 'p' _ 'l' _ 'e' _ 'm' _ 'e' _ 'n' _ 't' _ ';', 11, 0x2201, 1)
NAMED_CHARACTER_REFERENCE(849, 'c' _ 'o' _ 'm' _ 'p' _ 'l' _ 'e' _ 'x' _ 'e' _ 's' _ ';', 10, 0x2102, 1)
NAMED_CHARACTER_REFERENCE(850, 'c' _ 'o' _ 'n' _ 'g' _ ';', 5, 0x2245, 1)
NAMED_CHARACTER_REFERENCE(851, 'c' _ 'o' _ 'n' _ 'g' _ 'd' _ 'o' _ 't' _ ';', 8, 0x2a6d, 1)
NAMED_CHARACTER_REFERENCE(852, 'c' _ 'o' _ 'n' _ 'i' _ 'n' _ 't' _ ';', 7, 0x222e, 1)
NAMED_CHARACTER_REFERENCE(853, 'c' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd54, 2)
NAMED_CHARACTER_REFERENCE(854, 'c' _ 'o' _ 'p' _ 'r' _ 'o' _ 'd' _ ';', 7, 0x2210, 1)
NAMED_CHARACTER_REFERENCE(855, 'c' _ 'o' _ 'p' _ 'y', 4, 0x00a9, 1)
NAMED_CHARACTER_REFERENCE(856, 'c' _ 'o' _ 'p' _ 'y' _ ';', 5, 0x00a9, 1)
NAMED_CHARACTER_REFERENCE(857, 'c' _ 'o' _ 'p' _ 'y' _ 's' _ 'r' _ ';', 7, 0x2117, 1)
NAMED_CHARACTER_REFERENCE(858, 'c' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21b5, 1)
NAMED_CHARACTER_REFERENCE(859, 'c' _ 'r' _ 'o' _ 's' _ 's' _ ';', 6, 0x2717, 1)
NAMED_CHARACTER_REFERENCE(860, 'c' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb8, 2)
NAMED_CHARACTER_REFERENCE(861, 'c' _ 's' _ 'u' _ 'b' _ ';', 5, 0x2acf, 1)
NAMED_CHARACTER_REFERENCE(862, 'c' _ 's' _ 'u' _ 'b' _ 'e' _ ';', 6, 0x2ad1, 1)
NAMED_CHARACTER_REFERENCE(863, 'c' _ 's' _ 'u' _ 'p' _ ';', 5, 0x2ad0, 1)
NAMED_CHARACTER_REFERENCE(864, 'c' _ 's' _ 'u' _ 'p' _ 'e' _ ';', 6, 0x2ad2, 1)
NAMED_CHARACTER_REFERENCE(865, 'c' _ 't' _ 'd' _ 'o' _ 't' _ ';', 6, 0x22ef, 1)
NAMED_CHARACTER_REFERENCE(866, 'c' _ 'u' _ 'd' _ 'a' _ 'r' _ 'r' _ 'l' _ ';', 8, 0x2938, 1)
NAMED_CHARACTER_REFERENCE(867, 'c' _ 'u' _ 'd' _ 'a' _ 'r' _ 'r' _ 'r' _ ';', 8, 0x2935, 1)
NAMED_CHARACTER_REFERENCE(868, 'c' _ 'u' _ 'e' _ 'p' _ 'r' _ ';', 6, 0x22de, 1)
NAMED_CHARACTER_REFERENCE(869, 'c' _ 'u' _ 'e' _ 's' _ 'c' _ ';', 6, 0x22df, 1)
NAMED_CHARACTER_REFERENCE(870, 'c' _ 'u' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 7, 0x21b6, 1)
NAMED_CHARACTER_REFERENCE(871, 'c' _ 'u' _ 'l' _ 'a' _ 'r' _ 'r' _ 'p' _ ';', 8, 0x293d, 1)
NAMED_CHARACTER_REFERENCE(872, 'c' _ 'u' _ 'p' _ ';', 4, 0x222a, 1)
NAMED_CHARACTER_REFERENCE(873, 'c' _ 'u' _ 'p' _ 'b' _ 'r' _ 'c' _ 'a' _ 'p' _ ';', 9, 0x2a48, 1)
NAMED_CHARACTER_REFERENCE(874, 'c' _ 'u' _ 'p' _ 'c' _ 'a' _ 'p' _ ';', 7, 0x2a46, 1)
NAMED_CHARACTER_REFERENCE(875, 'c' _ 'u' _ 'p' _ 'c' _ 'u' _ 'p' _ ';', 7, 0x2a4a, 1)
NAMED_CHARACTER_REFERENCE(876, 'c' _ 'u' _ 'p' _ 'd' _ 'o' _ 't' _ ';', 7, 0x228d, 1)
NAMED_CHARACTER_REFERENCE(877, 'c' _ 'u' _ 'p' _ 'o' _ 'r' _ ';', 6, 0x2a45, 1)
NAMED_CHARACTER_REFERENCE(878, 'c' _ 'u' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 7, 0x21b7, 1)
NAMED_CHARACTER_REFERENCE(879, 'c' _ 'u' _ 'r' _ 'a' _ 'r' _ 'r' _ 'm' _ ';', 8, 0x293c, 1)
NAMED_CHARACTER_REFERENCE(880, 'c' _ 'u' _ 'r' _ 'l' _ 'y' _ 'e' _ 'q' _ 'p' _ 'r' _ 'e' _ 'c' _ ';', 12, 0x22de, 1)
NAMED_CHARACTER_REFERENCE(881, 'c' _ 'u' _ 'r' _ 'l' _ 'y' _ 'e' _ 'q' _ 's' _ 'u' _ 'c' _ 'c' _ ';', 12, 0x22df, 1)
NAMED_CHARACTER_REFERENCE(882, 'c' _ 'u' _ 'r' _ 'l' _ 'y' _ 'v' _ 'e' _ 'e' _ ';', 9, 0x22ce, 1)
NAMED_CHARACTER_REFERENCE(883, 'c' _ 'u' _ 'r' _ 'l' _ 'y' _ 'w' _ 'e' _ 'd' _ 'g' _ 'e' _ ';', 11, 0x22cf, 1)
NAMED_CHARACTER_REFERENCE(884, 'c' _ 'u' _ 'r' _ 'r' _ 'e' _ 'n', 6, 0x00a4, 1)
NAMED_CHARACTER_REFERENCE(885, 'c' _ 'u' _ 'r' _ 'r' _ 'e' _ 'n' _ ';', 7, 0x00a4, 1)
NAMED_CHARACTER_REFERENCE(886, 'c' _ 'u' _ 'r' _ 'v' _ 'e' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 15, 0x21b6, 1)
NAMED_CHARACTER_REFERENCE(887, 'c' _ 'u' _ 'r' _ 'v' _ 'e' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 16, 0x21b7, 1)
NAMED_CHARACTER_REFERENCE(888, 'c' _ 'u' _ 'v' _ 'e' _ 'e' _ ';', 6, 0x22ce, 1)
NAMED_CHARACTER_REFERENCE(889, 'c' _ 'u' _ 'w' _ 'e' _ 'd' _ ';', 6, 0x22cf, 1)
NAMED_CHARACTER_REFERENCE(890, 'c' _ 'w' _ 'c' _ 'o' _ 'n' _ 'i' _ 'n' _ 't' _ ';', 9, 0x2232, 1)
NAMED_CHARACTER_REFERENCE(891, 'c' _ 'w' _ 'i' _ 'n' _ 't' _ ';', 6, 0x2231, 1)
NAMED_CHARACTER_REFERENCE(892, 'c' _ 'y' _ 'l' _ 'c' _ 't' _ 'y' _ ';', 7, 0x232d, 1)
NAMED_CHARACTER_REFERENCE(893, 'd' _ 'A' _ 'r' _ 'r' _ ';', 5, 0x21d3, 1)
NAMED_CHARACTER_REFERENCE(894, 'd' _ 'H' _ 'a' _ 'r' _ ';', 5, 0x2965, 1)
NAMED_CHARACTER_REFERENCE(895, 'd' _ 'a' _ 'g' _ 'g' _ 'e' _ 'r' _ ';', 7, 0x2020, 1)
NAMED_CHARACTER_REFERENCE(896, 'd' _ 'a' _ 'l' _ 'e' _ 't' _ 'h' _ ';', 7, 0x2138, 1)
NAMED_CHARACTER_REFERENCE(897, 'd' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x2193, 1)
NAMED_CHARACTER_REFERENCE(898, 'd' _ 'a' _ 's' _ 'h' _ ';', 5, 0x2010, 1)
NAMED_CHARACTER_REFERENCE(899, 'd' _ 'a' _ 's' _ 'h' _ 'v' _ ';', 6, 0x22a3, 1)
NAMED_CHARACTER_REFERENCE(900, 'd' _ 'b' _ 'k' _ 'a' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x290f, 1)
NAMED_CHARACTER_REFERENCE(901, 'd' _ 'b' _ 'l' _ 'a' _ 'c' _ ';', 6, 0x02dd, 1)
NAMED_CHARACTER_REFERENCE(902, 'd' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x010f, 1)
NAMED_CHARACTER_REFERENCE(903, 'd' _ 'c' _ 'y' _ ';', 4, 0x0434, 1)
NAMED_CHARACTER_REFERENCE(904, 'd' _ 'd' _ ';', 3, 0x2146, 1)
NAMED_CHARACTER_REFERENCE(905, 'd' _ 'd' _ 'a' _ 'g' _ 'g' _ 'e' _ 'r' _ ';', 8, 0x2021, 1)
NAMED_CHARACTER_REFERENCE(906, 'd' _ 'd' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21ca, 1)
NAMED_CHARACTER_REFERENCE(907, 'd' _ 'd' _ 'o' _ 't' _ 's' _ 'e' _ 'q' _ ';', 8, 0x2a77, 1)
NAMED_CHARACTER_REFERENCE(908, 'd' _ 'e' _ 'g', 3, 0x00b0, 1)
NAMED_CHARACTER_REFERENCE(909, 'd' _ 'e' _ 'g' _ ';', 4, 0x00b0, 1)
NAMED_CHARACTER_REFERENCE(910, 'd' _ 'e' _ 'l' _ 't' _ 'a' _ ';', 6, 0x03b4, 1)
NAMED_CHARACTER_REFERENCE(911, 'd' _ 'e' _ 'm' _ 'p' _ 't' _ 'y' _ 'v' _ ';', 8, 0x29b1, 1)
NAMED_CHARACTER_REFERENCE(912, 'd' _ 'f' _ 'i' _ 's' _ 'h' _ 't' _ ';', 7, 0x297f, 1)
NAMED_CHARACTER_REFERENCE(913, 'd' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd21, 2)
NAMED_CHARACTER_REFERENCE(914, 'd' _ 'h' _ 'a' _ 'r' _ 'l' _ ';', 6, 0x21c3, 1)
NAMED_CHARACTER_REFERENCE(915, 'd' _ 'h' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21c2, 1)
NAMED_CHARACTER_REFERENCE(916, 'd' _ 'i' _ 'a' _ 'm' _ ';', 5, 0x22c4, 1)
NAMED_CHARACTER_REFERENCE(917, 'd' _ 'i' _ 'a' _ 'm' _ 'o' _ 'n' _ 'd' _ ';', 8, 0x22c4, 1)
NAMED_CHARACTER_REFERENCE(918, 'd' _ 'i' _ 'a' _ 'm' _ 'o' _ 'n' _ 'd' _ 's' _ 'u' _ 'i' _ 't' _ ';', 12, 0x2666, 1)
NAMED_CHARACTER_REFERENCE(919, 'd' _ 'i' _ 'a' _ 'm' _ 's' _ ';', 6, 0x2666, 1)
NAMED_CHARACTER_REFERENCE(920, 'd' _ 'i' _ 'e' _ ';', 4, 0x00a8, 1)
NAMED_CHARACTER_REFERENCE(921, 'd' _ 'i' _ 'g' _ 'a' _ 'm' _ 'm' _ 'a' _ ';', 8, 0x03dd, 1)
NAMED_CHARACTER_REFERENCE(922, 'd' _ 'i' _ 's' _ 'i' _ 'n' _ ';', 6, 0x22f2, 1)
NAMED_CHARACTER_REFERENCE(923, 'd' _ 'i' _ 'v' _ ';', 4, 0x00f7, 1)
NAMED_CHARACTER_REFERENCE(924, 'd' _ 'i' _ 'v' _ 'i' _ 'd' _ 'e', 6, 0x00f7, 1)
NAMED_CHARACTER_REFERENCE(925, 'd' _ 'i' _ 'v' _ 'i' _ 'd' _ 'e' _ ';', 7, 0x00f7, 1)
NAMED_CHARACTER_REFERENCE(926, 'd' _ 'i' _ 'v' _ 'i' _ 'd' _ 'e' _ 'o' _ 'n' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 14, 0x22c7, 1)
NAMED_CHARACTER_REFERENCE(927, 'd' _ 'i' _ 'v' _ 'o' _ 'n' _ 'x' _ ';', 7, 0x22c7, 1)
NAMED_CHARACTER_REFERENCE(928, 'd' _ 'j' _ 'c' _ 'y' _ ';', 5, 0x0452, 1)
NAMED_CHARACTER_REFERENCE(929, 'd' _ 'l' _ 'c' _ 'o' _ 'r' _ 'n' _ ';', 7, 0x231e, 1)
NAMED_CHARACTER_REFERENCE(930, 'd' _ 'l' _ 'c' _ 'r' _ 'o' _ 'p' _ ';', 7, 0x230d, 1)
NAMED_CHARACTER_REFERENCE(931, 'd' _ 'o' _ 'l' _ 'l' _ 'a' _ 'r' _ ';', 7, 0x0024, 1)
NAMED_CHARACTER_REFERENCE(932, 'd' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd55, 2)
NAMED_CHARACTER_REFERENCE(933, 'd' _ 'o' _ 't' _ ';', 4, 0x02d9, 1)
NAMED_CHARACTER_REFERENCE(934, 'd' _ 'o' _ 't' _ 'e' _ 'q' _ ';', 6, 0x2250, 1)
NAMED_CHARACTER_REFERENCE(935, 'd' _ 'o' _ 't' _ 'e' _ 'q' _ 'd' _ 'o' _ 't' _ ';', 9, 0x2251, 1)
NAMED_CHARACTER_REFERENCE(936, 'd' _ 'o' _ 't' _ 'm' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 9, 0x2238, 1)
NAMED_CHARACTER_REFERENCE(937, 'd' _ 'o' _ 't' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 8, 0x2214, 1)
NAMED_CHARACTER_REFERENCE(938, 'd' _ 'o' _ 't' _ 's' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 10, 0x22a1, 1)
NAMED_CHARACTER_REFERENCE(939, 'd' _ 'o' _ 'u' _ 'b' _ 'l' _ 'e' _ 'b' _ 'a' _ 'r' _ 'w' _ 'e' _ 'd' _ 'g' _ 'e' _ ';', 15, 0x2306, 1)
NAMED_CHARACTER_REFERENCE(940, 'd' _ 'o' _ 'w' _ 'n' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 10, 0x2193, 1)
NAMED_CHARACTER_REFERENCE(941, 'd' _ 'o' _ 'w' _ 'n' _ 'd' _ 'o' _ 'w' _ 'n' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 's' _ ';', 15, 0x21ca, 1)
NAMED_CHARACTER_REFERENCE(942, 'd' _ 'o' _ 'w' _ 'n' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 16, 0x21c3, 1)
NAMED_CHARACTER_REFERENCE(943, 'd' _ 'o' _ 'w' _ 'n' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 17, 0x21c2, 1)
NAMED_CHARACTER_REFERENCE(944, 'd' _ 'r' _ 'b' _ 'k' _ 'a' _ 'r' _ 'o' _ 'w' _ ';', 9, 0x2910, 1)
NAMED_CHARACTER_REFERENCE(945, 'd' _ 'r' _ 'c' _ 'o' _ 'r' _ 'n' _ ';', 7, 0x231f, 1)
NAMED_CHARACTER_REFERENCE(946, 'd' _ 'r' _ 'c' _ 'r' _ 'o' _ 'p' _ ';', 7, 0x230c, 1)
NAMED_CHARACTER_REFERENCE(947, 'd' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcb9, 2)
NAMED_CHARACTER_REFERENCE(948, 'd' _ 's' _ 'c' _ 'y' _ ';', 5, 0x0455, 1)
NAMED_CHARACTER_REFERENCE(949, 'd' _ 's' _ 'o' _ 'l' _ ';', 5, 0x29f6, 1)
NAMED_CHARACTER_REFERENCE(950, 'd' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0111, 1)
NAMED_CHARACTER_REFERENCE(951, 'd' _ 't' _ 'd' _ 'o' _ 't' _ ';', 6, 0x22f1, 1)
NAMED_CHARACTER_REFERENCE(952, 'd' _ 't' _ 'r' _ 'i' _ ';', 5, 0x25bf, 1)
NAMED_CHARACTER_REFERENCE(953, 'd' _ 't' _ 'r' _ 'i' _ 'f' _ ';', 6, 0x25be, 1)
NAMED_CHARACTER_REFERENCE(954, 'd' _ 'u' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21f5, 1)
NAMED_CHARACTER_REFERENCE(955, 'd' _ 'u' _ 'h' _ 'a' _ 'r' _ ';', 6, 0x296f, 1)
NAMED_CHARACTER_REFERENCE(956, 'd' _ 'w' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 8, 0x29a6, 1)
NAMED_CHARACTER_REFERENCE(957, 'd' _ 'z' _ 'c' _ 'y' _ ';', 5, 0x045f, 1)
NAMED_CHARACTER_REFERENCE(958, 'd' _ 'z' _ 'i' _ 'g' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 9, 0x27ff, 1)
NAMED_CHARACTER_REFERENCE(959, 'e' _ 'D' _ 'D' _ 'o' _ 't' _ ';', 6, 0x2a77, 1)
NAMED_CHARACTER_REFERENCE(960, 'e' _ 'D' _ 'o' _ 't' _ ';', 5, 0x2251, 1)
NAMED_CHARACTER_REFERENCE(961, 'e' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00e9, 1)
NAMED_CHARACTER_REFERENCE(962, 'e' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00e9, 1)
NAMED_CHARACTER_REFERENCE(963, 'e' _ 'a' _ 's' _ 't' _ 'e' _ 'r' _ ';', 7, 0x2a6e, 1)
NAMED_CHARACTER_REFERENCE(964, 'e' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x011b, 1)
NAMED_CHARACTER_REFERENCE(965, 'e' _ 'c' _ 'i' _ 'r' _ ';', 5, 0x2256, 1)
NAMED_CHARACTER_REFERENCE(966, 'e' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00ea, 1)
NAMED_CHARACTER_REFERENCE(967, 'e' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00ea, 1)
NAMED_CHARACTER_REFERENCE(968, 'e' _ 'c' _ 'o' _ 'l' _ 'o' _ 'n' _ ';', 7, 0x2255, 1)
NAMED_CHARACTER_REFERENCE(969, 'e' _ 'c' _ 'y' _ ';', 4, 0x044d, 1)
NAMED_CHARACTER_REFERENCE(970, 'e' _ 'd' _ 'o' _ 't' _ ';', 5, 0x0117, 1)
NAMED_CHARACTER_REFERENCE(971, 'e' _ 'e' _ ';', 3, 0x2147, 1)
NAMED_CHARACTER_REFERENCE(972, 'e' _ 'f' _ 'D' _ 'o' _ 't' _ ';', 6, 0x2252, 1)
NAMED_CHARACTER_REFERENCE(973, 'e' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd22, 2)
NAMED_CHARACTER_REFERENCE(974, 'e' _ 'g' _ ';', 3, 0x2a9a, 1)
NAMED_CHARACTER_REFERENCE(975, 'e' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00e8, 1)
NAMED_CHARACTER_REFERENCE(976, 'e' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00e8, 1)
NAMED_CHARACTER_REFERENCE(977, 'e' _ 'g' _ 's' _ ';', 4, 0x2a96, 1)
NAMED_CHARACTER_REFERENCE(978, 'e' _ 'g' _ 's' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2a98, 1)
NAMED_CHARACTER_REFERENCE(979, 'e' _ 'l' _ ';', 3, 0x2a99, 1)
NAMED_CHARACTER_REFERENCE(980, 'e' _ 'l' _ 'i' _ 'n' _ 't' _ 'e' _ 'r' _ 's' _ ';', 9, 0x23e7, 1)
NAMED_CHARACTER_REFERENCE(981, 'e' _ 'l' _ 'l' _ ';', 4, 0x2113, 1)
NAMED_CHARACTER_REFERENCE(982, 'e' _ 'l' _ 's' _ ';', 4, 0x2a95, 1)
NAMED_CHARACTER_REFERENCE(983, 'e' _ 'l' _ 's' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2a97, 1)
NAMED_CHARACTER_REFERENCE(984, 'e' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x0113, 1)
NAMED_CHARACTER_REFERENCE(985, 'e' _ 'm' _ 'p' _ 't' _ 'y' _ ';', 6, 0x2205, 1)
NAMED_CHARACTER_REFERENCE(986, 'e' _ 'm' _ 'p' _ 't' _ 'y' _ 's' _ 'e' _ 't' _ ';', 9, 0x2205, 1)
NAMED_CHARACTER_REFERENCE(987, 'e' _ 'm' _ 'p' _ 't' _ 'y' _ 'v' _ ';', 7, 0x2205, 1)
NAMED_CHARACTER_REFERENCE(988, 'e' _ 'm' _ 's' _ 'p' _ '1' _ '3' _ ';', 7, 0x2004, 1)
NAMED_CHARACTER_REFERENCE(989, 'e' _ 'm' _ 's' _ 'p' _ '1' _ '4' _ ';', 7, 0x2005, 1)
NAMED_CHARACTER_REFERENCE(990, 'e' _ 'm' _ 's' _ 'p' _ ';', 5, 0x2003, 1)
NAMED_CHARACTER_REFERENCE(991, 'e' _ 'n' _ 'g' _ ';', 4, 0x014b, 1)
NAMED_CHARACTER_REFERENCE(992, 'e' _ 'n' _ 's' _ 'p' _ ';', 5, 0x2002, 1)
NAMED_CHARACTER_REFERENCE(993, 'e' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x0119, 1)
NAMED_CHARACTER_REFERENCE(994, 'e' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd56, 2)
NAMED_CHARACTER_REFERENCE(995, 'e' _ 'p' _ 'a' _ 'r' _ ';', 5, 0x22d5, 1)
NAMED_CHARACTER_REFERENCE(996, 'e' _ 'p' _ 'a' _ 'r' _ 's' _ 'l' _ ';', 7, 0x29e3, 1)
NAMED_CHARACTER_REFERENCE(997, 'e' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 6, 0x2a71, 1)
NAMED_CHARACTER_REFERENCE(998, 'e' _ 'p' _ 's' _ 'i' _ ';', 5, 0x03b5, 1)
NAMED_CHARACTER_REFERENCE(999, 'e' _ 'p' _ 's' _ 'i' _ 'l' _ 'o' _ 'n' _ ';', 8, 0x03b5, 1)
NAMED_CHARACTER_REFERENCE(1000, 'e' _ 'p' _ 's' _ 'i' _ 'v' _ ';', 6, 0x03f5, 1)
NAMED_CHARACTER_REFERENCE(1001, 'e' _ 'q' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 7, 0x2256, 1)
NAMED_CHARACTER_REFERENCE(1002, 'e' _ 'q' _ 'c' _ 'o' _ 'l' _ 'o' _ 'n' _ ';', 8, 0x2255, 1)
NAMED_CHARACTER_REFERENCE(1003, 'e' _ 'q' _ 's' _ 'i' _ 'm' _ ';', 6, 0x2242, 1)
NAMED_CHARACTER_REFERENCE(1004, 'e' _ 'q' _ 's' _ 'l' _ 'a' _ 'n' _ 't' _ 'g' _ 't' _ 'r' _ ';', 11, 0x2a96, 1)
NAMED_CHARACTER_REFERENCE(1005, 'e' _ 'q' _ 's' _ 'l' _ 'a' _ 'n' _ 't' _ 'l' _ 'e' _ 's' _ 's' _ ';', 12, 0x2a95, 1)
NAMED_CHARACTER_REFERENCE(1006, 'e' _ 'q' _ 'u' _ 'a' _ 'l' _ 's' _ ';', 7, 0x003d, 1)
NAMED_CHARACTER_REFERENCE(1007, 'e' _ 'q' _ 'u' _ 'e' _ 's' _ 't' _ ';', 7, 0x225f, 1)
NAMED_CHARACTER_REFERENCE(1008, 'e' _ 'q' _ 'u' _ 'i' _ 'v' _ ';', 6, 0x2261, 1)
NAMED_CHARACTER_REFERENCE(1009, 'e' _ 'q' _ 'u' _ 'i' _ 'v' _ 'D' _ 'D' _ ';', 8, 0x2a78, 1)
NAMED_CHARACTER_REFERENCE(1010, 'e' _ 'q' _ 'v' _ 'p' _ 'a' _ 'r' _ 's' _ 'l' _ ';', 9, 0x29e5, 1)
NAMED_CHARACTER_REFERENCE(1011, 'e' _ 'r' _ 'D' _ 'o' _ 't' _ ';', 6, 0x2253, 1)
NAMED_CHARACTER_REFERENCE(1012, 'e' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2971, 1)
NAMED_CHARACTER_REFERENCE(1013, 'e' _ 's' _ 'c' _ 'r' _ ';', 5, 0x212f, 1)
NAMED_CHARACTER_REFERENCE(1014, 'e' _ 's' _ 'd' _ 'o' _ 't' _ ';', 6, 0x2250, 1)
NAMED_CHARACTER_REFERENCE(1015, 'e' _ 's' _ 'i' _ 'm' _ ';', 5, 0x2242, 1)
NAMED_CHARACTER_REFERENCE(1016, 'e' _ 't' _ 'a' _ ';', 4, 0x03b7, 1)
NAMED_CHARACTER_REFERENCE(1017, 'e' _ 't' _ 'h', 3, 0x00f0, 1)
NAMED_CHARACTER_REFERENCE(1018, 'e' _ 't' _ 'h' _ ';', 4, 0x00f0, 1)
NAMED_CHARACTER_REFERENCE(1019, 'e' _ 'u' _ 'm' _ 'l', 4, 0x00eb, 1)
NAMED_CHARACTER_REFERENCE(1020, 'e' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00eb, 1)
NAMED_CHARACTER_REFERENCE(1021, 'e' _ 'u' _ 'r' _ 'o' _ ';', 5, 0x20ac, 1)
NAMED_CHARACTER_REFERENCE(1022, 'e' _ 'x' _ 'c' _ 'l' _ ';', 5, 0x0021, 1)
NAMED_CHARACTER_REFERENCE(1023, 'e' _ 'x' _ 'i' _ 's' _ 't' _ ';', 6, 0x2203, 1)
NAMED_CHARACTER_REFERENCE(1024, 'e' _ 'x' _ 'p' _ 'e' _ 'c' _ 't' _ 'a' _ 't' _ 'i' _ 'o' _ 'n' _ ';', 12, 0x2130, 1)
NAMED_CHARACTER_REFERENCE(1025, 'e' _ 'x' _ 'p' _ 'o' _ 'n' _ 'e' _ 'n' _ 't' _ 'i' _ 'a' _ 'l' _ 'e' _ ';', 13, 0x2147, 1)
NAMED_CHARACTER_REFERENCE(1026, 'f' _ 'a' _ 'l' _ 'l' _ 'i' _ 'n' _ 'g' _ 'd' _ 'o' _ 't' _ 's' _ 'e' _ 'q' _ ';', 14, 0x2252, 1)
NAMED_CHARACTER_REFERENCE(1027, 'f' _ 'c' _ 'y' _ ';', 4, 0x0444, 1)
NAMED_CHARACTER_REFERENCE(1028, 'f' _ 'e' _ 'm' _ 'a' _ 'l' _ 'e' _ ';', 7, 0x2640, 1)
NAMED_CHARACTER_REFERENCE(1029, 'f' _ 'f' _ 'i' _ 'l' _ 'i' _ 'g' _ ';', 7, 0xfb03, 1)
NAMED_CHARACTER_REFERENCE(1030, 'f' _ 'f' _ 'l' _ 'i' _ 'g' _ ';', 6, 0xfb00, 1)
NAMED_CHARACTER_REFERENCE(1031, 'f' _ 'f' _ 'l' _ 'l' _ 'i' _ 'g' _ ';', 7, 0xfb04, 1)
NAMED_CHARACTER_REFERENCE(1032, 'f' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd23, 2)
NAMED_CHARACTER_REFERENCE(1033, 'f' _ 'i' _ 'l' _ 'i' _ 'g' _ ';', 6, 0xfb01, 1)
NAMED_CHARACTER_REFERENCE(1034, 'f' _ 'l' _ 'a' _ 't' _ ';', 5, 0x266d, 1)
NAMED_CHARACTER_REFERENCE(1035, 'f' _ 'l' _ 'l' _ 'i' _ 'g' _ ';', 6, 0xfb02, 1)
NAMED_CHARACTER_REFERENCE(1036, 'f' _ 'l' _ 't' _ 'n' _ 's' _ ';', 6, 0x25b1, 1)
NAMED_CHARACTER_REFERENCE(1037, 'f' _ 'n' _ 'o' _ 'f' _ ';', 5, 0x0192, 1)
NAMED_CHARACTER_REFERENCE(1038, 'f' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd57, 2)
NAMED_CHARACTER_REFERENCE(1039, 'f' _ 'o' _ 'r' _ 'a' _ 'l' _ 'l' _ ';', 7, 0x2200, 1)
NAMED_CHARACTER_REFERENCE(1040, 'f' _ 'o' _ 'r' _ 'k' _ ';', 5, 0x22d4, 1)
NAMED_CHARACTER_REFERENCE(1041, 'f' _ 'o' _ 'r' _ 'k' _ 'v' _ ';', 6, 0x2ad9, 1)
NAMED_CHARACTER_REFERENCE(1042, 'f' _ 'p' _ 'a' _ 'r' _ 't' _ 'i' _ 'n' _ 't' _ ';', 9, 0x2a0d, 1)
NAMED_CHARACTER_REFERENCE(1043, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '2', 6, 0x00bd, 1)
NAMED_CHARACTER_REFERENCE(1044, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '2' _ ';', 7, 0x00bd, 1)
NAMED_CHARACTER_REFERENCE(1045, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '3' _ ';', 7, 0x2153, 1)
NAMED_CHARACTER_REFERENCE(1046, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '4', 6, 0x00bc, 1)
NAMED_CHARACTER_REFERENCE(1047, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '4' _ ';', 7, 0x00bc, 1)
NAMED_CHARACTER_REFERENCE(1048, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '5' _ ';', 7, 0x2155, 1)
NAMED_CHARACTER_REFERENCE(1049, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '6' _ ';', 7, 0x2159, 1)
NAMED_CHARACTER_REFERENCE(1050, 'f' _ 'r' _ 'a' _ 'c' _ '1' _ '8' _ ';', 7, 0x215b, 1)
NAMED_CHARACTER_REFERENCE(1051, 'f' _ 'r' _ 'a' _ 'c' _ '2' _ '3' _ ';', 7, 0x2154, 1)
NAMED_CHARACTER_REFERENCE(1052, 'f' _ 'r' _ 'a' _ 'c' _ '2' _ '5' _ ';', 7, 0x2156, 1)
NAMED_CHARACTER_REFERENCE(1053, 'f' _ 'r' _ 'a' _ 'c' _ '3' _ '4', 6, 0x00be, 1)
NAMED_CHARACTER_REFERENCE(1054, 'f' _ 'r' _ 'a' _ 'c' _ '3' _ '4' _ ';', 7, 0x00be, 1)
NAMED_CHARACTER_REFERENCE(1055, 'f' _ 'r' _ 'a' _ 'c' _ '3' _ '5' _ ';', 7, 0x2157, 1)
NAMED_CHARACTER_REFERENCE(1056, 'f' _ 'r' _ 'a' _ 'c' _ '3' _ '8' _ ';', 7, 0x215c, 1)
NAMED_CHARACTER_REFERENCE(1057, 'f' _ 'r' _ 'a' _ 'c' _ '4' _ '5' _ ';', 7, 0x2158, 1)
NAMED_CHARACTER_REFERENCE(1058, 'f' _ 'r' _ 'a' _ 'c' _ '5' _ '6' _ ';', 7, 0x215a, 1)
NAMED_CHARACTER_REFERENCE(1059, 'f' _ 'r' _ 'a' _ 'c' _ '5' _ '8' _ ';', 7, 0x215d, 1)
NAMED_CHARACTER_REFERENCE(1060, 'f' _ 'r' _ 'a' _ 'c' _ '7' _ '8' _ ';', 7, 0x215e, 1)
NAMED_CHARACTER_REFERENCE(1061, 'f' _ 'r' _ 'a' _ 's' _ 'l' _ ';', 6, 0x2044, 1)
NAMED_CHARACTER_REFERENCE(1062, 'f' _ 'r' _ 'o' _ 'w' _ 'n' _ ';', 6, 0x2322, 1)
NAMED_CHARACTER_REFERENCE(1063, 'f' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcbb, 2)
NAMED_CHARACTER_REFERENCE(1064, 'g' _ 'E' _ ';', 3, 0x2267, 1)
NAMED_CHARACTER_REFERENCE(1065, 'g' _ 'E' _ 'l' _ ';', 4, 0x2a8c, 1)
NAMED_CHARACTER_REFERENCE(1066, 'g' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x01f5, 1)
NAMED_CHARACTER_REFERENCE(1067, 'g' _ 'a' _ 'm' _ 'm' _ 'a' _ ';', 6, 0x03b3, 1)
NAMED_CHARACTER_REFERENCE(1068, 'g' _ 'a' _ 'm' _ 'm' _ 'a' _ 'd' _ ';', 7, 0x03dd, 1)
NAMED_CHARACTER_REFERENCE(1069, 'g' _ 'a' _ 'p' _ ';', 4, 0x2a86, 1)
NAMED_CHARACTER_REFERENCE(1070, 'g' _ 'b' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 7, 0x011f, 1)
NAMED_CHARACTER_REFERENCE(1071, 'g' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x011d, 1)
NAMED_CHARACTER_REFERENCE(1072, 'g' _ 'c' _ 'y' _ ';', 4, 0x0433, 1)
NAMED_CHARACTER_REFERENCE(1073, 'g' _ 'd' _ 'o' _ 't' _ ';', 5, 0x0121, 1)
NAMED_CHARACTER_REFERENCE(1074, 'g' _ 'e' _ ';', 3, 0x2265, 1)
NAMED_CHARACTER_REFERENCE(1075, 'g' _ 'e' _ 'l' _ ';', 4, 0x22db, 1)
NAMED_CHARACTER_REFERENCE(1076, 'g' _ 'e' _ 'q' _ ';', 4, 0x2265, 1)
NAMED_CHARACTER_REFERENCE(1077, 'g' _ 'e' _ 'q' _ 'q' _ ';', 5, 0x2267, 1)
NAMED_CHARACTER_REFERENCE(1078, 'g' _ 'e' _ 'q' _ 's' _ 'l' _ 'a' _ 'n' _ 't' _ ';', 9, 0x2a7e, 1)
NAMED_CHARACTER_REFERENCE(1079, 'g' _ 'e' _ 's' _ ';', 4, 0x2a7e, 1)
NAMED_CHARACTER_REFERENCE(1080, 'g' _ 'e' _ 's' _ 'c' _ 'c' _ ';', 6, 0x2aa9, 1)
NAMED_CHARACTER_REFERENCE(1081, 'g' _ 'e' _ 's' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2a80, 1)
NAMED_CHARACTER_REFERENCE(1082, 'g' _ 'e' _ 's' _ 'd' _ 'o' _ 't' _ 'o' _ ';', 8, 0x2a82, 1)
NAMED_CHARACTER_REFERENCE(1083, 'g' _ 'e' _ 's' _ 'd' _ 'o' _ 't' _ 'o' _ 'l' _ ';', 9, 0x2a84, 1)
NAMED_CHARACTER_REFERENCE(1084, 'g' _ 'e' _ 's' _ 'l' _ 'e' _ 's' _ ';', 7, 0x2a94, 1)
NAMED_CHARACTER_REFERENCE(1085, 'g' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd24, 2)
NAMED_CHARACTER_REFERENCE(1086, 'g' _ 'g' _ ';', 3, 0x226b, 1)
NAMED_CHARACTER_REFERENCE(1087, 'g' _ 'g' _ 'g' _ ';', 4, 0x22d9, 1)
NAMED_CHARACTER_REFERENCE(1088, 'g' _ 'i' _ 'm' _ 'e' _ 'l' _ ';', 6, 0x2137, 1)
NAMED_CHARACTER_REFERENCE(1089, 'g' _ 'j' _ 'c' _ 'y' _ ';', 5, 0x0453, 1)
NAMED_CHARACTER_REFERENCE(1090, 'g' _ 'l' _ ';', 3, 0x2277, 1)
NAMED_CHARACTER_REFERENCE(1091, 'g' _ 'l' _ 'E' _ ';', 4, 0x2a92, 1)
NAMED_CHARACTER_REFERENCE(1092, 'g' _ 'l' _ 'a' _ ';', 4, 0x2aa5, 1)
NAMED_CHARACTER_REFERENCE(1093, 'g' _ 'l' _ 'j' _ ';', 4, 0x2aa4, 1)
NAMED_CHARACTER_REFERENCE(1094, 'g' _ 'n' _ 'E' _ ';', 4, 0x2269, 1)
NAMED_CHARACTER_REFERENCE(1095, 'g' _ 'n' _ 'a' _ 'p' _ ';', 5, 0x2a8a, 1)
NAMED_CHARACTER_REFERENCE(1096, 'g' _ 'n' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 9, 0x2a8a, 1)
NAMED_CHARACTER_REFERENCE(1097, 'g' _ 'n' _ 'e' _ ';', 4, 0x2a88, 1)
NAMED_CHARACTER_REFERENCE(1098, 'g' _ 'n' _ 'e' _ 'q' _ ';', 5, 0x2a88, 1)
NAMED_CHARACTER_REFERENCE(1099, 'g' _ 'n' _ 'e' _ 'q' _ 'q' _ ';', 6, 0x2269, 1)
NAMED_CHARACTER_REFERENCE(1100, 'g' _ 'n' _ 's' _ 'i' _ 'm' _ ';', 6, 0x22e7, 1)
NAMED_CHARACTER_REFERENCE(1101, 'g' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd58, 2)
NAMED_CHARACTER_REFERENCE(1102, 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 6, 0x0060, 1)
NAMED_CHARACTER_REFERENCE(1103, 'g' _ 's' _ 'c' _ 'r' _ ';', 5, 0x210a, 1)
NAMED_CHARACTER_REFERENCE(1104, 'g' _ 's' _ 'i' _ 'm' _ ';', 5, 0x2273, 1)
NAMED_CHARACTER_REFERENCE(1105, 'g' _ 's' _ 'i' _ 'm' _ 'e' _ ';', 6, 0x2a8e, 1)
NAMED_CHARACTER_REFERENCE(1106, 'g' _ 's' _ 'i' _ 'm' _ 'l' _ ';', 6, 0x2a90, 1)
NAMED_CHARACTER_REFERENCE(1107, 'g' _ 't', 2, 0x003e, 1)
NAMED_CHARACTER_REFERENCE(1108, 'g' _ 't' _ ';', 3, 0x003e, 1)
NAMED_CHARACTER_REFERENCE(1109, 'g' _ 't' _ 'c' _ 'c' _ ';', 5, 0x2aa7, 1)
NAMED_CHARACTER_REFERENCE(1110, 'g' _ 't' _ 'c' _ 'i' _ 'r' _ ';', 6, 0x2a7a, 1)
NAMED_CHARACTER_REFERENCE(1111, 'g' _ 't' _ 'd' _ 'o' _ 't' _ ';', 6, 0x22d7, 1)
NAMED_CHARACTER_REFERENCE(1112, 'g' _ 't' _ 'l' _ 'P' _ 'a' _ 'r' _ ';', 7, 0x2995, 1)
NAMED_CHARACTER_REFERENCE(1113, 'g' _ 't' _ 'q' _ 'u' _ 'e' _ 's' _ 't' _ ';', 8, 0x2a7c, 1)
NAMED_CHARACTER_REFERENCE(1114, 'g' _ 't' _ 'r' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 10, 0x2a86, 1)
NAMED_CHARACTER_REFERENCE(1115, 'g' _ 't' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 7, 0x2978, 1)
NAMED_CHARACTER_REFERENCE(1116, 'g' _ 't' _ 'r' _ 'd' _ 'o' _ 't' _ ';', 7, 0x22d7, 1)
NAMED_CHARACTER_REFERENCE(1117, 'g' _ 't' _ 'r' _ 'e' _ 'q' _ 'l' _ 'e' _ 's' _ 's' _ ';', 10, 0x22db, 1)
NAMED_CHARACTER_REFERENCE(1118, 'g' _ 't' _ 'r' _ 'e' _ 'q' _ 'q' _ 'l' _ 'e' _ 's' _ 's' _ ';', 11, 0x2a8c, 1)
NAMED_CHARACTER_REFERENCE(1119, 'g' _ 't' _ 'r' _ 'l' _ 'e' _ 's' _ 's' _ ';', 8, 0x2277, 1)
NAMED_CHARACTER_REFERENCE(1120, 'g' _ 't' _ 'r' _ 's' _ 'i' _ 'm' _ ';', 7, 0x2273, 1)
NAMED_CHARACTER_REFERENCE(1121, 'h' _ 'A' _ 'r' _ 'r' _ ';', 5, 0x21d4, 1)
NAMED_CHARACTER_REFERENCE(1122, 'h' _ 'a' _ 'i' _ 'r' _ 's' _ 'p' _ ';', 7, 0x200a, 1)
NAMED_CHARACTER_REFERENCE(1123, 'h' _ 'a' _ 'l' _ 'f' _ ';', 5, 0x00bd, 1)
NAMED_CHARACTER_REFERENCE(1124, 'h' _ 'a' _ 'm' _ 'i' _ 'l' _ 't' _ ';', 7, 0x210b, 1)
NAMED_CHARACTER_REFERENCE(1125, 'h' _ 'a' _ 'r' _ 'd' _ 'c' _ 'y' _ ';', 7, 0x044a, 1)
NAMED_CHARACTER_REFERENCE(1126, 'h' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x2194, 1)
NAMED_CHARACTER_REFERENCE(1127, 'h' _ 'a' _ 'r' _ 'r' _ 'c' _ 'i' _ 'r' _ ';', 8, 0x2948, 1)
NAMED_CHARACTER_REFERENCE(1128, 'h' _ 'a' _ 'r' _ 'r' _ 'w' _ ';', 6, 0x21ad, 1)
NAMED_CHARACTER_REFERENCE(1129, 'h' _ 'b' _ 'a' _ 'r' _ ';', 5, 0x210f, 1)
NAMED_CHARACTER_REFERENCE(1130, 'h' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0125, 1)
NAMED_CHARACTER_REFERENCE(1131, 'h' _ 'e' _ 'a' _ 'r' _ 't' _ 's' _ ';', 7, 0x2665, 1)
NAMED_CHARACTER_REFERENCE(1132, 'h' _ 'e' _ 'a' _ 'r' _ 't' _ 's' _ 'u' _ 'i' _ 't' _ ';', 10, 0x2665, 1)
NAMED_CHARACTER_REFERENCE(1133, 'h' _ 'e' _ 'l' _ 'l' _ 'i' _ 'p' _ ';', 7, 0x2026, 1)
NAMED_CHARACTER_REFERENCE(1134, 'h' _ 'e' _ 'r' _ 'c' _ 'o' _ 'n' _ ';', 7, 0x22b9, 1)
NAMED_CHARACTER_REFERENCE(1135, 'h' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd25, 2)
NAMED_CHARACTER_REFERENCE(1136, 'h' _ 'k' _ 's' _ 'e' _ 'a' _ 'r' _ 'o' _ 'w' _ ';', 9, 0x2925, 1)
NAMED_CHARACTER_REFERENCE(1137, 'h' _ 'k' _ 's' _ 'w' _ 'a' _ 'r' _ 'o' _ 'w' _ ';', 9, 0x2926, 1)
NAMED_CHARACTER_REFERENCE(1138, 'h' _ 'o' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21ff, 1)
NAMED_CHARACTER_REFERENCE(1139, 'h' _ 'o' _ 'm' _ 't' _ 'h' _ 't' _ ';', 7, 0x223b, 1)
NAMED_CHARACTER_REFERENCE(1140, 'h' _ 'o' _ 'o' _ 'k' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 14, 0x21a9, 1)
NAMED_CHARACTER_REFERENCE(1141, 'h' _ 'o' _ 'o' _ 'k' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x21aa, 1)
NAMED_CHARACTER_REFERENCE(1142, 'h' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd59, 2)
NAMED_CHARACTER_REFERENCE(1143, 'h' _ 'o' _ 'r' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x2015, 1)
NAMED_CHARACTER_REFERENCE(1144, 'h' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcbd, 2)
NAMED_CHARACTER_REFERENCE(1145, 'h' _ 's' _ 'l' _ 'a' _ 's' _ 'h' _ ';', 7, 0x210f, 1)
NAMED_CHARACTER_REFERENCE(1146, 'h' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0127, 1)
NAMED_CHARACTER_REFERENCE(1147, 'h' _ 'y' _ 'b' _ 'u' _ 'l' _ 'l' _ ';', 7, 0x2043, 1)
NAMED_CHARACTER_REFERENCE(1148, 'h' _ 'y' _ 'p' _ 'h' _ 'e' _ 'n' _ ';', 7, 0x2010, 1)
NAMED_CHARACTER_REFERENCE(1149, 'i' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00ed, 1)
NAMED_CHARACTER_REFERENCE(1150, 'i' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00ed, 1)
NAMED_CHARACTER_REFERENCE(1151, 'i' _ 'c' _ ';', 3, 0x2063, 1)
NAMED_CHARACTER_REFERENCE(1152, 'i' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00ee, 1)
NAMED_CHARACTER_REFERENCE(1153, 'i' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00ee, 1)
NAMED_CHARACTER_REFERENCE(1154, 'i' _ 'c' _ 'y' _ ';', 4, 0x0438, 1)
NAMED_CHARACTER_REFERENCE(1155, 'i' _ 'e' _ 'c' _ 'y' _ ';', 5, 0x0435, 1)
NAMED_CHARACTER_REFERENCE(1156, 'i' _ 'e' _ 'x' _ 'c' _ 'l', 5, 0x00a1, 1)
NAMED_CHARACTER_REFERENCE(1157, 'i' _ 'e' _ 'x' _ 'c' _ 'l' _ ';', 6, 0x00a1, 1)
NAMED_CHARACTER_REFERENCE(1158, 'i' _ 'f' _ 'f' _ ';', 4, 0x21d4, 1)
NAMED_CHARACTER_REFERENCE(1159, 'i' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd26, 2)
NAMED_CHARACTER_REFERENCE(1160, 'i' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00ec, 1)
NAMED_CHARACTER_REFERENCE(1161, 'i' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00ec, 1)
NAMED_CHARACTER_REFERENCE(1162, 'i' _ 'i' _ ';', 3, 0x2148, 1)
NAMED_CHARACTER_REFERENCE(1163, 'i' _ 'i' _ 'i' _ 'i' _ 'n' _ 't' _ ';', 7, 0x2a0c, 1)
NAMED_CHARACTER_REFERENCE(1164, 'i' _ 'i' _ 'i' _ 'n' _ 't' _ ';', 6, 0x222d, 1)
NAMED_CHARACTER_REFERENCE(1165, 'i' _ 'i' _ 'n' _ 'f' _ 'i' _ 'n' _ ';', 7, 0x29dc, 1)
NAMED_CHARACTER_REFERENCE(1166, 'i' _ 'i' _ 'o' _ 't' _ 'a' _ ';', 6, 0x2129, 1)
NAMED_CHARACTER_REFERENCE(1167, 'i' _ 'j' _ 'l' _ 'i' _ 'g' _ ';', 6, 0x0133, 1)
NAMED_CHARACTER_REFERENCE(1168, 'i' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x012b, 1)
NAMED_CHARACTER_REFERENCE(1169, 'i' _ 'm' _ 'a' _ 'g' _ 'e' _ ';', 6, 0x2111, 1)
NAMED_CHARACTER_REFERENCE(1170, 'i' _ 'm' _ 'a' _ 'g' _ 'l' _ 'i' _ 'n' _ 'e' _ ';', 9, 0x2110, 1)
NAMED_CHARACTER_REFERENCE(1171, 'i' _ 'm' _ 'a' _ 'g' _ 'p' _ 'a' _ 'r' _ 't' _ ';', 9, 0x2111, 1)
NAMED_CHARACTER_REFERENCE(1172, 'i' _ 'm' _ 'a' _ 't' _ 'h' _ ';', 6, 0x0131, 1)
NAMED_CHARACTER_REFERENCE(1173, 'i' _ 'm' _ 'o' _ 'f' _ ';', 5, 0x22b7, 1)
NAMED_CHARACTER_REFERENCE(1174, 'i' _ 'm' _ 'p' _ 'e' _ 'd' _ ';', 6, 0x01b5, 1)
NAMED_CHARACTER_REFERENCE(1175, 'i' _ 'n' _ ';', 3, 0x2208, 1)
NAMED_CHARACTER_REFERENCE(1176, 'i' _ 'n' _ 'c' _ 'a' _ 'r' _ 'e' _ ';', 7, 0x2105, 1)
NAMED_CHARACTER_REFERENCE(1177, 'i' _ 'n' _ 'f' _ 'i' _ 'n' _ ';', 6, 0x221e, 1)
NAMED_CHARACTER_REFERENCE(1178, 'i' _ 'n' _ 'f' _ 'i' _ 'n' _ 't' _ 'i' _ 'e' _ ';', 9, 0x29dd, 1)
NAMED_CHARACTER_REFERENCE(1179, 'i' _ 'n' _ 'o' _ 'd' _ 'o' _ 't' _ ';', 7, 0x0131, 1)
NAMED_CHARACTER_REFERENCE(1180, 'i' _ 'n' _ 't' _ ';', 4, 0x222b, 1)
NAMED_CHARACTER_REFERENCE(1181, 'i' _ 'n' _ 't' _ 'c' _ 'a' _ 'l' _ ';', 7, 0x22ba, 1)
NAMED_CHARACTER_REFERENCE(1182, 'i' _ 'n' _ 't' _ 'e' _ 'g' _ 'e' _ 'r' _ 's' _ ';', 9, 0x2124, 1)
NAMED_CHARACTER_REFERENCE(1183, 'i' _ 'n' _ 't' _ 'e' _ 'r' _ 'c' _ 'a' _ 'l' _ ';', 9, 0x22ba, 1)
NAMED_CHARACTER_REFERENCE(1184, 'i' _ 'n' _ 't' _ 'l' _ 'a' _ 'r' _ 'h' _ 'k' _ ';', 9, 0x2a17, 1)
NAMED_CHARACTER_REFERENCE(1185, 'i' _ 'n' _ 't' _ 'p' _ 'r' _ 'o' _ 'd' _ ';', 8, 0x2a3c, 1)
NAMED_CHARACTER_REFERENCE(1186, 'i' _ 'o' _ 'c' _ 'y' _ ';', 5, 0x0451, 1)
NAMED_CHARACTER_REFERENCE(1187, 'i' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x012f, 1)
NAMED_CHARACTER_REFERENCE(1188, 'i' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd5a, 2)
NAMED_CHARACTER_REFERENCE(1189, 'i' _ 'o' _ 't' _ 'a' _ ';', 5, 0x03b9, 1)
NAMED_CHARACTER_REFERENCE(1190, 'i' _ 'p' _ 'r' _ 'o' _ 'd' _ ';', 6, 0x2a3c, 1)
NAMED_CHARACTER_REFERENCE(1191, 'i' _ 'q' _ 'u' _ 'e' _ 's' _ 't', 6, 0x00bf, 1)
NAMED_CHARACTER_REFERENCE(1192, 'i' _ 'q' _ 'u' _ 'e' _ 's' _ 't' _ ';', 7, 0x00bf, 1)
NAMED_CHARACTER_REFERENCE(1193, 'i' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcbe, 2)
NAMED_CHARACTER_REFERENCE(1194, 'i' _ 's' _ 'i' _ 'n' _ ';', 5, 0x2208, 1)
NAMED_CHARACTER_REFERENCE(1195, 'i' _ 's' _ 'i' _ 'n' _ 'E' _ ';', 6, 0x22f9, 1)
NAMED_CHARACTER_REFERENCE(1196, 'i' _ 's' _ 'i' _ 'n' _ 'd' _ 'o' _ 't' _ ';', 8, 0x22f5, 1)
NAMED_CHARACTER_REFERENCE(1197, 'i' _ 's' _ 'i' _ 'n' _ 's' _ ';', 6, 0x22f4, 1)
NAMED_CHARACTER_REFERENCE(1198, 'i' _ 's' _ 'i' _ 'n' _ 's' _ 'v' _ ';', 7, 0x22f3, 1)
NAMED_CHARACTER_REFERENCE(1199, 'i' _ 's' _ 'i' _ 'n' _ 'v' _ ';', 6, 0x2208, 1)
NAMED_CHARACTER_REFERENCE(1200, 'i' _ 't' _ ';', 3, 0x2062, 1)
NAMED_CHARACTER_REFERENCE(1201, 'i' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x0129, 1)
NAMED_CHARACTER_REFERENCE(1202, 'i' _ 'u' _ 'k' _ 'c' _ 'y' _ ';', 6, 0x0456, 1)
NAMED_CHARACTER_REFERENCE(1203, 'i' _ 'u' _ 'm' _ 'l', 4, 0x00ef, 1)
NAMED_CHARACTER_REFERENCE(1204, 'i' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00ef, 1)
NAMED_CHARACTER_REFERENCE(1205, 'j' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0135, 1)
NAMED_CHARACTER_REFERENCE(1206, 'j' _ 'c' _ 'y' _ ';', 4, 0x0439, 1)
NAMED_CHARACTER_REFERENCE(1207, 'j' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd27, 2)
NAMED_CHARACTER_REFERENCE(1208, 'j' _ 'm' _ 'a' _ 't' _ 'h' _ ';', 6, 0x0237, 1)
NAMED_CHARACTER_REFERENCE(1209, 'j' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd5b, 2)
NAMED_CHARACTER_REFERENCE(1210, 'j' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcbf, 2)
NAMED_CHARACTER_REFERENCE(1211, 'j' _ 's' _ 'e' _ 'r' _ 'c' _ 'y' _ ';', 7, 0x0458, 1)
NAMED_CHARACTER_REFERENCE(1212, 'j' _ 'u' _ 'k' _ 'c' _ 'y' _ ';', 6, 0x0454, 1)
NAMED_CHARACTER_REFERENCE(1213, 'k' _ 'a' _ 'p' _ 'p' _ 'a' _ ';', 6, 0x03ba, 1)
NAMED_CHARACTER_REFERENCE(1214, 'k' _ 'a' _ 'p' _ 'p' _ 'a' _ 'v' _ ';', 7, 0x03f0, 1)
NAMED_CHARACTER_REFERENCE(1215, 'k' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0137, 1)
NAMED_CHARACTER_REFERENCE(1216, 'k' _ 'c' _ 'y' _ ';', 4, 0x043a, 1)
NAMED_CHARACTER_REFERENCE(1217, 'k' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd28, 2)
NAMED_CHARACTER_REFERENCE(1218, 'k' _ 'g' _ 'r' _ 'e' _ 'e' _ 'n' _ ';', 7, 0x0138, 1)
NAMED_CHARACTER_REFERENCE(1219, 'k' _ 'h' _ 'c' _ 'y' _ ';', 5, 0x0445, 1)
NAMED_CHARACTER_REFERENCE(1220, 'k' _ 'j' _ 'c' _ 'y' _ ';', 5, 0x045c, 1)
NAMED_CHARACTER_REFERENCE(1221, 'k' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd5c, 2)
NAMED_CHARACTER_REFERENCE(1222, 'k' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc0, 2)
NAMED_CHARACTER_REFERENCE(1223, 'l' _ 'A' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21da, 1)
NAMED_CHARACTER_REFERENCE(1224, 'l' _ 'A' _ 'r' _ 'r' _ ';', 5, 0x21d0, 1)
NAMED_CHARACTER_REFERENCE(1225, 'l' _ 'A' _ 't' _ 'a' _ 'i' _ 'l' _ ';', 7, 0x291b, 1)
NAMED_CHARACTER_REFERENCE(1226, 'l' _ 'B' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x290e, 1)
NAMED_CHARACTER_REFERENCE(1227, 'l' _ 'E' _ ';', 3, 0x2266, 1)
NAMED_CHARACTER_REFERENCE(1228, 'l' _ 'E' _ 'g' _ ';', 4, 0x2a8b, 1)
NAMED_CHARACTER_REFERENCE(1229, 'l' _ 'H' _ 'a' _ 'r' _ ';', 5, 0x2962, 1)
NAMED_CHARACTER_REFERENCE(1230, 'l' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x013a, 1)
NAMED_CHARACTER_REFERENCE(1231, 'l' _ 'a' _ 'e' _ 'm' _ 'p' _ 't' _ 'y' _ 'v' _ ';', 9, 0x29b4, 1)
NAMED_CHARACTER_REFERENCE(1232, 'l' _ 'a' _ 'g' _ 'r' _ 'a' _ 'n' _ ';', 7, 0x2112, 1)
NAMED_CHARACTER_REFERENCE(1233, 'l' _ 'a' _ 'm' _ 'b' _ 'd' _ 'a' _ ';', 7, 0x03bb, 1)
NAMED_CHARACTER_REFERENCE(1234, 'l' _ 'a' _ 'n' _ 'g' _ ';', 5, 0x27e8, 1)
NAMED_CHARACTER_REFERENCE(1235, 'l' _ 'a' _ 'n' _ 'g' _ 'd' _ ';', 6, 0x2991, 1)
NAMED_CHARACTER_REFERENCE(1236, 'l' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 7, 0x27e8, 1)
NAMED_CHARACTER_REFERENCE(1237, 'l' _ 'a' _ 'p' _ ';', 4, 0x2a85, 1)
NAMED_CHARACTER_REFERENCE(1238, 'l' _ 'a' _ 'q' _ 'u' _ 'o', 5, 0x00ab, 1)
NAMED_CHARACTER_REFERENCE(1239, 'l' _ 'a' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x00ab, 1)
NAMED_CHARACTER_REFERENCE(1240, 'l' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x2190, 1)
NAMED_CHARACTER_REFERENCE(1241, 'l' _ 'a' _ 'r' _ 'r' _ 'b' _ ';', 6, 0x21e4, 1)
NAMED_CHARACTER_REFERENCE(1242, 'l' _ 'a' _ 'r' _ 'r' _ 'b' _ 'f' _ 's' _ ';', 8, 0x291f, 1)
NAMED_CHARACTER_REFERENCE(1243, 'l' _ 'a' _ 'r' _ 'r' _ 'f' _ 's' _ ';', 7, 0x291d, 1)
NAMED_CHARACTER_REFERENCE(1244, 'l' _ 'a' _ 'r' _ 'r' _ 'h' _ 'k' _ ';', 7, 0x21a9, 1)
NAMED_CHARACTER_REFERENCE(1245, 'l' _ 'a' _ 'r' _ 'r' _ 'l' _ 'p' _ ';', 7, 0x21ab, 1)
NAMED_CHARACTER_REFERENCE(1246, 'l' _ 'a' _ 'r' _ 'r' _ 'p' _ 'l' _ ';', 7, 0x2939, 1)
NAMED_CHARACTER_REFERENCE(1247, 'l' _ 'a' _ 'r' _ 'r' _ 's' _ 'i' _ 'm' _ ';', 8, 0x2973, 1)
NAMED_CHARACTER_REFERENCE(1248, 'l' _ 'a' _ 'r' _ 'r' _ 't' _ 'l' _ ';', 7, 0x21a2, 1)
NAMED_CHARACTER_REFERENCE(1249, 'l' _ 'a' _ 't' _ ';', 4, 0x2aab, 1)
NAMED_CHARACTER_REFERENCE(1250, 'l' _ 'a' _ 't' _ 'a' _ 'i' _ 'l' _ ';', 7, 0x2919, 1)
NAMED_CHARACTER_REFERENCE(1251, 'l' _ 'a' _ 't' _ 'e' _ ';', 5, 0x2aad, 1)
NAMED_CHARACTER_REFERENCE(1252, 'l' _ 'b' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x290c, 1)
NAMED_CHARACTER_REFERENCE(1253, 'l' _ 'b' _ 'b' _ 'r' _ 'k' _ ';', 6, 0x2772, 1)
NAMED_CHARACTER_REFERENCE(1254, 'l' _ 'b' _ 'r' _ 'a' _ 'c' _ 'e' _ ';', 7, 0x007b, 1)
NAMED_CHARACTER_REFERENCE(1255, 'l' _ 'b' _ 'r' _ 'a' _ 'c' _ 'k' _ ';', 7, 0x005b, 1)
NAMED_CHARACTER_REFERENCE(1256, 'l' _ 'b' _ 'r' _ 'k' _ 'e' _ ';', 6, 0x298b, 1)
NAMED_CHARACTER_REFERENCE(1257, 'l' _ 'b' _ 'r' _ 'k' _ 's' _ 'l' _ 'd' _ ';', 8, 0x298f, 1)
NAMED_CHARACTER_REFERENCE(1258, 'l' _ 'b' _ 'r' _ 'k' _ 's' _ 'l' _ 'u' _ ';', 8, 0x298d, 1)
NAMED_CHARACTER_REFERENCE(1259, 'l' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x013e, 1)
NAMED_CHARACTER_REFERENCE(1260, 'l' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x013c, 1)
NAMED_CHARACTER_REFERENCE(1261, 'l' _ 'c' _ 'e' _ 'i' _ 'l' _ ';', 6, 0x2308, 1)
NAMED_CHARACTER_REFERENCE(1262, 'l' _ 'c' _ 'u' _ 'b' _ ';', 5, 0x007b, 1)
NAMED_CHARACTER_REFERENCE(1263, 'l' _ 'c' _ 'y' _ ';', 4, 0x043b, 1)
NAMED_CHARACTER_REFERENCE(1264, 'l' _ 'd' _ 'c' _ 'a' _ ';', 5, 0x2936, 1)
NAMED_CHARACTER_REFERENCE(1265, 'l' _ 'd' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x201c, 1)
NAMED_CHARACTER_REFERENCE(1266, 'l' _ 'd' _ 'q' _ 'u' _ 'o' _ 'r' _ ';', 7, 0x201e, 1)
NAMED_CHARACTER_REFERENCE(1267, 'l' _ 'd' _ 'r' _ 'd' _ 'h' _ 'a' _ 'r' _ ';', 8, 0x2967, 1)
NAMED_CHARACTER_REFERENCE(1268, 'l' _ 'd' _ 'r' _ 'u' _ 's' _ 'h' _ 'a' _ 'r' _ ';', 9, 0x294b, 1)
NAMED_CHARACTER_REFERENCE(1269, 'l' _ 'd' _ 's' _ 'h' _ ';', 5, 0x21b2, 1)
NAMED_CHARACTER_REFERENCE(1270, 'l' _ 'e' _ ';', 3, 0x2264, 1)
NAMED_CHARACTER_REFERENCE(1271, 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 10, 0x2190, 1)
NAMED_CHARACTER_REFERENCE(1272, 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 't' _ 'a' _ 'i' _ 'l' _ ';', 14, 0x21a2, 1)
NAMED_CHARACTER_REFERENCE(1273, 'l' _ 'e' _ 'f' _ 't' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'd' _ 'o' _ 'w' _ 'n' _ ';', 16, 0x21bd, 1)
NAMED_CHARACTER_REFERENCE(1274, 'l' _ 'e' _ 'f' _ 't' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'u' _ 'p' _ ';', 14, 0x21bc, 1)
NAMED_CHARACTER_REFERENCE(1275, 'l' _ 'e' _ 'f' _ 't' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 's' _ ';', 15, 0x21c7, 1)
NAMED_CHARACTER_REFERENCE(1276, 'l' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x2194, 1)
NAMED_CHARACTER_REFERENCE(1277, 'l' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 's' _ ';', 16, 0x21c6, 1)
NAMED_CHARACTER_REFERENCE(1278, 'l' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 's' _ ';', 18, 0x21cb, 1)
NAMED_CHARACTER_REFERENCE(1279, 'l' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 's' _ 'q' _ 'u' _ 'i' _ 'g' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 20, 0x21ad, 1)
NAMED_CHARACTER_REFERENCE(1280, 'l' _ 'e' _ 'f' _ 't' _ 't' _ 'h' _ 'r' _ 'e' _ 'e' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 15, 0x22cb, 1)
NAMED_CHARACTER_REFERENCE(1281, 'l' _ 'e' _ 'g' _ ';', 4, 0x22da, 1)
NAMED_CHARACTER_REFERENCE(1282, 'l' _ 'e' _ 'q' _ ';', 4, 0x2264, 1)
NAMED_CHARACTER_REFERENCE(1283, 'l' _ 'e' _ 'q' _ 'q' _ ';', 5, 0x2266, 1)
NAMED_CHARACTER_REFERENCE(1284, 'l' _ 'e' _ 'q' _ 's' _ 'l' _ 'a' _ 'n' _ 't' _ ';', 9, 0x2a7d, 1)
NAMED_CHARACTER_REFERENCE(1285, 'l' _ 'e' _ 's' _ ';', 4, 0x2a7d, 1)
NAMED_CHARACTER_REFERENCE(1286, 'l' _ 'e' _ 's' _ 'c' _ 'c' _ ';', 6, 0x2aa8, 1)
NAMED_CHARACTER_REFERENCE(1287, 'l' _ 'e' _ 's' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2a7f, 1)
NAMED_CHARACTER_REFERENCE(1288, 'l' _ 'e' _ 's' _ 'd' _ 'o' _ 't' _ 'o' _ ';', 8, 0x2a81, 1)
NAMED_CHARACTER_REFERENCE(1289, 'l' _ 'e' _ 's' _ 'd' _ 'o' _ 't' _ 'o' _ 'r' _ ';', 9, 0x2a83, 1)
NAMED_CHARACTER_REFERENCE(1290, 'l' _ 'e' _ 's' _ 'g' _ 'e' _ 's' _ ';', 7, 0x2a93, 1)
NAMED_CHARACTER_REFERENCE(1291, 'l' _ 'e' _ 's' _ 's' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 11, 0x2a85, 1)
NAMED_CHARACTER_REFERENCE(1292, 'l' _ 'e' _ 's' _ 's' _ 'd' _ 'o' _ 't' _ ';', 8, 0x22d6, 1)
NAMED_CHARACTER_REFERENCE(1293, 'l' _ 'e' _ 's' _ 's' _ 'e' _ 'q' _ 'g' _ 't' _ 'r' _ ';', 10, 0x22da, 1)
NAMED_CHARACTER_REFERENCE(1294, 'l' _ 'e' _ 's' _ 's' _ 'e' _ 'q' _ 'q' _ 'g' _ 't' _ 'r' _ ';', 11, 0x2a8b, 1)
NAMED_CHARACTER_REFERENCE(1295, 'l' _ 'e' _ 's' _ 's' _ 'g' _ 't' _ 'r' _ ';', 8, 0x2276, 1)
NAMED_CHARACTER_REFERENCE(1296, 'l' _ 'e' _ 's' _ 's' _ 's' _ 'i' _ 'm' _ ';', 8, 0x2272, 1)
NAMED_CHARACTER_REFERENCE(1297, 'l' _ 'f' _ 'i' _ 's' _ 'h' _ 't' _ ';', 7, 0x297c, 1)
NAMED_CHARACTER_REFERENCE(1298, 'l' _ 'f' _ 'l' _ 'o' _ 'o' _ 'r' _ ';', 7, 0x230a, 1)
NAMED_CHARACTER_REFERENCE(1299, 'l' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd29, 2)
NAMED_CHARACTER_REFERENCE(1300, 'l' _ 'g' _ ';', 3, 0x2276, 1)
NAMED_CHARACTER_REFERENCE(1301, 'l' _ 'g' _ 'E' _ ';', 4, 0x2a91, 1)
NAMED_CHARACTER_REFERENCE(1302, 'l' _ 'h' _ 'a' _ 'r' _ 'd' _ ';', 6, 0x21bd, 1)
NAMED_CHARACTER_REFERENCE(1303, 'l' _ 'h' _ 'a' _ 'r' _ 'u' _ ';', 6, 0x21bc, 1)
NAMED_CHARACTER_REFERENCE(1304, 'l' _ 'h' _ 'a' _ 'r' _ 'u' _ 'l' _ ';', 7, 0x296a, 1)
NAMED_CHARACTER_REFERENCE(1305, 'l' _ 'h' _ 'b' _ 'l' _ 'k' _ ';', 6, 0x2584, 1)
NAMED_CHARACTER_REFERENCE(1306, 'l' _ 'j' _ 'c' _ 'y' _ ';', 5, 0x0459, 1)
NAMED_CHARACTER_REFERENCE(1307, 'l' _ 'l' _ ';', 3, 0x226a, 1)
NAMED_CHARACTER_REFERENCE(1308, 'l' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21c7, 1)
NAMED_CHARACTER_REFERENCE(1309, 'l' _ 'l' _ 'c' _ 'o' _ 'r' _ 'n' _ 'e' _ 'r' _ ';', 9, 0x231e, 1)
NAMED_CHARACTER_REFERENCE(1310, 'l' _ 'l' _ 'h' _ 'a' _ 'r' _ 'd' _ ';', 7, 0x296b, 1)
NAMED_CHARACTER_REFERENCE(1311, 'l' _ 'l' _ 't' _ 'r' _ 'i' _ ';', 6, 0x25fa, 1)
NAMED_CHARACTER_REFERENCE(1312, 'l' _ 'm' _ 'i' _ 'd' _ 'o' _ 't' _ ';', 7, 0x0140, 1)
NAMED_CHARACTER_REFERENCE(1313, 'l' _ 'm' _ 'o' _ 'u' _ 's' _ 't' _ ';', 7, 0x23b0, 1)
NAMED_CHARACTER_REFERENCE(1314, 'l' _ 'm' _ 'o' _ 'u' _ 's' _ 't' _ 'a' _ 'c' _ 'h' _ 'e' _ ';', 11, 0x23b0, 1)
NAMED_CHARACTER_REFERENCE(1315, 'l' _ 'n' _ 'E' _ ';', 4, 0x2268, 1)
NAMED_CHARACTER_REFERENCE(1316, 'l' _ 'n' _ 'a' _ 'p' _ ';', 5, 0x2a89, 1)
NAMED_CHARACTER_REFERENCE(1317, 'l' _ 'n' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 9, 0x2a89, 1)
NAMED_CHARACTER_REFERENCE(1318, 'l' _ 'n' _ 'e' _ ';', 4, 0x2a87, 1)
NAMED_CHARACTER_REFERENCE(1319, 'l' _ 'n' _ 'e' _ 'q' _ ';', 5, 0x2a87, 1)
NAMED_CHARACTER_REFERENCE(1320, 'l' _ 'n' _ 'e' _ 'q' _ 'q' _ ';', 6, 0x2268, 1)
NAMED_CHARACTER_REFERENCE(1321, 'l' _ 'n' _ 's' _ 'i' _ 'm' _ ';', 6, 0x22e6, 1)
NAMED_CHARACTER_REFERENCE(1322, 'l' _ 'o' _ 'a' _ 'n' _ 'g' _ ';', 6, 0x27ec, 1)
NAMED_CHARACTER_REFERENCE(1323, 'l' _ 'o' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21fd, 1)
NAMED_CHARACTER_REFERENCE(1324, 'l' _ 'o' _ 'b' _ 'r' _ 'k' _ ';', 6, 0x27e6, 1)
NAMED_CHARACTER_REFERENCE(1325, 'l' _ 'o' _ 'n' _ 'g' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 14, 0x27f5, 1)
NAMED_CHARACTER_REFERENCE(1326, 'l' _ 'o' _ 'n' _ 'g' _ 'l' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 19, 0x27f7, 1)
NAMED_CHARACTER_REFERENCE(1327, 'l' _ 'o' _ 'n' _ 'g' _ 'm' _ 'a' _ 'p' _ 's' _ 't' _ 'o' _ ';', 11, 0x27fc, 1)
NAMED_CHARACTER_REFERENCE(1328, 'l' _ 'o' _ 'n' _ 'g' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 15, 0x27f6, 1)
NAMED_CHARACTER_REFERENCE(1329, 'l' _ 'o' _ 'o' _ 'p' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 14, 0x21ab, 1)
NAMED_CHARACTER_REFERENCE(1330, 'l' _ 'o' _ 'o' _ 'p' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 15, 0x21ac, 1)
NAMED_CHARACTER_REFERENCE(1331, 'l' _ 'o' _ 'p' _ 'a' _ 'r' _ ';', 6, 0x2985, 1)
NAMED_CHARACTER_REFERENCE(1332, 'l' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd5d, 2)
NAMED_CHARACTER_REFERENCE(1333, 'l' _ 'o' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 7, 0x2a2d, 1)
NAMED_CHARACTER_REFERENCE(1334, 'l' _ 'o' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 8, 0x2a34, 1)
NAMED_CHARACTER_REFERENCE(1335, 'l' _ 'o' _ 'w' _ 'a' _ 's' _ 't' _ ';', 7, 0x2217, 1)
NAMED_CHARACTER_REFERENCE(1336, 'l' _ 'o' _ 'w' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x005f, 1)
NAMED_CHARACTER_REFERENCE(1337, 'l' _ 'o' _ 'z' _ ';', 4, 0x25ca, 1)
NAMED_CHARACTER_REFERENCE(1338, 'l' _ 'o' _ 'z' _ 'e' _ 'n' _ 'g' _ 'e' _ ';', 8, 0x25ca, 1)
NAMED_CHARACTER_REFERENCE(1339, 'l' _ 'o' _ 'z' _ 'f' _ ';', 5, 0x29eb, 1)
NAMED_CHARACTER_REFERENCE(1340, 'l' _ 'p' _ 'a' _ 'r' _ ';', 5, 0x0028, 1)
NAMED_CHARACTER_REFERENCE(1341, 'l' _ 'p' _ 'a' _ 'r' _ 'l' _ 't' _ ';', 7, 0x2993, 1)
NAMED_CHARACTER_REFERENCE(1342, 'l' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21c6, 1)
NAMED_CHARACTER_REFERENCE(1343, 'l' _ 'r' _ 'c' _ 'o' _ 'r' _ 'n' _ 'e' _ 'r' _ ';', 9, 0x231f, 1)
NAMED_CHARACTER_REFERENCE(1344, 'l' _ 'r' _ 'h' _ 'a' _ 'r' _ ';', 6, 0x21cb, 1)
NAMED_CHARACTER_REFERENCE(1345, 'l' _ 'r' _ 'h' _ 'a' _ 'r' _ 'd' _ ';', 7, 0x296d, 1)
NAMED_CHARACTER_REFERENCE(1346, 'l' _ 'r' _ 'm' _ ';', 4, 0x200e, 1)
NAMED_CHARACTER_REFERENCE(1347, 'l' _ 'r' _ 't' _ 'r' _ 'i' _ ';', 6, 0x22bf, 1)
NAMED_CHARACTER_REFERENCE(1348, 'l' _ 's' _ 'a' _ 'q' _ 'u' _ 'o' _ ';', 7, 0x2039, 1)
NAMED_CHARACTER_REFERENCE(1349, 'l' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc1, 2)
NAMED_CHARACTER_REFERENCE(1350, 'l' _ 's' _ 'h' _ ';', 4, 0x21b0, 1)
NAMED_CHARACTER_REFERENCE(1351, 'l' _ 's' _ 'i' _ 'm' _ ';', 5, 0x2272, 1)
NAMED_CHARACTER_REFERENCE(1352, 'l' _ 's' _ 'i' _ 'm' _ 'e' _ ';', 6, 0x2a8d, 1)
NAMED_CHARACTER_REFERENCE(1353, 'l' _ 's' _ 'i' _ 'm' _ 'g' _ ';', 6, 0x2a8f, 1)
NAMED_CHARACTER_REFERENCE(1354, 'l' _ 's' _ 'q' _ 'b' _ ';', 5, 0x005b, 1)
NAMED_CHARACTER_REFERENCE(1355, 'l' _ 's' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x2018, 1)
NAMED_CHARACTER_REFERENCE(1356, 'l' _ 's' _ 'q' _ 'u' _ 'o' _ 'r' _ ';', 7, 0x201a, 1)
NAMED_CHARACTER_REFERENCE(1357, 'l' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0142, 1)
NAMED_CHARACTER_REFERENCE(1358, 'l' _ 't', 2, 0x003c, 1)
NAMED_CHARACTER_REFERENCE(1359, 'l' _ 't' _ ';', 3, 0x003c, 1)
NAMED_CHARACTER_REFERENCE(1360, 'l' _ 't' _ 'c' _ 'c' _ ';', 5, 0x2aa6, 1)
NAMED_CHARACTER_REFERENCE(1361, 'l' _ 't' _ 'c' _ 'i' _ 'r' _ ';', 6, 0x2a79, 1)
NAMED_CHARACTER_REFERENCE(1362, 'l' _ 't' _ 'd' _ 'o' _ 't' _ ';', 6, 0x22d6, 1)
NAMED_CHARACTER_REFERENCE(1363, 'l' _ 't' _ 'h' _ 'r' _ 'e' _ 'e' _ ';', 7, 0x22cb, 1)
NAMED_CHARACTER_REFERENCE(1364, 'l' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 7, 0x22c9, 1)
NAMED_CHARACTER_REFERENCE(1365, 'l' _ 't' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 7, 0x2976, 1)
NAMED_CHARACTER_REFERENCE(1366, 'l' _ 't' _ 'q' _ 'u' _ 'e' _ 's' _ 't' _ ';', 8, 0x2a7b, 1)
NAMED_CHARACTER_REFERENCE(1367, 'l' _ 't' _ 'r' _ 'P' _ 'a' _ 'r' _ ';', 7, 0x2996, 1)
NAMED_CHARACTER_REFERENCE(1368, 'l' _ 't' _ 'r' _ 'i' _ ';', 5, 0x25c3, 1)
NAMED_CHARACTER_REFERENCE(1369, 'l' _ 't' _ 'r' _ 'i' _ 'e' _ ';', 6, 0x22b4, 1)
NAMED_CHARACTER_REFERENCE(1370, 'l' _ 't' _ 'r' _ 'i' _ 'f' _ ';', 6, 0x25c2, 1)
NAMED_CHARACTER_REFERENCE(1371, 'l' _ 'u' _ 'r' _ 'd' _ 's' _ 'h' _ 'a' _ 'r' _ ';', 9, 0x294a, 1)
NAMED_CHARACTER_REFERENCE(1372, 'l' _ 'u' _ 'r' _ 'u' _ 'h' _ 'a' _ 'r' _ ';', 8, 0x2966, 1)
NAMED_CHARACTER_REFERENCE(1373, 'm' _ 'D' _ 'D' _ 'o' _ 't' _ ';', 6, 0x223a, 1)
NAMED_CHARACTER_REFERENCE(1374, 'm' _ 'a' _ 'c' _ 'r', 4, 0x00af, 1)
NAMED_CHARACTER_REFERENCE(1375, 'm' _ 'a' _ 'c' _ 'r' _ ';', 5, 0x00af, 1)
NAMED_CHARACTER_REFERENCE(1376, 'm' _ 'a' _ 'l' _ 'e' _ ';', 5, 0x2642, 1)
NAMED_CHARACTER_REFERENCE(1377, 'm' _ 'a' _ 'l' _ 't' _ ';', 5, 0x2720, 1)
NAMED_CHARACTER_REFERENCE(1378, 'm' _ 'a' _ 'l' _ 't' _ 'e' _ 's' _ 'e' _ ';', 8, 0x2720, 1)
NAMED_CHARACTER_REFERENCE(1379, 'm' _ 'a' _ 'p' _ ';', 4, 0x21a6, 1)
NAMED_CHARACTER_REFERENCE(1380, 'm' _ 'a' _ 'p' _ 's' _ 't' _ 'o' _ ';', 7, 0x21a6, 1)
NAMED_CHARACTER_REFERENCE(1381, 'm' _ 'a' _ 'p' _ 's' _ 't' _ 'o' _ 'd' _ 'o' _ 'w' _ 'n' _ ';', 11, 0x21a7, 1)
NAMED_CHARACTER_REFERENCE(1382, 'm' _ 'a' _ 'p' _ 's' _ 't' _ 'o' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 11, 0x21a4, 1)
NAMED_CHARACTER_REFERENCE(1383, 'm' _ 'a' _ 'p' _ 's' _ 't' _ 'o' _ 'u' _ 'p' _ ';', 9, 0x21a5, 1)
NAMED_CHARACTER_REFERENCE(1384, 'm' _ 'a' _ 'r' _ 'k' _ 'e' _ 'r' _ ';', 7, 0x25ae, 1)
NAMED_CHARACTER_REFERENCE(1385, 'm' _ 'c' _ 'o' _ 'm' _ 'm' _ 'a' _ ';', 7, 0x2a29, 1)
NAMED_CHARACTER_REFERENCE(1386, 'm' _ 'c' _ 'y' _ ';', 4, 0x043c, 1)
NAMED_CHARACTER_REFERENCE(1387, 'm' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 6, 0x2014, 1)
NAMED_CHARACTER_REFERENCE(1388, 'm' _ 'e' _ 'a' _ 's' _ 'u' _ 'r' _ 'e' _ 'd' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 14, 0x2221, 1)
NAMED_CHARACTER_REFERENCE(1389, 'm' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd2a, 2)
NAMED_CHARACTER_REFERENCE(1390, 'm' _ 'h' _ 'o' _ ';', 4, 0x2127, 1)
NAMED_CHARACTER_REFERENCE(1391, 'm' _ 'i' _ 'c' _ 'r' _ 'o', 5, 0x00b5, 1)
NAMED_CHARACTER_REFERENCE(1392, 'm' _ 'i' _ 'c' _ 'r' _ 'o' _ ';', 6, 0x00b5, 1)
NAMED_CHARACTER_REFERENCE(1393, 'm' _ 'i' _ 'd' _ ';', 4, 0x2223, 1)
NAMED_CHARACTER_REFERENCE(1394, 'm' _ 'i' _ 'd' _ 'a' _ 's' _ 't' _ ';', 7, 0x002a, 1)
NAMED_CHARACTER_REFERENCE(1395, 'm' _ 'i' _ 'd' _ 'c' _ 'i' _ 'r' _ ';', 7, 0x2af0, 1)
NAMED_CHARACTER_REFERENCE(1396, 'm' _ 'i' _ 'd' _ 'd' _ 'o' _ 't', 6, 0x00b7, 1)
NAMED_CHARACTER_REFERENCE(1397, 'm' _ 'i' _ 'd' _ 'd' _ 'o' _ 't' _ ';', 7, 0x00b7, 1)
NAMED_CHARACTER_REFERENCE(1398, 'm' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 6, 0x2212, 1)
NAMED_CHARACTER_REFERENCE(1399, 'm' _ 'i' _ 'n' _ 'u' _ 's' _ 'b' _ ';', 7, 0x229f, 1)
NAMED_CHARACTER_REFERENCE(1400, 'm' _ 'i' _ 'n' _ 'u' _ 's' _ 'd' _ ';', 7, 0x2238, 1)
NAMED_CHARACTER_REFERENCE(1401, 'm' _ 'i' _ 'n' _ 'u' _ 's' _ 'd' _ 'u' _ ';', 8, 0x2a2a, 1)
NAMED_CHARACTER_REFERENCE(1402, 'm' _ 'l' _ 'c' _ 'p' _ ';', 5, 0x2adb, 1)
NAMED_CHARACTER_REFERENCE(1403, 'm' _ 'l' _ 'd' _ 'r' _ ';', 5, 0x2026, 1)
NAMED_CHARACTER_REFERENCE(1404, 'm' _ 'n' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 7, 0x2213, 1)
NAMED_CHARACTER_REFERENCE(1405, 'm' _ 'o' _ 'd' _ 'e' _ 'l' _ 's' _ ';', 7, 0x22a7, 1)
NAMED_CHARACTER_REFERENCE(1406, 'm' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd5e, 2)
NAMED_CHARACTER_REFERENCE(1407, 'm' _ 'p' _ ';', 3, 0x2213, 1)
NAMED_CHARACTER_REFERENCE(1408, 'm' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc2, 2)
NAMED_CHARACTER_REFERENCE(1409, 'm' _ 's' _ 't' _ 'p' _ 'o' _ 's' _ ';', 7, 0x223e, 1)
NAMED_CHARACTER_REFERENCE(1410, 'm' _ 'u' _ ';', 3, 0x03bc, 1)
NAMED_CHARACTER_REFERENCE(1411, 'm' _ 'u' _ 'l' _ 't' _ 'i' _ 'm' _ 'a' _ 'p' _ ';', 9, 0x22b8, 1)
NAMED_CHARACTER_REFERENCE(1412, 'm' _ 'u' _ 'm' _ 'a' _ 'p' _ ';', 6, 0x22b8, 1)
NAMED_CHARACTER_REFERENCE(1413, 'n' _ 'L' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 11, 0x21cd, 1)
NAMED_CHARACTER_REFERENCE(1414, 'n' _ 'L' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x21ce, 1)
NAMED_CHARACTER_REFERENCE(1415, 'n' _ 'R' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 12, 0x21cf, 1)
NAMED_CHARACTER_REFERENCE(1416, 'n' _ 'V' _ 'D' _ 'a' _ 's' _ 'h' _ ';', 7, 0x22af, 1)
NAMED_CHARACTER_REFERENCE(1417, 'n' _ 'V' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 7, 0x22ae, 1)
NAMED_CHARACTER_REFERENCE(1418, 'n' _ 'a' _ 'b' _ 'l' _ 'a' _ ';', 6, 0x2207, 1)
NAMED_CHARACTER_REFERENCE(1419, 'n' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0144, 1)
NAMED_CHARACTER_REFERENCE(1420, 'n' _ 'a' _ 'p' _ ';', 4, 0x2249, 1)
NAMED_CHARACTER_REFERENCE(1421, 'n' _ 'a' _ 'p' _ 'o' _ 's' _ ';', 6, 0x0149, 1)
NAMED_CHARACTER_REFERENCE(1422, 'n' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 8, 0x2249, 1)
NAMED_CHARACTER_REFERENCE(1423, 'n' _ 'a' _ 't' _ 'u' _ 'r' _ ';', 6, 0x266e, 1)
NAMED_CHARACTER_REFERENCE(1424, 'n' _ 'a' _ 't' _ 'u' _ 'r' _ 'a' _ 'l' _ ';', 8, 0x266e, 1)
NAMED_CHARACTER_REFERENCE(1425, 'n' _ 'a' _ 't' _ 'u' _ 'r' _ 'a' _ 'l' _ 's' _ ';', 9, 0x2115, 1)
NAMED_CHARACTER_REFERENCE(1426, 'n' _ 'b' _ 's' _ 'p', 4, 0x00a0, 1)
NAMED_CHARACTER_REFERENCE(1427, 'n' _ 'b' _ 's' _ 'p' _ ';', 5, 0x00a0, 1)
NAMED_CHARACTER_REFERENCE(1428, 'n' _ 'c' _ 'a' _ 'p' _ ';', 5, 0x2a43, 1)
NAMED_CHARACTER_REFERENCE(1429, 'n' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0148, 1)
NAMED_CHARACTER_REFERENCE(1430, 'n' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0146, 1)
NAMED_CHARACTER_REFERENCE(1431, 'n' _ 'c' _ 'o' _ 'n' _ 'g' _ ';', 6, 0x2247, 1)
NAMED_CHARACTER_REFERENCE(1432, 'n' _ 'c' _ 'u' _ 'p' _ ';', 5, 0x2a42, 1)
NAMED_CHARACTER_REFERENCE(1433, 'n' _ 'c' _ 'y' _ ';', 4, 0x043d, 1)
NAMED_CHARACTER_REFERENCE(1434, 'n' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 6, 0x2013, 1)
NAMED_CHARACTER_REFERENCE(1435, 'n' _ 'e' _ ';', 3, 0x2260, 1)
NAMED_CHARACTER_REFERENCE(1436, 'n' _ 'e' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x21d7, 1)
NAMED_CHARACTER_REFERENCE(1437, 'n' _ 'e' _ 'a' _ 'r' _ 'h' _ 'k' _ ';', 7, 0x2924, 1)
NAMED_CHARACTER_REFERENCE(1438, 'n' _ 'e' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2197, 1)
NAMED_CHARACTER_REFERENCE(1439, 'n' _ 'e' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x2197, 1)
NAMED_CHARACTER_REFERENCE(1440, 'n' _ 'e' _ 'q' _ 'u' _ 'i' _ 'v' _ ';', 7, 0x2262, 1)
NAMED_CHARACTER_REFERENCE(1441, 'n' _ 'e' _ 's' _ 'e' _ 'a' _ 'r' _ ';', 7, 0x2928, 1)
NAMED_CHARACTER_REFERENCE(1442, 'n' _ 'e' _ 'x' _ 'i' _ 's' _ 't' _ ';', 7, 0x2204, 1)
NAMED_CHARACTER_REFERENCE(1443, 'n' _ 'e' _ 'x' _ 'i' _ 's' _ 't' _ 's' _ ';', 8, 0x2204, 1)
NAMED_CHARACTER_REFERENCE(1444, 'n' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd2b, 2)
NAMED_CHARACTER_REFERENCE(1445, 'n' _ 'g' _ 'e' _ ';', 4, 0x2271, 1)
NAMED_CHARACTER_REFERENCE(1446, 'n' _ 'g' _ 'e' _ 'q' _ ';', 5, 0x2271, 1)
NAMED_CHARACTER_REFERENCE(1447, 'n' _ 'g' _ 's' _ 'i' _ 'm' _ ';', 6, 0x2275, 1)
NAMED_CHARACTER_REFERENCE(1448, 'n' _ 'g' _ 't' _ ';', 4, 0x226f, 1)
NAMED_CHARACTER_REFERENCE(1449, 'n' _ 'g' _ 't' _ 'r' _ ';', 5, 0x226f, 1)
NAMED_CHARACTER_REFERENCE(1450, 'n' _ 'h' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x21ce, 1)
NAMED_CHARACTER_REFERENCE(1451, 'n' _ 'h' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21ae, 1)
NAMED_CHARACTER_REFERENCE(1452, 'n' _ 'h' _ 'p' _ 'a' _ 'r' _ ';', 6, 0x2af2, 1)
NAMED_CHARACTER_REFERENCE(1453, 'n' _ 'i' _ ';', 3, 0x220b, 1)
NAMED_CHARACTER_REFERENCE(1454, 'n' _ 'i' _ 's' _ ';', 4, 0x22fc, 1)
NAMED_CHARACTER_REFERENCE(1455, 'n' _ 'i' _ 's' _ 'd' _ ';', 5, 0x22fa, 1)
NAMED_CHARACTER_REFERENCE(1456, 'n' _ 'i' _ 'v' _ ';', 4, 0x220b, 1)
NAMED_CHARACTER_REFERENCE(1457, 'n' _ 'j' _ 'c' _ 'y' _ ';', 5, 0x045a, 1)
NAMED_CHARACTER_REFERENCE(1458, 'n' _ 'l' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x21cd, 1)
NAMED_CHARACTER_REFERENCE(1459, 'n' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x219a, 1)
NAMED_CHARACTER_REFERENCE(1460, 'n' _ 'l' _ 'd' _ 'r' _ ';', 5, 0x2025, 1)
NAMED_CHARACTER_REFERENCE(1461, 'n' _ 'l' _ 'e' _ ';', 4, 0x2270, 1)
NAMED_CHARACTER_REFERENCE(1462, 'n' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 11, 0x219a, 1)
NAMED_CHARACTER_REFERENCE(1463, 'n' _ 'l' _ 'e' _ 'f' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x21ae, 1)
NAMED_CHARACTER_REFERENCE(1464, 'n' _ 'l' _ 'e' _ 'q' _ ';', 5, 0x2270, 1)
NAMED_CHARACTER_REFERENCE(1465, 'n' _ 'l' _ 'e' _ 's' _ 's' _ ';', 6, 0x226e, 1)
NAMED_CHARACTER_REFERENCE(1466, 'n' _ 'l' _ 's' _ 'i' _ 'm' _ ';', 6, 0x2274, 1)
NAMED_CHARACTER_REFERENCE(1467, 'n' _ 'l' _ 't' _ ';', 4, 0x226e, 1)
NAMED_CHARACTER_REFERENCE(1468, 'n' _ 'l' _ 't' _ 'r' _ 'i' _ ';', 6, 0x22ea, 1)
NAMED_CHARACTER_REFERENCE(1469, 'n' _ 'l' _ 't' _ 'r' _ 'i' _ 'e' _ ';', 7, 0x22ec, 1)
NAMED_CHARACTER_REFERENCE(1470, 'n' _ 'm' _ 'i' _ 'd' _ ';', 5, 0x2224, 1)
NAMED_CHARACTER_REFERENCE(1471, 'n' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd5f, 2)
NAMED_CHARACTER_REFERENCE(1472, 'n' _ 'o' _ 't', 3, 0x00ac, 1)
NAMED_CHARACTER_REFERENCE(1473, 'n' _ 'o' _ 't' _ ';', 4, 0x00ac, 1)
NAMED_CHARACTER_REFERENCE(1474, 'n' _ 'o' _ 't' _ 'i' _ 'n' _ ';', 6, 0x2209, 1)
NAMED_CHARACTER_REFERENCE(1475, 'n' _ 'o' _ 't' _ 'i' _ 'n' _ 'v' _ 'a' _ ';', 8, 0x2209, 1)
NAMED_CHARACTER_REFERENCE(1476, 'n' _ 'o' _ 't' _ 'i' _ 'n' _ 'v' _ 'b' _ ';', 8, 0x22f7, 1)
NAMED_CHARACTER_REFERENCE(1477, 'n' _ 'o' _ 't' _ 'i' _ 'n' _ 'v' _ 'c' _ ';', 8, 0x22f6, 1)
NAMED_CHARACTER_REFERENCE(1478, 'n' _ 'o' _ 't' _ 'n' _ 'i' _ ';', 6, 0x220c, 1)
NAMED_CHARACTER_REFERENCE(1479, 'n' _ 'o' _ 't' _ 'n' _ 'i' _ 'v' _ 'a' _ ';', 8, 0x220c, 1)
NAMED_CHARACTER_REFERENCE(1480, 'n' _ 'o' _ 't' _ 'n' _ 'i' _ 'v' _ 'b' _ ';', 8, 0x22fe, 1)
NAMED_CHARACTER_REFERENCE(1481, 'n' _ 'o' _ 't' _ 'n' _ 'i' _ 'v' _ 'c' _ ';', 8, 0x22fd, 1)
NAMED_CHARACTER_REFERENCE(1482, 'n' _ 'p' _ 'a' _ 'r' _ ';', 5, 0x2226, 1)
NAMED_CHARACTER_REFERENCE(1483, 'n' _ 'p' _ 'a' _ 'r' _ 'a' _ 'l' _ 'l' _ 'e' _ 'l' _ ';', 10, 0x2226, 1)
NAMED_CHARACTER_REFERENCE(1484, 'n' _ 'p' _ 'o' _ 'l' _ 'i' _ 'n' _ 't' _ ';', 8, 0x2a14, 1)
NAMED_CHARACTER_REFERENCE(1485, 'n' _ 'p' _ 'r' _ ';', 4, 0x2280, 1)
NAMED_CHARACTER_REFERENCE(1486, 'n' _ 'p' _ 'r' _ 'c' _ 'u' _ 'e' _ ';', 7, 0x22e0, 1)
NAMED_CHARACTER_REFERENCE(1487, 'n' _ 'p' _ 'r' _ 'e' _ 'c' _ ';', 6, 0x2280, 1)
NAMED_CHARACTER_REFERENCE(1488, 'n' _ 'r' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x21cf, 1)
NAMED_CHARACTER_REFERENCE(1489, 'n' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x219b, 1)
NAMED_CHARACTER_REFERENCE(1490, 'n' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 12, 0x219b, 1)
NAMED_CHARACTER_REFERENCE(1491, 'n' _ 'r' _ 't' _ 'r' _ 'i' _ ';', 6, 0x22eb, 1)
NAMED_CHARACTER_REFERENCE(1492, 'n' _ 'r' _ 't' _ 'r' _ 'i' _ 'e' _ ';', 7, 0x22ed, 1)
NAMED_CHARACTER_REFERENCE(1493, 'n' _ 's' _ 'c' _ ';', 4, 0x2281, 1)
NAMED_CHARACTER_REFERENCE(1494, 'n' _ 's' _ 'c' _ 'c' _ 'u' _ 'e' _ ';', 7, 0x22e1, 1)
NAMED_CHARACTER_REFERENCE(1495, 'n' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc3, 2)
NAMED_CHARACTER_REFERENCE(1496, 'n' _ 's' _ 'h' _ 'o' _ 'r' _ 't' _ 'm' _ 'i' _ 'd' _ ';', 10, 0x2224, 1)
NAMED_CHARACTER_REFERENCE(1497, 'n' _ 's' _ 'h' _ 'o' _ 'r' _ 't' _ 'p' _ 'a' _ 'r' _ 'a' _ 'l' _ 'l' _ 'e' _ 'l' _ ';', 15, 0x2226, 1)
NAMED_CHARACTER_REFERENCE(1498, 'n' _ 's' _ 'i' _ 'm' _ ';', 5, 0x2241, 1)
NAMED_CHARACTER_REFERENCE(1499, 'n' _ 's' _ 'i' _ 'm' _ 'e' _ ';', 6, 0x2244, 1)
NAMED_CHARACTER_REFERENCE(1500, 'n' _ 's' _ 'i' _ 'm' _ 'e' _ 'q' _ ';', 7, 0x2244, 1)
NAMED_CHARACTER_REFERENCE(1501, 'n' _ 's' _ 'm' _ 'i' _ 'd' _ ';', 6, 0x2224, 1)
NAMED_CHARACTER_REFERENCE(1502, 'n' _ 's' _ 'p' _ 'a' _ 'r' _ ';', 6, 0x2226, 1)
NAMED_CHARACTER_REFERENCE(1503, 'n' _ 's' _ 'q' _ 's' _ 'u' _ 'b' _ 'e' _ ';', 8, 0x22e2, 1)
NAMED_CHARACTER_REFERENCE(1504, 'n' _ 's' _ 'q' _ 's' _ 'u' _ 'p' _ 'e' _ ';', 8, 0x22e3, 1)
NAMED_CHARACTER_REFERENCE(1505, 'n' _ 's' _ 'u' _ 'b' _ ';', 5, 0x2284, 1)
NAMED_CHARACTER_REFERENCE(1506, 'n' _ 's' _ 'u' _ 'b' _ 'e' _ ';', 6, 0x2288, 1)
NAMED_CHARACTER_REFERENCE(1507, 'n' _ 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ ';', 10, 0x2288, 1)
NAMED_CHARACTER_REFERENCE(1508, 'n' _ 's' _ 'u' _ 'c' _ 'c' _ ';', 6, 0x2281, 1)
NAMED_CHARACTER_REFERENCE(1509, 'n' _ 's' _ 'u' _ 'p' _ ';', 5, 0x2285, 1)
NAMED_CHARACTER_REFERENCE(1510, 'n' _ 's' _ 'u' _ 'p' _ 'e' _ ';', 6, 0x2289, 1)
NAMED_CHARACTER_REFERENCE(1511, 'n' _ 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ ';', 10, 0x2289, 1)
NAMED_CHARACTER_REFERENCE(1512, 'n' _ 't' _ 'g' _ 'l' _ ';', 5, 0x2279, 1)
NAMED_CHARACTER_REFERENCE(1513, 'n' _ 't' _ 'i' _ 'l' _ 'd' _ 'e', 6, 0x00f1, 1)
NAMED_CHARACTER_REFERENCE(1514, 'n' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x00f1, 1)
NAMED_CHARACTER_REFERENCE(1515, 'n' _ 't' _ 'l' _ 'g' _ ';', 5, 0x2278, 1)
NAMED_CHARACTER_REFERENCE(1516, 'n' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 14, 0x22ea, 1)
NAMED_CHARACTER_REFERENCE(1517, 'n' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'l' _ 'e' _ 'f' _ 't' _ 'e' _ 'q' _ ';', 16, 0x22ec, 1)
NAMED_CHARACTER_REFERENCE(1518, 'n' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 15, 0x22eb, 1)
NAMED_CHARACTER_REFERENCE(1519, 'n' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'e' _ 'q' _ ';', 17, 0x22ed, 1)
NAMED_CHARACTER_REFERENCE(1520, 'n' _ 'u' _ ';', 3, 0x03bd, 1)
NAMED_CHARACTER_REFERENCE(1521, 'n' _ 'u' _ 'm' _ ';', 4, 0x0023, 1)
NAMED_CHARACTER_REFERENCE(1522, 'n' _ 'u' _ 'm' _ 'e' _ 'r' _ 'o' _ ';', 7, 0x2116, 1)
NAMED_CHARACTER_REFERENCE(1523, 'n' _ 'u' _ 'm' _ 's' _ 'p' _ ';', 6, 0x2007, 1)
NAMED_CHARACTER_REFERENCE(1524, 'n' _ 'v' _ 'D' _ 'a' _ 's' _ 'h' _ ';', 7, 0x22ad, 1)
NAMED_CHARACTER_REFERENCE(1525, 'n' _ 'v' _ 'H' _ 'a' _ 'r' _ 'r' _ ';', 7, 0x2904, 1)
NAMED_CHARACTER_REFERENCE(1526, 'n' _ 'v' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 7, 0x22ac, 1)
NAMED_CHARACTER_REFERENCE(1527, 'n' _ 'v' _ 'i' _ 'n' _ 'f' _ 'i' _ 'n' _ ';', 8, 0x29de, 1)
NAMED_CHARACTER_REFERENCE(1528, 'n' _ 'v' _ 'l' _ 'A' _ 'r' _ 'r' _ ';', 7, 0x2902, 1)
NAMED_CHARACTER_REFERENCE(1529, 'n' _ 'v' _ 'r' _ 'A' _ 'r' _ 'r' _ ';', 7, 0x2903, 1)
NAMED_CHARACTER_REFERENCE(1530, 'n' _ 'w' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x21d6, 1)
NAMED_CHARACTER_REFERENCE(1531, 'n' _ 'w' _ 'a' _ 'r' _ 'h' _ 'k' _ ';', 7, 0x2923, 1)
NAMED_CHARACTER_REFERENCE(1532, 'n' _ 'w' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2196, 1)
NAMED_CHARACTER_REFERENCE(1533, 'n' _ 'w' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x2196, 1)
NAMED_CHARACTER_REFERENCE(1534, 'n' _ 'w' _ 'n' _ 'e' _ 'a' _ 'r' _ ';', 7, 0x2927, 1)
NAMED_CHARACTER_REFERENCE(1535, 'o' _ 'S' _ ';', 3, 0x24c8, 1)
NAMED_CHARACTER_REFERENCE(1536, 'o' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00f3, 1)
NAMED_CHARACTER_REFERENCE(1537, 'o' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00f3, 1)
NAMED_CHARACTER_REFERENCE(1538, 'o' _ 'a' _ 's' _ 't' _ ';', 5, 0x229b, 1)
NAMED_CHARACTER_REFERENCE(1539, 'o' _ 'c' _ 'i' _ 'r' _ ';', 5, 0x229a, 1)
NAMED_CHARACTER_REFERENCE(1540, 'o' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00f4, 1)
NAMED_CHARACTER_REFERENCE(1541, 'o' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00f4, 1)
NAMED_CHARACTER_REFERENCE(1542, 'o' _ 'c' _ 'y' _ ';', 4, 0x043e, 1)
NAMED_CHARACTER_REFERENCE(1543, 'o' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 6, 0x229d, 1)
NAMED_CHARACTER_REFERENCE(1544, 'o' _ 'd' _ 'b' _ 'l' _ 'a' _ 'c' _ ';', 7, 0x0151, 1)
NAMED_CHARACTER_REFERENCE(1545, 'o' _ 'd' _ 'i' _ 'v' _ ';', 5, 0x2a38, 1)
NAMED_CHARACTER_REFERENCE(1546, 'o' _ 'd' _ 'o' _ 't' _ ';', 5, 0x2299, 1)
NAMED_CHARACTER_REFERENCE(1547, 'o' _ 'd' _ 's' _ 'o' _ 'l' _ 'd' _ ';', 7, 0x29bc, 1)
NAMED_CHARACTER_REFERENCE(1548, 'o' _ 'e' _ 'l' _ 'i' _ 'g' _ ';', 6, 0x0153, 1)
NAMED_CHARACTER_REFERENCE(1549, 'o' _ 'f' _ 'c' _ 'i' _ 'r' _ ';', 6, 0x29bf, 1)
NAMED_CHARACTER_REFERENCE(1550, 'o' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd2c, 2)
NAMED_CHARACTER_REFERENCE(1551, 'o' _ 'g' _ 'o' _ 'n' _ ';', 5, 0x02db, 1)
NAMED_CHARACTER_REFERENCE(1552, 'o' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00f2, 1)
NAMED_CHARACTER_REFERENCE(1553, 'o' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00f2, 1)
NAMED_CHARACTER_REFERENCE(1554, 'o' _ 'g' _ 't' _ ';', 4, 0x29c1, 1)
NAMED_CHARACTER_REFERENCE(1555, 'o' _ 'h' _ 'b' _ 'a' _ 'r' _ ';', 6, 0x29b5, 1)
NAMED_CHARACTER_REFERENCE(1556, 'o' _ 'h' _ 'm' _ ';', 4, 0x03a9, 1)
NAMED_CHARACTER_REFERENCE(1557, 'o' _ 'i' _ 'n' _ 't' _ ';', 5, 0x222e, 1)
NAMED_CHARACTER_REFERENCE(1558, 'o' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21ba, 1)
NAMED_CHARACTER_REFERENCE(1559, 'o' _ 'l' _ 'c' _ 'i' _ 'r' _ ';', 6, 0x29be, 1)
NAMED_CHARACTER_REFERENCE(1560, 'o' _ 'l' _ 'c' _ 'r' _ 'o' _ 's' _ 's' _ ';', 8, 0x29bb, 1)
NAMED_CHARACTER_REFERENCE(1561, 'o' _ 'l' _ 'i' _ 'n' _ 'e' _ ';', 6, 0x203e, 1)
NAMED_CHARACTER_REFERENCE(1562, 'o' _ 'l' _ 't' _ ';', 4, 0x29c0, 1)
NAMED_CHARACTER_REFERENCE(1563, 'o' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x014d, 1)
NAMED_CHARACTER_REFERENCE(1564, 'o' _ 'm' _ 'e' _ 'g' _ 'a' _ ';', 6, 0x03c9, 1)
NAMED_CHARACTER_REFERENCE(1565, 'o' _ 'm' _ 'i' _ 'c' _ 'r' _ 'o' _ 'n' _ ';', 8, 0x03bf, 1)
NAMED_CHARACTER_REFERENCE(1566, 'o' _ 'm' _ 'i' _ 'd' _ ';', 5, 0x29b6, 1)
NAMED_CHARACTER_REFERENCE(1567, 'o' _ 'm' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 7, 0x2296, 1)
NAMED_CHARACTER_REFERENCE(1568, 'o' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd60, 2)
NAMED_CHARACTER_REFERENCE(1569, 'o' _ 'p' _ 'a' _ 'r' _ ';', 5, 0x29b7, 1)
NAMED_CHARACTER_REFERENCE(1570, 'o' _ 'p' _ 'e' _ 'r' _ 'p' _ ';', 6, 0x29b9, 1)
NAMED_CHARACTER_REFERENCE(1571, 'o' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 6, 0x2295, 1)
NAMED_CHARACTER_REFERENCE(1572, 'o' _ 'r' _ ';', 3, 0x2228, 1)
NAMED_CHARACTER_REFERENCE(1573, 'o' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21bb, 1)
NAMED_CHARACTER_REFERENCE(1574, 'o' _ 'r' _ 'd' _ ';', 4, 0x2a5d, 1)
NAMED_CHARACTER_REFERENCE(1575, 'o' _ 'r' _ 'd' _ 'e' _ 'r' _ ';', 6, 0x2134, 1)
NAMED_CHARACTER_REFERENCE(1576, 'o' _ 'r' _ 'd' _ 'e' _ 'r' _ 'o' _ 'f' _ ';', 8, 0x2134, 1)
NAMED_CHARACTER_REFERENCE(1577, 'o' _ 'r' _ 'd' _ 'f', 4, 0x00aa, 1)
NAMED_CHARACTER_REFERENCE(1578, 'o' _ 'r' _ 'd' _ 'f' _ ';', 5, 0x00aa, 1)
NAMED_CHARACTER_REFERENCE(1579, 'o' _ 'r' _ 'd' _ 'm', 4, 0x00ba, 1)
NAMED_CHARACTER_REFERENCE(1580, 'o' _ 'r' _ 'd' _ 'm' _ ';', 5, 0x00ba, 1)
NAMED_CHARACTER_REFERENCE(1581, 'o' _ 'r' _ 'i' _ 'g' _ 'o' _ 'f' _ ';', 7, 0x22b6, 1)
NAMED_CHARACTER_REFERENCE(1582, 'o' _ 'r' _ 'o' _ 'r' _ ';', 5, 0x2a56, 1)
NAMED_CHARACTER_REFERENCE(1583, 'o' _ 'r' _ 's' _ 'l' _ 'o' _ 'p' _ 'e' _ ';', 8, 0x2a57, 1)
NAMED_CHARACTER_REFERENCE(1584, 'o' _ 'r' _ 'v' _ ';', 4, 0x2a5b, 1)
NAMED_CHARACTER_REFERENCE(1585, 'o' _ 's' _ 'c' _ 'r' _ ';', 5, 0x2134, 1)
NAMED_CHARACTER_REFERENCE(1586, 'o' _ 's' _ 'l' _ 'a' _ 's' _ 'h', 6, 0x00f8, 1)
NAMED_CHARACTER_REFERENCE(1587, 'o' _ 's' _ 'l' _ 'a' _ 's' _ 'h' _ ';', 7, 0x00f8, 1)
NAMED_CHARACTER_REFERENCE(1588, 'o' _ 's' _ 'o' _ 'l' _ ';', 5, 0x2298, 1)
NAMED_CHARACTER_REFERENCE(1589, 'o' _ 't' _ 'i' _ 'l' _ 'd' _ 'e', 6, 0x00f5, 1)
NAMED_CHARACTER_REFERENCE(1590, 'o' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x00f5, 1)
NAMED_CHARACTER_REFERENCE(1591, 'o' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 7, 0x2297, 1)
NAMED_CHARACTER_REFERENCE(1592, 'o' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ 'a' _ 's' _ ';', 9, 0x2a36, 1)
NAMED_CHARACTER_REFERENCE(1593, 'o' _ 'u' _ 'm' _ 'l', 4, 0x00f6, 1)
NAMED_CHARACTER_REFERENCE(1594, 'o' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00f6, 1)
NAMED_CHARACTER_REFERENCE(1595, 'o' _ 'v' _ 'b' _ 'a' _ 'r' _ ';', 6, 0x233d, 1)
NAMED_CHARACTER_REFERENCE(1596, 'p' _ 'a' _ 'r' _ ';', 4, 0x2225, 1)
NAMED_CHARACTER_REFERENCE(1597, 'p' _ 'a' _ 'r' _ 'a', 4, 0x00b6, 1)
NAMED_CHARACTER_REFERENCE(1598, 'p' _ 'a' _ 'r' _ 'a' _ ';', 5, 0x00b6, 1)
NAMED_CHARACTER_REFERENCE(1599, 'p' _ 'a' _ 'r' _ 'a' _ 'l' _ 'l' _ 'e' _ 'l' _ ';', 9, 0x2225, 1)
NAMED_CHARACTER_REFERENCE(1600, 'p' _ 'a' _ 'r' _ 's' _ 'i' _ 'm' _ ';', 7, 0x2af3, 1)
NAMED_CHARACTER_REFERENCE(1601, 'p' _ 'a' _ 'r' _ 's' _ 'l' _ ';', 6, 0x2afd, 1)
NAMED_CHARACTER_REFERENCE(1602, 'p' _ 'a' _ 'r' _ 't' _ ';', 5, 0x2202, 1)
NAMED_CHARACTER_REFERENCE(1603, 'p' _ 'c' _ 'y' _ ';', 4, 0x043f, 1)
NAMED_CHARACTER_REFERENCE(1604, 'p' _ 'e' _ 'r' _ 'c' _ 'n' _ 't' _ ';', 7, 0x0025, 1)
NAMED_CHARACTER_REFERENCE(1605, 'p' _ 'e' _ 'r' _ 'i' _ 'o' _ 'd' _ ';', 7, 0x002e, 1)
NAMED_CHARACTER_REFERENCE(1606, 'p' _ 'e' _ 'r' _ 'm' _ 'i' _ 'l' _ ';', 7, 0x2030, 1)
NAMED_CHARACTER_REFERENCE(1607, 'p' _ 'e' _ 'r' _ 'p' _ ';', 5, 0x22a5, 1)
NAMED_CHARACTER_REFERENCE(1608, 'p' _ 'e' _ 'r' _ 't' _ 'e' _ 'n' _ 'k' _ ';', 8, 0x2031, 1)
NAMED_CHARACTER_REFERENCE(1609, 'p' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd2d, 2)
NAMED_CHARACTER_REFERENCE(1610, 'p' _ 'h' _ 'i' _ ';', 4, 0x03c6, 1)
NAMED_CHARACTER_REFERENCE(1611, 'p' _ 'h' _ 'i' _ 'v' _ ';', 5, 0x03d5, 1)
NAMED_CHARACTER_REFERENCE(1612, 'p' _ 'h' _ 'm' _ 'm' _ 'a' _ 't' _ ';', 7, 0x2133, 1)
NAMED_CHARACTER_REFERENCE(1613, 'p' _ 'h' _ 'o' _ 'n' _ 'e' _ ';', 6, 0x260e, 1)
NAMED_CHARACTER_REFERENCE(1614, 'p' _ 'i' _ ';', 3, 0x03c0, 1)
NAMED_CHARACTER_REFERENCE(1615, 'p' _ 'i' _ 't' _ 'c' _ 'h' _ 'f' _ 'o' _ 'r' _ 'k' _ ';', 10, 0x22d4, 1)
NAMED_CHARACTER_REFERENCE(1616, 'p' _ 'i' _ 'v' _ ';', 4, 0x03d6, 1)
NAMED_CHARACTER_REFERENCE(1617, 'p' _ 'l' _ 'a' _ 'n' _ 'c' _ 'k' _ ';', 7, 0x210f, 1)
NAMED_CHARACTER_REFERENCE(1618, 'p' _ 'l' _ 'a' _ 'n' _ 'c' _ 'k' _ 'h' _ ';', 8, 0x210e, 1)
NAMED_CHARACTER_REFERENCE(1619, 'p' _ 'l' _ 'a' _ 'n' _ 'k' _ 'v' _ ';', 7, 0x210f, 1)
NAMED_CHARACTER_REFERENCE(1620, 'p' _ 'l' _ 'u' _ 's' _ ';', 5, 0x002b, 1)
NAMED_CHARACTER_REFERENCE(1621, 'p' _ 'l' _ 'u' _ 's' _ 'a' _ 'c' _ 'i' _ 'r' _ ';', 9, 0x2a23, 1)
NAMED_CHARACTER_REFERENCE(1622, 'p' _ 'l' _ 'u' _ 's' _ 'b' _ ';', 6, 0x229e, 1)
NAMED_CHARACTER_REFERENCE(1623, 'p' _ 'l' _ 'u' _ 's' _ 'c' _ 'i' _ 'r' _ ';', 8, 0x2a22, 1)
NAMED_CHARACTER_REFERENCE(1624, 'p' _ 'l' _ 'u' _ 's' _ 'd' _ 'o' _ ';', 7, 0x2214, 1)
NAMED_CHARACTER_REFERENCE(1625, 'p' _ 'l' _ 'u' _ 's' _ 'd' _ 'u' _ ';', 7, 0x2a25, 1)
NAMED_CHARACTER_REFERENCE(1626, 'p' _ 'l' _ 'u' _ 's' _ 'e' _ ';', 6, 0x2a72, 1)
NAMED_CHARACTER_REFERENCE(1627, 'p' _ 'l' _ 'u' _ 's' _ 'm' _ 'n', 6, 0x00b1, 1)
NAMED_CHARACTER_REFERENCE(1628, 'p' _ 'l' _ 'u' _ 's' _ 'm' _ 'n' _ ';', 7, 0x00b1, 1)
NAMED_CHARACTER_REFERENCE(1629, 'p' _ 'l' _ 'u' _ 's' _ 's' _ 'i' _ 'm' _ ';', 8, 0x2a26, 1)
NAMED_CHARACTER_REFERENCE(1630, 'p' _ 'l' _ 'u' _ 's' _ 't' _ 'w' _ 'o' _ ';', 8, 0x2a27, 1)
NAMED_CHARACTER_REFERENCE(1631, 'p' _ 'm' _ ';', 3, 0x00b1, 1)
NAMED_CHARACTER_REFERENCE(1632, 'p' _ 'o' _ 'i' _ 'n' _ 't' _ 'i' _ 'n' _ 't' _ ';', 9, 0x2a15, 1)
NAMED_CHARACTER_REFERENCE(1633, 'p' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd61, 2)
NAMED_CHARACTER_REFERENCE(1634, 'p' _ 'o' _ 'u' _ 'n' _ 'd', 5, 0x00a3, 1)
NAMED_CHARACTER_REFERENCE(1635, 'p' _ 'o' _ 'u' _ 'n' _ 'd' _ ';', 6, 0x00a3, 1)
NAMED_CHARACTER_REFERENCE(1636, 'p' _ 'r' _ ';', 3, 0x227a, 1)
NAMED_CHARACTER_REFERENCE(1637, 'p' _ 'r' _ 'E' _ ';', 4, 0x2ab3, 1)
NAMED_CHARACTER_REFERENCE(1638, 'p' _ 'r' _ 'a' _ 'p' _ ';', 5, 0x2ab7, 1)
NAMED_CHARACTER_REFERENCE(1639, 'p' _ 'r' _ 'c' _ 'u' _ 'e' _ ';', 6, 0x227c, 1)
NAMED_CHARACTER_REFERENCE(1640, 'p' _ 'r' _ 'e' _ ';', 4, 0x2aaf, 1)
NAMED_CHARACTER_REFERENCE(1641, 'p' _ 'r' _ 'e' _ 'c' _ ';', 5, 0x227a, 1)
NAMED_CHARACTER_REFERENCE(1642, 'p' _ 'r' _ 'e' _ 'c' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 11, 0x2ab7, 1)
NAMED_CHARACTER_REFERENCE(1643, 'p' _ 'r' _ 'e' _ 'c' _ 'c' _ 'u' _ 'r' _ 'l' _ 'y' _ 'e' _ 'q' _ ';', 12, 0x227c, 1)
NAMED_CHARACTER_REFERENCE(1644, 'p' _ 'r' _ 'e' _ 'c' _ 'e' _ 'q' _ ';', 7, 0x2aaf, 1)
NAMED_CHARACTER_REFERENCE(1645, 'p' _ 'r' _ 'e' _ 'c' _ 'n' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 12, 0x2ab9, 1)
NAMED_CHARACTER_REFERENCE(1646, 'p' _ 'r' _ 'e' _ 'c' _ 'n' _ 'e' _ 'q' _ 'q' _ ';', 9, 0x2ab5, 1)
NAMED_CHARACTER_REFERENCE(1647, 'p' _ 'r' _ 'e' _ 'c' _ 'n' _ 's' _ 'i' _ 'm' _ ';', 9, 0x22e8, 1)
NAMED_CHARACTER_REFERENCE(1648, 'p' _ 'r' _ 'e' _ 'c' _ 's' _ 'i' _ 'm' _ ';', 8, 0x227e, 1)
NAMED_CHARACTER_REFERENCE(1649, 'p' _ 'r' _ 'i' _ 'm' _ 'e' _ ';', 6, 0x2032, 1)
NAMED_CHARACTER_REFERENCE(1650, 'p' _ 'r' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 7, 0x2119, 1)
NAMED_CHARACTER_REFERENCE(1651, 'p' _ 'r' _ 'n' _ 'E' _ ';', 5, 0x2ab5, 1)
NAMED_CHARACTER_REFERENCE(1652, 'p' _ 'r' _ 'n' _ 'a' _ 'p' _ ';', 6, 0x2ab9, 1)
NAMED_CHARACTER_REFERENCE(1653, 'p' _ 'r' _ 'n' _ 's' _ 'i' _ 'm' _ ';', 7, 0x22e8, 1)
NAMED_CHARACTER_REFERENCE(1654, 'p' _ 'r' _ 'o' _ 'd' _ ';', 5, 0x220f, 1)
NAMED_CHARACTER_REFERENCE(1655, 'p' _ 'r' _ 'o' _ 'f' _ 'a' _ 'l' _ 'a' _ 'r' _ ';', 9, 0x232e, 1)
NAMED_CHARACTER_REFERENCE(1656, 'p' _ 'r' _ 'o' _ 'f' _ 'l' _ 'i' _ 'n' _ 'e' _ ';', 9, 0x2312, 1)
NAMED_CHARACTER_REFERENCE(1657, 'p' _ 'r' _ 'o' _ 'f' _ 's' _ 'u' _ 'r' _ 'f' _ ';', 9, 0x2313, 1)
NAMED_CHARACTER_REFERENCE(1658, 'p' _ 'r' _ 'o' _ 'p' _ ';', 5, 0x221d, 1)
NAMED_CHARACTER_REFERENCE(1659, 'p' _ 'r' _ 'o' _ 'p' _ 't' _ 'o' _ ';', 7, 0x221d, 1)
NAMED_CHARACTER_REFERENCE(1660, 'p' _ 'r' _ 's' _ 'i' _ 'm' _ ';', 6, 0x227e, 1)
NAMED_CHARACTER_REFERENCE(1661, 'p' _ 'r' _ 'u' _ 'r' _ 'e' _ 'l' _ ';', 7, 0x22b0, 1)
NAMED_CHARACTER_REFERENCE(1662, 'p' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc5, 2)
NAMED_CHARACTER_REFERENCE(1663, 'p' _ 's' _ 'i' _ ';', 4, 0x03c8, 1)
NAMED_CHARACTER_REFERENCE(1664, 'p' _ 'u' _ 'n' _ 'c' _ 's' _ 'p' _ ';', 7, 0x2008, 1)
NAMED_CHARACTER_REFERENCE(1665, 'q' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd2e, 2)
NAMED_CHARACTER_REFERENCE(1666, 'q' _ 'i' _ 'n' _ 't' _ ';', 5, 0x2a0c, 1)
NAMED_CHARACTER_REFERENCE(1667, 'q' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd62, 2)
NAMED_CHARACTER_REFERENCE(1668, 'q' _ 'p' _ 'r' _ 'i' _ 'm' _ 'e' _ ';', 7, 0x2057, 1)
NAMED_CHARACTER_REFERENCE(1669, 'q' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc6, 2)
NAMED_CHARACTER_REFERENCE(1670, 'q' _ 'u' _ 'a' _ 't' _ 'e' _ 'r' _ 'n' _ 'i' _ 'o' _ 'n' _ 's' _ ';', 12, 0x210d, 1)
NAMED_CHARACTER_REFERENCE(1671, 'q' _ 'u' _ 'a' _ 't' _ 'i' _ 'n' _ 't' _ ';', 8, 0x2a16, 1)
NAMED_CHARACTER_REFERENCE(1672, 'q' _ 'u' _ 'e' _ 's' _ 't' _ ';', 6, 0x003f, 1)
NAMED_CHARACTER_REFERENCE(1673, 'q' _ 'u' _ 'e' _ 's' _ 't' _ 'e' _ 'q' _ ';', 8, 0x225f, 1)
NAMED_CHARACTER_REFERENCE(1674, 'q' _ 'u' _ 'o' _ 't', 4, 0x0022, 1)
NAMED_CHARACTER_REFERENCE(1675, 'q' _ 'u' _ 'o' _ 't' _ ';', 5, 0x0022, 1)
NAMED_CHARACTER_REFERENCE(1676, 'r' _ 'A' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21db, 1)
NAMED_CHARACTER_REFERENCE(1677, 'r' _ 'A' _ 'r' _ 'r' _ ';', 5, 0x21d2, 1)
NAMED_CHARACTER_REFERENCE(1678, 'r' _ 'A' _ 't' _ 'a' _ 'i' _ 'l' _ ';', 7, 0x291c, 1)
NAMED_CHARACTER_REFERENCE(1679, 'r' _ 'B' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x290f, 1)
NAMED_CHARACTER_REFERENCE(1680, 'r' _ 'H' _ 'a' _ 'r' _ ';', 5, 0x2964, 1)
NAMED_CHARACTER_REFERENCE(1681, 'r' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x0155, 1)
NAMED_CHARACTER_REFERENCE(1682, 'r' _ 'a' _ 'd' _ 'i' _ 'c' _ ';', 6, 0x221a, 1)
NAMED_CHARACTER_REFERENCE(1683, 'r' _ 'a' _ 'e' _ 'm' _ 'p' _ 't' _ 'y' _ 'v' _ ';', 9, 0x29b3, 1)
NAMED_CHARACTER_REFERENCE(1684, 'r' _ 'a' _ 'n' _ 'g' _ ';', 5, 0x27e9, 1)
NAMED_CHARACTER_REFERENCE(1685, 'r' _ 'a' _ 'n' _ 'g' _ 'd' _ ';', 6, 0x2992, 1)
NAMED_CHARACTER_REFERENCE(1686, 'r' _ 'a' _ 'n' _ 'g' _ 'e' _ ';', 6, 0x29a5, 1)
NAMED_CHARACTER_REFERENCE(1687, 'r' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 7, 0x27e9, 1)
NAMED_CHARACTER_REFERENCE(1688, 'r' _ 'a' _ 'q' _ 'u' _ 'o', 5, 0x00bb, 1)
NAMED_CHARACTER_REFERENCE(1689, 'r' _ 'a' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x00bb, 1)
NAMED_CHARACTER_REFERENCE(1690, 'r' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x2192, 1)
NAMED_CHARACTER_REFERENCE(1691, 'r' _ 'a' _ 'r' _ 'r' _ 'a' _ 'p' _ ';', 7, 0x2975, 1)
NAMED_CHARACTER_REFERENCE(1692, 'r' _ 'a' _ 'r' _ 'r' _ 'b' _ ';', 6, 0x21e5, 1)
NAMED_CHARACTER_REFERENCE(1693, 'r' _ 'a' _ 'r' _ 'r' _ 'b' _ 'f' _ 's' _ ';', 8, 0x2920, 1)
NAMED_CHARACTER_REFERENCE(1694, 'r' _ 'a' _ 'r' _ 'r' _ 'c' _ ';', 6, 0x2933, 1)
NAMED_CHARACTER_REFERENCE(1695, 'r' _ 'a' _ 'r' _ 'r' _ 'f' _ 's' _ ';', 7, 0x291e, 1)
NAMED_CHARACTER_REFERENCE(1696, 'r' _ 'a' _ 'r' _ 'r' _ 'h' _ 'k' _ ';', 7, 0x21aa, 1)
NAMED_CHARACTER_REFERENCE(1697, 'r' _ 'a' _ 'r' _ 'r' _ 'l' _ 'p' _ ';', 7, 0x21ac, 1)
NAMED_CHARACTER_REFERENCE(1698, 'r' _ 'a' _ 'r' _ 'r' _ 'p' _ 'l' _ ';', 7, 0x2945, 1)
NAMED_CHARACTER_REFERENCE(1699, 'r' _ 'a' _ 'r' _ 'r' _ 's' _ 'i' _ 'm' _ ';', 8, 0x2974, 1)
NAMED_CHARACTER_REFERENCE(1700, 'r' _ 'a' _ 'r' _ 'r' _ 't' _ 'l' _ ';', 7, 0x21a3, 1)
NAMED_CHARACTER_REFERENCE(1701, 'r' _ 'a' _ 'r' _ 'r' _ 'w' _ ';', 6, 0x219d, 1)
NAMED_CHARACTER_REFERENCE(1702, 'r' _ 'a' _ 't' _ 'a' _ 'i' _ 'l' _ ';', 7, 0x291a, 1)
NAMED_CHARACTER_REFERENCE(1703, 'r' _ 'a' _ 't' _ 'i' _ 'o' _ ';', 6, 0x2236, 1)
NAMED_CHARACTER_REFERENCE(1704, 'r' _ 'a' _ 't' _ 'i' _ 'o' _ 'n' _ 'a' _ 'l' _ 's' _ ';', 10, 0x211a, 1)
NAMED_CHARACTER_REFERENCE(1705, 'r' _ 'b' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x290d, 1)
NAMED_CHARACTER_REFERENCE(1706, 'r' _ 'b' _ 'b' _ 'r' _ 'k' _ ';', 6, 0x2773, 1)
NAMED_CHARACTER_REFERENCE(1707, 'r' _ 'b' _ 'r' _ 'a' _ 'c' _ 'e' _ ';', 7, 0x007d, 1)
NAMED_CHARACTER_REFERENCE(1708, 'r' _ 'b' _ 'r' _ 'a' _ 'c' _ 'k' _ ';', 7, 0x005d, 1)
NAMED_CHARACTER_REFERENCE(1709, 'r' _ 'b' _ 'r' _ 'k' _ 'e' _ ';', 6, 0x298c, 1)
NAMED_CHARACTER_REFERENCE(1710, 'r' _ 'b' _ 'r' _ 'k' _ 's' _ 'l' _ 'd' _ ';', 8, 0x298e, 1)
NAMED_CHARACTER_REFERENCE(1711, 'r' _ 'b' _ 'r' _ 'k' _ 's' _ 'l' _ 'u' _ ';', 8, 0x2990, 1)
NAMED_CHARACTER_REFERENCE(1712, 'r' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0159, 1)
NAMED_CHARACTER_REFERENCE(1713, 'r' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0157, 1)
NAMED_CHARACTER_REFERENCE(1714, 'r' _ 'c' _ 'e' _ 'i' _ 'l' _ ';', 6, 0x2309, 1)
NAMED_CHARACTER_REFERENCE(1715, 'r' _ 'c' _ 'u' _ 'b' _ ';', 5, 0x007d, 1)
NAMED_CHARACTER_REFERENCE(1716, 'r' _ 'c' _ 'y' _ ';', 4, 0x0440, 1)
NAMED_CHARACTER_REFERENCE(1717, 'r' _ 'd' _ 'c' _ 'a' _ ';', 5, 0x2937, 1)
NAMED_CHARACTER_REFERENCE(1718, 'r' _ 'd' _ 'l' _ 'd' _ 'h' _ 'a' _ 'r' _ ';', 8, 0x2969, 1)
NAMED_CHARACTER_REFERENCE(1719, 'r' _ 'd' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x201d, 1)
NAMED_CHARACTER_REFERENCE(1720, 'r' _ 'd' _ 'q' _ 'u' _ 'o' _ 'r' _ ';', 7, 0x201d, 1)
NAMED_CHARACTER_REFERENCE(1721, 'r' _ 'd' _ 's' _ 'h' _ ';', 5, 0x21b3, 1)
NAMED_CHARACTER_REFERENCE(1722, 'r' _ 'e' _ 'a' _ 'l' _ ';', 5, 0x211c, 1)
NAMED_CHARACTER_REFERENCE(1723, 'r' _ 'e' _ 'a' _ 'l' _ 'i' _ 'n' _ 'e' _ ';', 8, 0x211b, 1)
NAMED_CHARACTER_REFERENCE(1724, 'r' _ 'e' _ 'a' _ 'l' _ 'p' _ 'a' _ 'r' _ 't' _ ';', 9, 0x211c, 1)
NAMED_CHARACTER_REFERENCE(1725, 'r' _ 'e' _ 'a' _ 'l' _ 's' _ ';', 6, 0x211d, 1)
NAMED_CHARACTER_REFERENCE(1726, 'r' _ 'e' _ 'c' _ 't' _ ';', 5, 0x25ad, 1)
NAMED_CHARACTER_REFERENCE(1727, 'r' _ 'e' _ 'g', 3, 0x00ae, 1)
NAMED_CHARACTER_REFERENCE(1728, 'r' _ 'e' _ 'g' _ ';', 4, 0x00ae, 1)
NAMED_CHARACTER_REFERENCE(1729, 'r' _ 'f' _ 'i' _ 's' _ 'h' _ 't' _ ';', 7, 0x297d, 1)
NAMED_CHARACTER_REFERENCE(1730, 'r' _ 'f' _ 'l' _ 'o' _ 'o' _ 'r' _ ';', 7, 0x230b, 1)
NAMED_CHARACTER_REFERENCE(1731, 'r' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd2f, 2)
NAMED_CHARACTER_REFERENCE(1732, 'r' _ 'h' _ 'a' _ 'r' _ 'd' _ ';', 6, 0x21c1, 1)
NAMED_CHARACTER_REFERENCE(1733, 'r' _ 'h' _ 'a' _ 'r' _ 'u' _ ';', 6, 0x21c0, 1)
NAMED_CHARACTER_REFERENCE(1734, 'r' _ 'h' _ 'a' _ 'r' _ 'u' _ 'l' _ ';', 7, 0x296c, 1)
NAMED_CHARACTER_REFERENCE(1735, 'r' _ 'h' _ 'o' _ ';', 4, 0x03c1, 1)
NAMED_CHARACTER_REFERENCE(1736, 'r' _ 'h' _ 'o' _ 'v' _ ';', 5, 0x03f1, 1)
NAMED_CHARACTER_REFERENCE(1737, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 11, 0x2192, 1)
NAMED_CHARACTER_REFERENCE(1738, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 't' _ 'a' _ 'i' _ 'l' _ ';', 15, 0x21a3, 1)
NAMED_CHARACTER_REFERENCE(1739, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'd' _ 'o' _ 'w' _ 'n' _ ';', 17, 0x21c1, 1)
NAMED_CHARACTER_REFERENCE(1740, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'u' _ 'p' _ ';', 15, 0x21c0, 1)
NAMED_CHARACTER_REFERENCE(1741, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 's' _ ';', 16, 0x21c4, 1)
NAMED_CHARACTER_REFERENCE(1742, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'l' _ 'e' _ 'f' _ 't' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 's' _ ';', 18, 0x21cc, 1)
NAMED_CHARACTER_REFERENCE(1743, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 's' _ ';', 17, 0x21c9, 1)
NAMED_CHARACTER_REFERENCE(1744, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 's' _ 'q' _ 'u' _ 'i' _ 'g' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 16, 0x219d, 1)
NAMED_CHARACTER_REFERENCE(1745, 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 't' _ 'h' _ 'r' _ 'e' _ 'e' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 16, 0x22cc, 1)
NAMED_CHARACTER_REFERENCE(1746, 'r' _ 'i' _ 'n' _ 'g' _ ';', 5, 0x02da, 1)
NAMED_CHARACTER_REFERENCE(1747, 'r' _ 'i' _ 's' _ 'i' _ 'n' _ 'g' _ 'd' _ 'o' _ 't' _ 's' _ 'e' _ 'q' _ ';', 13, 0x2253, 1)
NAMED_CHARACTER_REFERENCE(1748, 'r' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21c4, 1)
NAMED_CHARACTER_REFERENCE(1749, 'r' _ 'l' _ 'h' _ 'a' _ 'r' _ ';', 6, 0x21cc, 1)
NAMED_CHARACTER_REFERENCE(1750, 'r' _ 'l' _ 'm' _ ';', 4, 0x200f, 1)
NAMED_CHARACTER_REFERENCE(1751, 'r' _ 'm' _ 'o' _ 'u' _ 's' _ 't' _ ';', 7, 0x23b1, 1)
NAMED_CHARACTER_REFERENCE(1752, 'r' _ 'm' _ 'o' _ 'u' _ 's' _ 't' _ 'a' _ 'c' _ 'h' _ 'e' _ ';', 11, 0x23b1, 1)
NAMED_CHARACTER_REFERENCE(1753, 'r' _ 'n' _ 'm' _ 'i' _ 'd' _ ';', 6, 0x2aee, 1)
NAMED_CHARACTER_REFERENCE(1754, 'r' _ 'o' _ 'a' _ 'n' _ 'g' _ ';', 6, 0x27ed, 1)
NAMED_CHARACTER_REFERENCE(1755, 'r' _ 'o' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21fe, 1)
NAMED_CHARACTER_REFERENCE(1756, 'r' _ 'o' _ 'b' _ 'r' _ 'k' _ ';', 6, 0x27e7, 1)
NAMED_CHARACTER_REFERENCE(1757, 'r' _ 'o' _ 'p' _ 'a' _ 'r' _ ';', 6, 0x2986, 1)
NAMED_CHARACTER_REFERENCE(1758, 'r' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd63, 2)
NAMED_CHARACTER_REFERENCE(1759, 'r' _ 'o' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 7, 0x2a2e, 1)
NAMED_CHARACTER_REFERENCE(1760, 'r' _ 'o' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 8, 0x2a35, 1)
NAMED_CHARACTER_REFERENCE(1761, 'r' _ 'p' _ 'a' _ 'r' _ ';', 5, 0x0029, 1)
NAMED_CHARACTER_REFERENCE(1762, 'r' _ 'p' _ 'a' _ 'r' _ 'g' _ 't' _ ';', 7, 0x2994, 1)
NAMED_CHARACTER_REFERENCE(1763, 'r' _ 'p' _ 'p' _ 'o' _ 'l' _ 'i' _ 'n' _ 't' _ ';', 9, 0x2a12, 1)
NAMED_CHARACTER_REFERENCE(1764, 'r' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21c9, 1)
NAMED_CHARACTER_REFERENCE(1765, 'r' _ 's' _ 'a' _ 'q' _ 'u' _ 'o' _ ';', 7, 0x203a, 1)
NAMED_CHARACTER_REFERENCE(1766, 'r' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc7, 2)
NAMED_CHARACTER_REFERENCE(1767, 'r' _ 's' _ 'h' _ ';', 4, 0x21b1, 1)
NAMED_CHARACTER_REFERENCE(1768, 'r' _ 's' _ 'q' _ 'b' _ ';', 5, 0x005d, 1)
NAMED_CHARACTER_REFERENCE(1769, 'r' _ 's' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x2019, 1)
NAMED_CHARACTER_REFERENCE(1770, 'r' _ 's' _ 'q' _ 'u' _ 'o' _ 'r' _ ';', 7, 0x2019, 1)
NAMED_CHARACTER_REFERENCE(1771, 'r' _ 't' _ 'h' _ 'r' _ 'e' _ 'e' _ ';', 7, 0x22cc, 1)
NAMED_CHARACTER_REFERENCE(1772, 'r' _ 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 7, 0x22ca, 1)
NAMED_CHARACTER_REFERENCE(1773, 'r' _ 't' _ 'r' _ 'i' _ ';', 5, 0x25b9, 1)
NAMED_CHARACTER_REFERENCE(1774, 'r' _ 't' _ 'r' _ 'i' _ 'e' _ ';', 6, 0x22b5, 1)
NAMED_CHARACTER_REFERENCE(1775, 'r' _ 't' _ 'r' _ 'i' _ 'f' _ ';', 6, 0x25b8, 1)
NAMED_CHARACTER_REFERENCE(1776, 'r' _ 't' _ 'r' _ 'i' _ 'l' _ 't' _ 'r' _ 'i' _ ';', 9, 0x29ce, 1)
NAMED_CHARACTER_REFERENCE(1777, 'r' _ 'u' _ 'l' _ 'u' _ 'h' _ 'a' _ 'r' _ ';', 8, 0x2968, 1)
NAMED_CHARACTER_REFERENCE(1778, 'r' _ 'x' _ ';', 3, 0x211e, 1)
NAMED_CHARACTER_REFERENCE(1779, 's' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x015b, 1)
NAMED_CHARACTER_REFERENCE(1780, 's' _ 'b' _ 'q' _ 'u' _ 'o' _ ';', 6, 0x201a, 1)
NAMED_CHARACTER_REFERENCE(1781, 's' _ 'c' _ ';', 3, 0x227b, 1)
NAMED_CHARACTER_REFERENCE(1782, 's' _ 'c' _ 'E' _ ';', 4, 0x2ab4, 1)
NAMED_CHARACTER_REFERENCE(1783, 's' _ 'c' _ 'a' _ 'p' _ ';', 5, 0x2ab8, 1)
NAMED_CHARACTER_REFERENCE(1784, 's' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0161, 1)
NAMED_CHARACTER_REFERENCE(1785, 's' _ 'c' _ 'c' _ 'u' _ 'e' _ ';', 6, 0x227d, 1)
NAMED_CHARACTER_REFERENCE(1786, 's' _ 'c' _ 'e' _ ';', 4, 0x2ab0, 1)
NAMED_CHARACTER_REFERENCE(1787, 's' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x015f, 1)
NAMED_CHARACTER_REFERENCE(1788, 's' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x015d, 1)
NAMED_CHARACTER_REFERENCE(1789, 's' _ 'c' _ 'n' _ 'E' _ ';', 5, 0x2ab6, 1)
NAMED_CHARACTER_REFERENCE(1790, 's' _ 'c' _ 'n' _ 'a' _ 'p' _ ';', 6, 0x2aba, 1)
NAMED_CHARACTER_REFERENCE(1791, 's' _ 'c' _ 'n' _ 's' _ 'i' _ 'm' _ ';', 7, 0x22e9, 1)
NAMED_CHARACTER_REFERENCE(1792, 's' _ 'c' _ 'p' _ 'o' _ 'l' _ 'i' _ 'n' _ 't' _ ';', 9, 0x2a13, 1)
NAMED_CHARACTER_REFERENCE(1793, 's' _ 'c' _ 's' _ 'i' _ 'm' _ ';', 6, 0x227f, 1)
NAMED_CHARACTER_REFERENCE(1794, 's' _ 'c' _ 'y' _ ';', 4, 0x0441, 1)
NAMED_CHARACTER_REFERENCE(1795, 's' _ 'd' _ 'o' _ 't' _ ';', 5, 0x22c5, 1)
NAMED_CHARACTER_REFERENCE(1796, 's' _ 'd' _ 'o' _ 't' _ 'b' _ ';', 6, 0x22a1, 1)
NAMED_CHARACTER_REFERENCE(1797, 's' _ 'd' _ 'o' _ 't' _ 'e' _ ';', 6, 0x2a66, 1)
NAMED_CHARACTER_REFERENCE(1798, 's' _ 'e' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x21d8, 1)
NAMED_CHARACTER_REFERENCE(1799, 's' _ 'e' _ 'a' _ 'r' _ 'h' _ 'k' _ ';', 7, 0x2925, 1)
NAMED_CHARACTER_REFERENCE(1800, 's' _ 'e' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2198, 1)
NAMED_CHARACTER_REFERENCE(1801, 's' _ 'e' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x2198, 1)
NAMED_CHARACTER_REFERENCE(1802, 's' _ 'e' _ 'c' _ 't', 4, 0x00a7, 1)
NAMED_CHARACTER_REFERENCE(1803, 's' _ 'e' _ 'c' _ 't' _ ';', 5, 0x00a7, 1)
NAMED_CHARACTER_REFERENCE(1804, 's' _ 'e' _ 'm' _ 'i' _ ';', 5, 0x003b, 1)
NAMED_CHARACTER_REFERENCE(1805, 's' _ 'e' _ 's' _ 'w' _ 'a' _ 'r' _ ';', 7, 0x2929, 1)
NAMED_CHARACTER_REFERENCE(1806, 's' _ 'e' _ 't' _ 'm' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 9, 0x2216, 1)
NAMED_CHARACTER_REFERENCE(1807, 's' _ 'e' _ 't' _ 'm' _ 'n' _ ';', 6, 0x2216, 1)
NAMED_CHARACTER_REFERENCE(1808, 's' _ 'e' _ 'x' _ 't' _ ';', 5, 0x2736, 1)
NAMED_CHARACTER_REFERENCE(1809, 's' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd30, 2)
NAMED_CHARACTER_REFERENCE(1810, 's' _ 'f' _ 'r' _ 'o' _ 'w' _ 'n' _ ';', 7, 0x2322, 1)
NAMED_CHARACTER_REFERENCE(1811, 's' _ 'h' _ 'a' _ 'r' _ 'p' _ ';', 6, 0x266f, 1)
NAMED_CHARACTER_REFERENCE(1812, 's' _ 'h' _ 'c' _ 'h' _ 'c' _ 'y' _ ';', 7, 0x0449, 1)
NAMED_CHARACTER_REFERENCE(1813, 's' _ 'h' _ 'c' _ 'y' _ ';', 5, 0x0448, 1)
NAMED_CHARACTER_REFERENCE(1814, 's' _ 'h' _ 'o' _ 'r' _ 't' _ 'm' _ 'i' _ 'd' _ ';', 9, 0x2223, 1)
NAMED_CHARACTER_REFERENCE(1815, 's' _ 'h' _ 'o' _ 'r' _ 't' _ 'p' _ 'a' _ 'r' _ 'a' _ 'l' _ 'l' _ 'e' _ 'l' _ ';', 14, 0x2225, 1)
NAMED_CHARACTER_REFERENCE(1816, 's' _ 'h' _ 'y', 3, 0x00ad, 1)
NAMED_CHARACTER_REFERENCE(1817, 's' _ 'h' _ 'y' _ ';', 4, 0x00ad, 1)
NAMED_CHARACTER_REFERENCE(1818, 's' _ 'i' _ 'g' _ 'm' _ 'a' _ ';', 6, 0x03c3, 1)
NAMED_CHARACTER_REFERENCE(1819, 's' _ 'i' _ 'g' _ 'm' _ 'a' _ 'f' _ ';', 7, 0x03c2, 1)
NAMED_CHARACTER_REFERENCE(1820, 's' _ 'i' _ 'g' _ 'm' _ 'a' _ 'v' _ ';', 7, 0x03c2, 1)
NAMED_CHARACTER_REFERENCE(1821, 's' _ 'i' _ 'm' _ ';', 4, 0x223c, 1)
NAMED_CHARACTER_REFERENCE(1822, 's' _ 'i' _ 'm' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2a6a, 1)
NAMED_CHARACTER_REFERENCE(1823, 's' _ 'i' _ 'm' _ 'e' _ ';', 5, 0x2243, 1)
NAMED_CHARACTER_REFERENCE(1824, 's' _ 'i' _ 'm' _ 'e' _ 'q' _ ';', 6, 0x2243, 1)
NAMED_CHARACTER_REFERENCE(1825, 's' _ 'i' _ 'm' _ 'g' _ ';', 5, 0x2a9e, 1)
NAMED_CHARACTER_REFERENCE(1826, 's' _ 'i' _ 'm' _ 'g' _ 'E' _ ';', 6, 0x2aa0, 1)
NAMED_CHARACTER_REFERENCE(1827, 's' _ 'i' _ 'm' _ 'l' _ ';', 5, 0x2a9d, 1)
NAMED_CHARACTER_REFERENCE(1828, 's' _ 'i' _ 'm' _ 'l' _ 'E' _ ';', 6, 0x2a9f, 1)
NAMED_CHARACTER_REFERENCE(1829, 's' _ 'i' _ 'm' _ 'n' _ 'e' _ ';', 6, 0x2246, 1)
NAMED_CHARACTER_REFERENCE(1830, 's' _ 'i' _ 'm' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 8, 0x2a24, 1)
NAMED_CHARACTER_REFERENCE(1831, 's' _ 'i' _ 'm' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 8, 0x2972, 1)
NAMED_CHARACTER_REFERENCE(1832, 's' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2190, 1)
NAMED_CHARACTER_REFERENCE(1833, 's' _ 'm' _ 'a' _ 'l' _ 'l' _ 's' _ 'e' _ 't' _ 'm' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 14, 0x2216, 1)
NAMED_CHARACTER_REFERENCE(1834, 's' _ 'm' _ 'a' _ 's' _ 'h' _ 'p' _ ';', 7, 0x2a33, 1)
NAMED_CHARACTER_REFERENCE(1835, 's' _ 'm' _ 'e' _ 'p' _ 'a' _ 'r' _ 's' _ 'l' _ ';', 9, 0x29e4, 1)
NAMED_CHARACTER_REFERENCE(1836, 's' _ 'm' _ 'i' _ 'd' _ ';', 5, 0x2223, 1)
NAMED_CHARACTER_REFERENCE(1837, 's' _ 'm' _ 'i' _ 'l' _ 'e' _ ';', 6, 0x2323, 1)
NAMED_CHARACTER_REFERENCE(1838, 's' _ 'm' _ 't' _ ';', 4, 0x2aaa, 1)
NAMED_CHARACTER_REFERENCE(1839, 's' _ 'm' _ 't' _ 'e' _ ';', 5, 0x2aac, 1)
NAMED_CHARACTER_REFERENCE(1840, 's' _ 'o' _ 'f' _ 't' _ 'c' _ 'y' _ ';', 7, 0x044c, 1)
NAMED_CHARACTER_REFERENCE(1841, 's' _ 'o' _ 'l' _ ';', 4, 0x002f, 1)
NAMED_CHARACTER_REFERENCE(1842, 's' _ 'o' _ 'l' _ 'b' _ ';', 5, 0x29c4, 1)
NAMED_CHARACTER_REFERENCE(1843, 's' _ 'o' _ 'l' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x233f, 1)
NAMED_CHARACTER_REFERENCE(1844, 's' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd64, 2)
NAMED_CHARACTER_REFERENCE(1845, 's' _ 'p' _ 'a' _ 'd' _ 'e' _ 's' _ ';', 7, 0x2660, 1)
NAMED_CHARACTER_REFERENCE(1846, 's' _ 'p' _ 'a' _ 'd' _ 'e' _ 's' _ 'u' _ 'i' _ 't' _ ';', 10, 0x2660, 1)
NAMED_CHARACTER_REFERENCE(1847, 's' _ 'p' _ 'a' _ 'r' _ ';', 5, 0x2225, 1)
NAMED_CHARACTER_REFERENCE(1848, 's' _ 'q' _ 'c' _ 'a' _ 'p' _ ';', 6, 0x2293, 1)
NAMED_CHARACTER_REFERENCE(1849, 's' _ 'q' _ 'c' _ 'u' _ 'p' _ ';', 6, 0x2294, 1)
NAMED_CHARACTER_REFERENCE(1850, 's' _ 'q' _ 's' _ 'u' _ 'b' _ ';', 6, 0x228f, 1)
NAMED_CHARACTER_REFERENCE(1851, 's' _ 'q' _ 's' _ 'u' _ 'b' _ 'e' _ ';', 7, 0x2291, 1)
NAMED_CHARACTER_REFERENCE(1852, 's' _ 'q' _ 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ ';', 9, 0x228f, 1)
NAMED_CHARACTER_REFERENCE(1853, 's' _ 'q' _ 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ ';', 11, 0x2291, 1)
NAMED_CHARACTER_REFERENCE(1854, 's' _ 'q' _ 's' _ 'u' _ 'p' _ ';', 6, 0x2290, 1)
NAMED_CHARACTER_REFERENCE(1855, 's' _ 'q' _ 's' _ 'u' _ 'p' _ 'e' _ ';', 7, 0x2292, 1)
NAMED_CHARACTER_REFERENCE(1856, 's' _ 'q' _ 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ ';', 9, 0x2290, 1)
NAMED_CHARACTER_REFERENCE(1857, 's' _ 'q' _ 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ ';', 11, 0x2292, 1)
NAMED_CHARACTER_REFERENCE(1858, 's' _ 'q' _ 'u' _ ';', 4, 0x25a1, 1)
NAMED_CHARACTER_REFERENCE(1859, 's' _ 'q' _ 'u' _ 'a' _ 'r' _ 'e' _ ';', 7, 0x25a1, 1)
NAMED_CHARACTER_REFERENCE(1860, 's' _ 'q' _ 'u' _ 'a' _ 'r' _ 'f' _ ';', 7, 0x25aa, 1)
NAMED_CHARACTER_REFERENCE(1861, 's' _ 'q' _ 'u' _ 'f' _ ';', 5, 0x25aa, 1)
NAMED_CHARACTER_REFERENCE(1862, 's' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2192, 1)
NAMED_CHARACTER_REFERENCE(1863, 's' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc8, 2)
NAMED_CHARACTER_REFERENCE(1864, 's' _ 's' _ 'e' _ 't' _ 'm' _ 'n' _ ';', 7, 0x2216, 1)
NAMED_CHARACTER_REFERENCE(1865, 's' _ 's' _ 'm' _ 'i' _ 'l' _ 'e' _ ';', 7, 0x2323, 1)
NAMED_CHARACTER_REFERENCE(1866, 's' _ 's' _ 't' _ 'a' _ 'r' _ 'f' _ ';', 7, 0x22c6, 1)
NAMED_CHARACTER_REFERENCE(1867, 's' _ 't' _ 'a' _ 'r' _ ';', 5, 0x2606, 1)
NAMED_CHARACTER_REFERENCE(1868, 's' _ 't' _ 'a' _ 'r' _ 'f' _ ';', 6, 0x2605, 1)
NAMED_CHARACTER_REFERENCE(1869, 's' _ 't' _ 'r' _ 'a' _ 'i' _ 'g' _ 'h' _ 't' _ 'e' _ 'p' _ 's' _ 'i' _ 'l' _ 'o' _ 'n' _ ';', 16, 0x03f5, 1)
NAMED_CHARACTER_REFERENCE(1870, 's' _ 't' _ 'r' _ 'a' _ 'i' _ 'g' _ 'h' _ 't' _ 'p' _ 'h' _ 'i' _ ';', 12, 0x03d5, 1)
NAMED_CHARACTER_REFERENCE(1871, 's' _ 't' _ 'r' _ 'n' _ 's' _ ';', 6, 0x00af, 1)
NAMED_CHARACTER_REFERENCE(1872, 's' _ 'u' _ 'b' _ ';', 4, 0x2282, 1)
NAMED_CHARACTER_REFERENCE(1873, 's' _ 'u' _ 'b' _ 'E' _ ';', 5, 0x2ac5, 1)
NAMED_CHARACTER_REFERENCE(1874, 's' _ 'u' _ 'b' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2abd, 1)
NAMED_CHARACTER_REFERENCE(1875, 's' _ 'u' _ 'b' _ 'e' _ ';', 5, 0x2286, 1)
NAMED_CHARACTER_REFERENCE(1876, 's' _ 'u' _ 'b' _ 'e' _ 'd' _ 'o' _ 't' _ ';', 8, 0x2ac3, 1)
NAMED_CHARACTER_REFERENCE(1877, 's' _ 'u' _ 'b' _ 'm' _ 'u' _ 'l' _ 't' _ ';', 8, 0x2ac1, 1)
NAMED_CHARACTER_REFERENCE(1878, 's' _ 'u' _ 'b' _ 'n' _ 'E' _ ';', 6, 0x2acb, 1)
NAMED_CHARACTER_REFERENCE(1879, 's' _ 'u' _ 'b' _ 'n' _ 'e' _ ';', 6, 0x228a, 1)
NAMED_CHARACTER_REFERENCE(1880, 's' _ 'u' _ 'b' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 8, 0x2abf, 1)
NAMED_CHARACTER_REFERENCE(1881, 's' _ 'u' _ 'b' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 8, 0x2979, 1)
NAMED_CHARACTER_REFERENCE(1882, 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ ';', 7, 0x2282, 1)
NAMED_CHARACTER_REFERENCE(1883, 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ ';', 9, 0x2286, 1)
NAMED_CHARACTER_REFERENCE(1884, 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ 'q' _ ';', 10, 0x2ac5, 1)
NAMED_CHARACTER_REFERENCE(1885, 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'n' _ 'e' _ 'q' _ ';', 10, 0x228a, 1)
NAMED_CHARACTER_REFERENCE(1886, 's' _ 'u' _ 'b' _ 's' _ 'e' _ 't' _ 'n' _ 'e' _ 'q' _ 'q' _ ';', 11, 0x2acb, 1)
NAMED_CHARACTER_REFERENCE(1887, 's' _ 'u' _ 'b' _ 's' _ 'i' _ 'm' _ ';', 7, 0x2ac7, 1)
NAMED_CHARACTER_REFERENCE(1888, 's' _ 'u' _ 'b' _ 's' _ 'u' _ 'b' _ ';', 7, 0x2ad5, 1)
NAMED_CHARACTER_REFERENCE(1889, 's' _ 'u' _ 'b' _ 's' _ 'u' _ 'p' _ ';', 7, 0x2ad3, 1)
NAMED_CHARACTER_REFERENCE(1890, 's' _ 'u' _ 'c' _ 'c' _ ';', 5, 0x227b, 1)
NAMED_CHARACTER_REFERENCE(1891, 's' _ 'u' _ 'c' _ 'c' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 11, 0x2ab8, 1)
NAMED_CHARACTER_REFERENCE(1892, 's' _ 'u' _ 'c' _ 'c' _ 'c' _ 'u' _ 'r' _ 'l' _ 'y' _ 'e' _ 'q' _ ';', 12, 0x227d, 1)
NAMED_CHARACTER_REFERENCE(1893, 's' _ 'u' _ 'c' _ 'c' _ 'e' _ 'q' _ ';', 7, 0x2ab0, 1)
NAMED_CHARACTER_REFERENCE(1894, 's' _ 'u' _ 'c' _ 'c' _ 'n' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 12, 0x2aba, 1)
NAMED_CHARACTER_REFERENCE(1895, 's' _ 'u' _ 'c' _ 'c' _ 'n' _ 'e' _ 'q' _ 'q' _ ';', 9, 0x2ab6, 1)
NAMED_CHARACTER_REFERENCE(1896, 's' _ 'u' _ 'c' _ 'c' _ 'n' _ 's' _ 'i' _ 'm' _ ';', 9, 0x22e9, 1)
NAMED_CHARACTER_REFERENCE(1897, 's' _ 'u' _ 'c' _ 'c' _ 's' _ 'i' _ 'm' _ ';', 8, 0x227f, 1)
NAMED_CHARACTER_REFERENCE(1898, 's' _ 'u' _ 'm' _ ';', 4, 0x2211, 1)
NAMED_CHARACTER_REFERENCE(1899, 's' _ 'u' _ 'n' _ 'g' _ ';', 5, 0x266a, 1)
NAMED_CHARACTER_REFERENCE(1900, 's' _ 'u' _ 'p' _ '1', 4, 0x00b9, 1)
NAMED_CHARACTER_REFERENCE(1901, 's' _ 'u' _ 'p' _ '1' _ ';', 5, 0x00b9, 1)
NAMED_CHARACTER_REFERENCE(1902, 's' _ 'u' _ 'p' _ '2', 4, 0x00b2, 1)
NAMED_CHARACTER_REFERENCE(1903, 's' _ 'u' _ 'p' _ '2' _ ';', 5, 0x00b2, 1)
NAMED_CHARACTER_REFERENCE(1904, 's' _ 'u' _ 'p' _ '3', 4, 0x00b3, 1)
NAMED_CHARACTER_REFERENCE(1905, 's' _ 'u' _ 'p' _ '3' _ ';', 5, 0x00b3, 1)
NAMED_CHARACTER_REFERENCE(1906, 's' _ 'u' _ 'p' _ ';', 4, 0x2283, 1)
NAMED_CHARACTER_REFERENCE(1907, 's' _ 'u' _ 'p' _ 'E' _ ';', 5, 0x2ac6, 1)
NAMED_CHARACTER_REFERENCE(1908, 's' _ 'u' _ 'p' _ 'd' _ 'o' _ 't' _ ';', 7, 0x2abe, 1)
NAMED_CHARACTER_REFERENCE(1909, 's' _ 'u' _ 'p' _ 'd' _ 's' _ 'u' _ 'b' _ ';', 8, 0x2ad8, 1)
NAMED_CHARACTER_REFERENCE(1910, 's' _ 'u' _ 'p' _ 'e' _ ';', 5, 0x2287, 1)
NAMED_CHARACTER_REFERENCE(1911, 's' _ 'u' _ 'p' _ 'e' _ 'd' _ 'o' _ 't' _ ';', 8, 0x2ac4, 1)
NAMED_CHARACTER_REFERENCE(1912, 's' _ 'u' _ 'p' _ 'h' _ 's' _ 'o' _ 'l' _ ';', 8, 0x27c9, 1)
NAMED_CHARACTER_REFERENCE(1913, 's' _ 'u' _ 'p' _ 'h' _ 's' _ 'u' _ 'b' _ ';', 8, 0x2ad7, 1)
NAMED_CHARACTER_REFERENCE(1914, 's' _ 'u' _ 'p' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 8, 0x297b, 1)
NAMED_CHARACTER_REFERENCE(1915, 's' _ 'u' _ 'p' _ 'm' _ 'u' _ 'l' _ 't' _ ';', 8, 0x2ac2, 1)
NAMED_CHARACTER_REFERENCE(1916, 's' _ 'u' _ 'p' _ 'n' _ 'E' _ ';', 6, 0x2acc, 1)
NAMED_CHARACTER_REFERENCE(1917, 's' _ 'u' _ 'p' _ 'n' _ 'e' _ ';', 6, 0x228b, 1)
NAMED_CHARACTER_REFERENCE(1918, 's' _ 'u' _ 'p' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 8, 0x2ac0, 1)
NAMED_CHARACTER_REFERENCE(1919, 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ ';', 7, 0x2283, 1)
NAMED_CHARACTER_REFERENCE(1920, 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ ';', 9, 0x2287, 1)
NAMED_CHARACTER_REFERENCE(1921, 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ 'e' _ 'q' _ 'q' _ ';', 10, 0x2ac6, 1)
NAMED_CHARACTER_REFERENCE(1922, 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ 'n' _ 'e' _ 'q' _ ';', 10, 0x228b, 1)
NAMED_CHARACTER_REFERENCE(1923, 's' _ 'u' _ 'p' _ 's' _ 'e' _ 't' _ 'n' _ 'e' _ 'q' _ 'q' _ ';', 11, 0x2acc, 1)
NAMED_CHARACTER_REFERENCE(1924, 's' _ 'u' _ 'p' _ 's' _ 'i' _ 'm' _ ';', 7, 0x2ac8, 1)
NAMED_CHARACTER_REFERENCE(1925, 's' _ 'u' _ 'p' _ 's' _ 'u' _ 'b' _ ';', 7, 0x2ad4, 1)
NAMED_CHARACTER_REFERENCE(1926, 's' _ 'u' _ 'p' _ 's' _ 'u' _ 'p' _ ';', 7, 0x2ad6, 1)
NAMED_CHARACTER_REFERENCE(1927, 's' _ 'w' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x21d9, 1)
NAMED_CHARACTER_REFERENCE(1928, 's' _ 'w' _ 'a' _ 'r' _ 'h' _ 'k' _ ';', 7, 0x2926, 1)
NAMED_CHARACTER_REFERENCE(1929, 's' _ 'w' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x2199, 1)
NAMED_CHARACTER_REFERENCE(1930, 's' _ 'w' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x2199, 1)
NAMED_CHARACTER_REFERENCE(1931, 's' _ 'w' _ 'n' _ 'w' _ 'a' _ 'r' _ ';', 7, 0x292a, 1)
NAMED_CHARACTER_REFERENCE(1932, 's' _ 'z' _ 'l' _ 'i' _ 'g', 5, 0x00df, 1)
NAMED_CHARACTER_REFERENCE(1933, 's' _ 'z' _ 'l' _ 'i' _ 'g' _ ';', 6, 0x00df, 1)
NAMED_CHARACTER_REFERENCE(1934, 't' _ 'a' _ 'r' _ 'g' _ 'e' _ 't' _ ';', 7, 0x2316, 1)
NAMED_CHARACTER_REFERENCE(1935, 't' _ 'a' _ 'u' _ ';', 4, 0x03c4, 1)
NAMED_CHARACTER_REFERENCE(1936, 't' _ 'b' _ 'r' _ 'k' _ ';', 5, 0x23b4, 1)
NAMED_CHARACTER_REFERENCE(1937, 't' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x0165, 1)
NAMED_CHARACTER_REFERENCE(1938, 't' _ 'c' _ 'e' _ 'd' _ 'i' _ 'l' _ ';', 7, 0x0163, 1)
NAMED_CHARACTER_REFERENCE(1939, 't' _ 'c' _ 'y' _ ';', 4, 0x0442, 1)
NAMED_CHARACTER_REFERENCE(1940, 't' _ 'd' _ 'o' _ 't' _ ';', 5, 0x20db, 1)
NAMED_CHARACTER_REFERENCE(1941, 't' _ 'e' _ 'l' _ 'r' _ 'e' _ 'c' _ ';', 7, 0x2315, 1)
NAMED_CHARACTER_REFERENCE(1942, 't' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd31, 2)
NAMED_CHARACTER_REFERENCE(1943, 't' _ 'h' _ 'e' _ 'r' _ 'e' _ '4' _ ';', 7, 0x2234, 1)
NAMED_CHARACTER_REFERENCE(1944, 't' _ 'h' _ 'e' _ 'r' _ 'e' _ 'f' _ 'o' _ 'r' _ 'e' _ ';', 10, 0x2234, 1)
NAMED_CHARACTER_REFERENCE(1945, 't' _ 'h' _ 'e' _ 't' _ 'a' _ ';', 6, 0x03b8, 1)
NAMED_CHARACTER_REFERENCE(1946, 't' _ 'h' _ 'e' _ 't' _ 'a' _ 's' _ 'y' _ 'm' _ ';', 9, 0x03d1, 1)
NAMED_CHARACTER_REFERENCE(1947, 't' _ 'h' _ 'e' _ 't' _ 'a' _ 'v' _ ';', 7, 0x03d1, 1)
NAMED_CHARACTER_REFERENCE(1948, 't' _ 'h' _ 'i' _ 'c' _ 'k' _ 'a' _ 'p' _ 'p' _ 'r' _ 'o' _ 'x' _ ';', 12, 0x2248, 1)
NAMED_CHARACTER_REFERENCE(1949, 't' _ 'h' _ 'i' _ 'c' _ 'k' _ 's' _ 'i' _ 'm' _ ';', 9, 0x223c, 1)
NAMED_CHARACTER_REFERENCE(1950, 't' _ 'h' _ 'i' _ 'n' _ 's' _ 'p' _ ';', 7, 0x2009, 1)
NAMED_CHARACTER_REFERENCE(1951, 't' _ 'h' _ 'k' _ 'a' _ 'p' _ ';', 6, 0x2248, 1)
NAMED_CHARACTER_REFERENCE(1952, 't' _ 'h' _ 'k' _ 's' _ 'i' _ 'm' _ ';', 7, 0x223c, 1)
NAMED_CHARACTER_REFERENCE(1953, 't' _ 'h' _ 'o' _ 'r' _ 'n', 5, 0x00fe, 1)
NAMED_CHARACTER_REFERENCE(1954, 't' _ 'h' _ 'o' _ 'r' _ 'n' _ ';', 6, 0x00fe, 1)
NAMED_CHARACTER_REFERENCE(1955, 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 6, 0x02dc, 1)
NAMED_CHARACTER_REFERENCE(1956, 't' _ 'i' _ 'm' _ 'e' _ 's', 5, 0x00d7, 1)
NAMED_CHARACTER_REFERENCE(1957, 't' _ 'i' _ 'm' _ 'e' _ 's' _ ';', 6, 0x00d7, 1)
NAMED_CHARACTER_REFERENCE(1958, 't' _ 'i' _ 'm' _ 'e' _ 's' _ 'b' _ ';', 7, 0x22a0, 1)
NAMED_CHARACTER_REFERENCE(1959, 't' _ 'i' _ 'm' _ 'e' _ 's' _ 'b' _ 'a' _ 'r' _ ';', 9, 0x2a31, 1)
NAMED_CHARACTER_REFERENCE(1960, 't' _ 'i' _ 'm' _ 'e' _ 's' _ 'd' _ ';', 7, 0x2a30, 1)
NAMED_CHARACTER_REFERENCE(1961, 't' _ 'i' _ 'n' _ 't' _ ';', 5, 0x222d, 1)
NAMED_CHARACTER_REFERENCE(1962, 't' _ 'o' _ 'e' _ 'a' _ ';', 5, 0x2928, 1)
NAMED_CHARACTER_REFERENCE(1963, 't' _ 'o' _ 'p' _ ';', 4, 0x22a4, 1)
NAMED_CHARACTER_REFERENCE(1964, 't' _ 'o' _ 'p' _ 'b' _ 'o' _ 't' _ ';', 7, 0x2336, 1)
NAMED_CHARACTER_REFERENCE(1965, 't' _ 'o' _ 'p' _ 'c' _ 'i' _ 'r' _ ';', 7, 0x2af1, 1)
NAMED_CHARACTER_REFERENCE(1966, 't' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd65, 2)
NAMED_CHARACTER_REFERENCE(1967, 't' _ 'o' _ 'p' _ 'f' _ 'o' _ 'r' _ 'k' _ ';', 8, 0x2ada, 1)
NAMED_CHARACTER_REFERENCE(1968, 't' _ 'o' _ 's' _ 'a' _ ';', 5, 0x2929, 1)
NAMED_CHARACTER_REFERENCE(1969, 't' _ 'p' _ 'r' _ 'i' _ 'm' _ 'e' _ ';', 7, 0x2034, 1)
NAMED_CHARACTER_REFERENCE(1970, 't' _ 'r' _ 'a' _ 'd' _ 'e' _ ';', 6, 0x2122, 1)
NAMED_CHARACTER_REFERENCE(1971, 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 9, 0x25b5, 1)
NAMED_CHARACTER_REFERENCE(1972, 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'd' _ 'o' _ 'w' _ 'n' _ ';', 13, 0x25bf, 1)
NAMED_CHARACTER_REFERENCE(1973, 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 13, 0x25c3, 1)
NAMED_CHARACTER_REFERENCE(1974, 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'l' _ 'e' _ 'f' _ 't' _ 'e' _ 'q' _ ';', 15, 0x22b4, 1)
NAMED_CHARACTER_REFERENCE(1975, 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'q' _ ';', 10, 0x225c, 1)
NAMED_CHARACTER_REFERENCE(1976, 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 14, 0x25b9, 1)
NAMED_CHARACTER_REFERENCE(1977, 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'e' _ 'q' _ ';', 16, 0x22b5, 1)
NAMED_CHARACTER_REFERENCE(1978, 't' _ 'r' _ 'i' _ 'd' _ 'o' _ 't' _ ';', 7, 0x25ec, 1)
NAMED_CHARACTER_REFERENCE(1979, 't' _ 'r' _ 'i' _ 'e' _ ';', 5, 0x225c, 1)
NAMED_CHARACTER_REFERENCE(1980, 't' _ 'r' _ 'i' _ 'm' _ 'i' _ 'n' _ 'u' _ 's' _ ';', 9, 0x2a3a, 1)
NAMED_CHARACTER_REFERENCE(1981, 't' _ 'r' _ 'i' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 8, 0x2a39, 1)
NAMED_CHARACTER_REFERENCE(1982, 't' _ 'r' _ 'i' _ 's' _ 'b' _ ';', 6, 0x29cd, 1)
NAMED_CHARACTER_REFERENCE(1983, 't' _ 'r' _ 'i' _ 't' _ 'i' _ 'm' _ 'e' _ ';', 8, 0x2a3b, 1)
NAMED_CHARACTER_REFERENCE(1984, 't' _ 'r' _ 'p' _ 'e' _ 'z' _ 'i' _ 'u' _ 'm' _ ';', 9, 0x23e2, 1)
NAMED_CHARACTER_REFERENCE(1985, 't' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcc9, 2)
NAMED_CHARACTER_REFERENCE(1986, 't' _ 's' _ 'c' _ 'y' _ ';', 5, 0x0446, 1)
NAMED_CHARACTER_REFERENCE(1987, 't' _ 's' _ 'h' _ 'c' _ 'y' _ ';', 6, 0x045b, 1)
NAMED_CHARACTER_REFERENCE(1988, 't' _ 's' _ 't' _ 'r' _ 'o' _ 'k' _ ';', 7, 0x0167, 1)
NAMED_CHARACTER_REFERENCE(1989, 't' _ 'w' _ 'i' _ 'x' _ 't' _ ';', 6, 0x226c, 1)
NAMED_CHARACTER_REFERENCE(1990, 't' _ 'w' _ 'o' _ 'h' _ 'e' _ 'a' _ 'd' _ 'l' _ 'e' _ 'f' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 17, 0x219e, 1)
NAMED_CHARACTER_REFERENCE(1991, 't' _ 'w' _ 'o' _ 'h' _ 'e' _ 'a' _ 'd' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 18, 0x21a0, 1)
NAMED_CHARACTER_REFERENCE(1992, 'u' _ 'A' _ 'r' _ 'r' _ ';', 5, 0x21d1, 1)
NAMED_CHARACTER_REFERENCE(1993, 'u' _ 'H' _ 'a' _ 'r' _ ';', 5, 0x2963, 1)
NAMED_CHARACTER_REFERENCE(1994, 'u' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00fa, 1)
NAMED_CHARACTER_REFERENCE(1995, 'u' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00fa, 1)
NAMED_CHARACTER_REFERENCE(1996, 'u' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x2191, 1)
NAMED_CHARACTER_REFERENCE(1997, 'u' _ 'b' _ 'r' _ 'c' _ 'y' _ ';', 6, 0x045e, 1)
NAMED_CHARACTER_REFERENCE(1998, 'u' _ 'b' _ 'r' _ 'e' _ 'v' _ 'e' _ ';', 7, 0x016d, 1)
NAMED_CHARACTER_REFERENCE(1999, 'u' _ 'c' _ 'i' _ 'r' _ 'c', 5, 0x00fb, 1)
NAMED_CHARACTER_REFERENCE(2000, 'u' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x00fb, 1)
NAMED_CHARACTER_REFERENCE(2001, 'u' _ 'c' _ 'y' _ ';', 4, 0x0443, 1)
NAMED_CHARACTER_REFERENCE(2002, 'u' _ 'd' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21c5, 1)
NAMED_CHARACTER_REFERENCE(2003, 'u' _ 'd' _ 'b' _ 'l' _ 'a' _ 'c' _ ';', 7, 0x0171, 1)
NAMED_CHARACTER_REFERENCE(2004, 'u' _ 'd' _ 'h' _ 'a' _ 'r' _ ';', 6, 0x296e, 1)
NAMED_CHARACTER_REFERENCE(2005, 'u' _ 'f' _ 'i' _ 's' _ 'h' _ 't' _ ';', 7, 0x297e, 1)
NAMED_CHARACTER_REFERENCE(2006, 'u' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd32, 2)
NAMED_CHARACTER_REFERENCE(2007, 'u' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e', 6, 0x00f9, 1)
NAMED_CHARACTER_REFERENCE(2008, 'u' _ 'g' _ 'r' _ 'a' _ 'v' _ 'e' _ ';', 7, 0x00f9, 1)
NAMED_CHARACTER_REFERENCE(2009, 'u' _ 'h' _ 'a' _ 'r' _ 'l' _ ';', 6, 0x21bf, 1)
NAMED_CHARACTER_REFERENCE(2010, 'u' _ 'h' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21be, 1)
NAMED_CHARACTER_REFERENCE(2011, 'u' _ 'h' _ 'b' _ 'l' _ 'k' _ ';', 6, 0x2580, 1)
NAMED_CHARACTER_REFERENCE(2012, 'u' _ 'l' _ 'c' _ 'o' _ 'r' _ 'n' _ ';', 7, 0x231c, 1)
NAMED_CHARACTER_REFERENCE(2013, 'u' _ 'l' _ 'c' _ 'o' _ 'r' _ 'n' _ 'e' _ 'r' _ ';', 9, 0x231c, 1)
NAMED_CHARACTER_REFERENCE(2014, 'u' _ 'l' _ 'c' _ 'r' _ 'o' _ 'p' _ ';', 7, 0x230f, 1)
NAMED_CHARACTER_REFERENCE(2015, 'u' _ 'l' _ 't' _ 'r' _ 'i' _ ';', 6, 0x25f8, 1)
NAMED_CHARACTER_REFERENCE(2016, 'u' _ 'm' _ 'a' _ 'c' _ 'r' _ ';', 6, 0x016b, 1)
NAMED_CHARACTER_REFERENCE(2017, 'u' _ 'm' _ 'l', 3, 0x00a8, 1)
NAMED_CHARACTER_REFERENCE(2018, 'u' _ 'm' _ 'l' _ ';', 4, 0x00a8, 1)
NAMED_CHARACTER_REFERENCE(2019, 'u' _ 'o' _ 'g' _ 'o' _ 'n' _ ';', 6, 0x0173, 1)
NAMED_CHARACTER_REFERENCE(2020, 'u' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd66, 2)
NAMED_CHARACTER_REFERENCE(2021, 'u' _ 'p' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 8, 0x2191, 1)
NAMED_CHARACTER_REFERENCE(2022, 'u' _ 'p' _ 'd' _ 'o' _ 'w' _ 'n' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ ';', 12, 0x2195, 1)
NAMED_CHARACTER_REFERENCE(2023, 'u' _ 'p' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 14, 0x21bf, 1)
NAMED_CHARACTER_REFERENCE(2024, 'u' _ 'p' _ 'h' _ 'a' _ 'r' _ 'p' _ 'o' _ 'o' _ 'n' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 15, 0x21be, 1)
NAMED_CHARACTER_REFERENCE(2025, 'u' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 6, 0x228e, 1)
NAMED_CHARACTER_REFERENCE(2026, 'u' _ 'p' _ 's' _ 'i' _ ';', 5, 0x03c5, 1)
NAMED_CHARACTER_REFERENCE(2027, 'u' _ 'p' _ 's' _ 'i' _ 'h' _ ';', 6, 0x03d2, 1)
NAMED_CHARACTER_REFERENCE(2028, 'u' _ 'p' _ 's' _ 'i' _ 'l' _ 'o' _ 'n' _ ';', 8, 0x03c5, 1)
NAMED_CHARACTER_REFERENCE(2029, 'u' _ 'p' _ 'u' _ 'p' _ 'a' _ 'r' _ 'r' _ 'o' _ 'w' _ 's' _ ';', 11, 0x21c8, 1)
NAMED_CHARACTER_REFERENCE(2030, 'u' _ 'r' _ 'c' _ 'o' _ 'r' _ 'n' _ ';', 7, 0x231d, 1)
NAMED_CHARACTER_REFERENCE(2031, 'u' _ 'r' _ 'c' _ 'o' _ 'r' _ 'n' _ 'e' _ 'r' _ ';', 9, 0x231d, 1)
NAMED_CHARACTER_REFERENCE(2032, 'u' _ 'r' _ 'c' _ 'r' _ 'o' _ 'p' _ ';', 7, 0x230e, 1)
NAMED_CHARACTER_REFERENCE(2033, 'u' _ 'r' _ 'i' _ 'n' _ 'g' _ ';', 6, 0x016f, 1)
NAMED_CHARACTER_REFERENCE(2034, 'u' _ 'r' _ 't' _ 'r' _ 'i' _ ';', 6, 0x25f9, 1)
NAMED_CHARACTER_REFERENCE(2035, 'u' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcca, 2)
NAMED_CHARACTER_REFERENCE(2036, 'u' _ 't' _ 'd' _ 'o' _ 't' _ ';', 6, 0x22f0, 1)
NAMED_CHARACTER_REFERENCE(2037, 'u' _ 't' _ 'i' _ 'l' _ 'd' _ 'e' _ ';', 7, 0x0169, 1)
NAMED_CHARACTER_REFERENCE(2038, 'u' _ 't' _ 'r' _ 'i' _ ';', 5, 0x25b5, 1)
NAMED_CHARACTER_REFERENCE(2039, 'u' _ 't' _ 'r' _ 'i' _ 'f' _ ';', 6, 0x25b4, 1)
NAMED_CHARACTER_REFERENCE(2040, 'u' _ 'u' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x21c8, 1)
NAMED_CHARACTER_REFERENCE(2041, 'u' _ 'u' _ 'm' _ 'l', 4, 0x00fc, 1)
NAMED_CHARACTER_REFERENCE(2042, 'u' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00fc, 1)
NAMED_CHARACTER_REFERENCE(2043, 'u' _ 'w' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ ';', 8, 0x29a7, 1)
NAMED_CHARACTER_REFERENCE(2044, 'v' _ 'A' _ 'r' _ 'r' _ ';', 5, 0x21d5, 1)
NAMED_CHARACTER_REFERENCE(2045, 'v' _ 'B' _ 'a' _ 'r' _ ';', 5, 0x2ae8, 1)
NAMED_CHARACTER_REFERENCE(2046, 'v' _ 'B' _ 'a' _ 'r' _ 'v' _ ';', 6, 0x2ae9, 1)
NAMED_CHARACTER_REFERENCE(2047, 'v' _ 'D' _ 'a' _ 's' _ 'h' _ ';', 6, 0x22a8, 1)
NAMED_CHARACTER_REFERENCE(2048, 'v' _ 'a' _ 'n' _ 'g' _ 'r' _ 't' _ ';', 7, 0x299c, 1)
NAMED_CHARACTER_REFERENCE(2049, 'v' _ 'a' _ 'r' _ 'e' _ 'p' _ 's' _ 'i' _ 'l' _ 'o' _ 'n' _ ';', 11, 0x03f5, 1)
NAMED_CHARACTER_REFERENCE(2050, 'v' _ 'a' _ 'r' _ 'k' _ 'a' _ 'p' _ 'p' _ 'a' _ ';', 9, 0x03f0, 1)
NAMED_CHARACTER_REFERENCE(2051, 'v' _ 'a' _ 'r' _ 'n' _ 'o' _ 't' _ 'h' _ 'i' _ 'n' _ 'g' _ ';', 11, 0x2205, 1)
NAMED_CHARACTER_REFERENCE(2052, 'v' _ 'a' _ 'r' _ 'p' _ 'h' _ 'i' _ ';', 7, 0x03d5, 1)
NAMED_CHARACTER_REFERENCE(2053, 'v' _ 'a' _ 'r' _ 'p' _ 'i' _ ';', 6, 0x03d6, 1)
NAMED_CHARACTER_REFERENCE(2054, 'v' _ 'a' _ 'r' _ 'p' _ 'r' _ 'o' _ 'p' _ 't' _ 'o' _ ';', 10, 0x221d, 1)
NAMED_CHARACTER_REFERENCE(2055, 'v' _ 'a' _ 'r' _ 'r' _ ';', 5, 0x2195, 1)
NAMED_CHARACTER_REFERENCE(2056, 'v' _ 'a' _ 'r' _ 'r' _ 'h' _ 'o' _ ';', 7, 0x03f1, 1)
NAMED_CHARACTER_REFERENCE(2057, 'v' _ 'a' _ 'r' _ 's' _ 'i' _ 'g' _ 'm' _ 'a' _ ';', 9, 0x03c2, 1)
NAMED_CHARACTER_REFERENCE(2058, 'v' _ 'a' _ 'r' _ 't' _ 'h' _ 'e' _ 't' _ 'a' _ ';', 9, 0x03d1, 1)
NAMED_CHARACTER_REFERENCE(2059, 'v' _ 'a' _ 'r' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'l' _ 'e' _ 'f' _ 't' _ ';', 16, 0x22b2, 1)
NAMED_CHARACTER_REFERENCE(2060, 'v' _ 'a' _ 'r' _ 't' _ 'r' _ 'i' _ 'a' _ 'n' _ 'g' _ 'l' _ 'e' _ 'r' _ 'i' _ 'g' _ 'h' _ 't' _ ';', 17, 0x22b3, 1)
NAMED_CHARACTER_REFERENCE(2061, 'v' _ 'c' _ 'y' _ ';', 4, 0x0432, 1)
NAMED_CHARACTER_REFERENCE(2062, 'v' _ 'd' _ 'a' _ 's' _ 'h' _ ';', 6, 0x22a2, 1)
NAMED_CHARACTER_REFERENCE(2063, 'v' _ 'e' _ 'e' _ ';', 4, 0x2228, 1)
NAMED_CHARACTER_REFERENCE(2064, 'v' _ 'e' _ 'e' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x22bb, 1)
NAMED_CHARACTER_REFERENCE(2065, 'v' _ 'e' _ 'e' _ 'e' _ 'q' _ ';', 6, 0x225a, 1)
NAMED_CHARACTER_REFERENCE(2066, 'v' _ 'e' _ 'l' _ 'l' _ 'i' _ 'p' _ ';', 7, 0x22ee, 1)
NAMED_CHARACTER_REFERENCE(2067, 'v' _ 'e' _ 'r' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x007c, 1)
NAMED_CHARACTER_REFERENCE(2068, 'v' _ 'e' _ 'r' _ 't' _ ';', 5, 0x007c, 1)
NAMED_CHARACTER_REFERENCE(2069, 'v' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd33, 2)
NAMED_CHARACTER_REFERENCE(2070, 'v' _ 'l' _ 't' _ 'r' _ 'i' _ ';', 6, 0x22b2, 1)
NAMED_CHARACTER_REFERENCE(2071, 'v' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd67, 2)
NAMED_CHARACTER_REFERENCE(2072, 'v' _ 'p' _ 'r' _ 'o' _ 'p' _ ';', 6, 0x221d, 1)
NAMED_CHARACTER_REFERENCE(2073, 'v' _ 'r' _ 't' _ 'r' _ 'i' _ ';', 6, 0x22b3, 1)
NAMED_CHARACTER_REFERENCE(2074, 'v' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdccb, 2)
NAMED_CHARACTER_REFERENCE(2075, 'v' _ 'z' _ 'i' _ 'g' _ 'z' _ 'a' _ 'g' _ ';', 8, 0x299a, 1)
NAMED_CHARACTER_REFERENCE(2076, 'w' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0175, 1)
NAMED_CHARACTER_REFERENCE(2077, 'w' _ 'e' _ 'd' _ 'b' _ 'a' _ 'r' _ ';', 7, 0x2a5f, 1)
NAMED_CHARACTER_REFERENCE(2078, 'w' _ 'e' _ 'd' _ 'g' _ 'e' _ ';', 6, 0x2227, 1)
NAMED_CHARACTER_REFERENCE(2079, 'w' _ 'e' _ 'd' _ 'g' _ 'e' _ 'q' _ ';', 7, 0x2259, 1)
NAMED_CHARACTER_REFERENCE(2080, 'w' _ 'e' _ 'i' _ 'e' _ 'r' _ 'p' _ ';', 7, 0x2118, 1)
NAMED_CHARACTER_REFERENCE(2081, 'w' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd34, 2)
NAMED_CHARACTER_REFERENCE(2082, 'w' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd68, 2)
NAMED_CHARACTER_REFERENCE(2083, 'w' _ 'p' _ ';', 3, 0x2118, 1)
NAMED_CHARACTER_REFERENCE(2084, 'w' _ 'r' _ ';', 3, 0x2240, 1)
NAMED_CHARACTER_REFERENCE(2085, 'w' _ 'r' _ 'e' _ 'a' _ 't' _ 'h' _ ';', 7, 0x2240, 1)
NAMED_CHARACTER_REFERENCE(2086, 'w' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdccc, 2)
NAMED_CHARACTER_REFERENCE(2087, 'x' _ 'c' _ 'a' _ 'p' _ ';', 5, 0x22c2, 1)
NAMED_CHARACTER_REFERENCE(2088, 'x' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x25ef, 1)
NAMED_CHARACTER_REFERENCE(2089, 'x' _ 'c' _ 'u' _ 'p' _ ';', 5, 0x22c3, 1)
NAMED_CHARACTER_REFERENCE(2090, 'x' _ 'd' _ 't' _ 'r' _ 'i' _ ';', 6, 0x25bd, 1)
NAMED_CHARACTER_REFERENCE(2091, 'x' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd35, 2)
NAMED_CHARACTER_REFERENCE(2092, 'x' _ 'h' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x27fa, 1)
NAMED_CHARACTER_REFERENCE(2093, 'x' _ 'h' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x27f7, 1)
NAMED_CHARACTER_REFERENCE(2094, 'x' _ 'i' _ ';', 3, 0x03be, 1)
NAMED_CHARACTER_REFERENCE(2095, 'x' _ 'l' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x27f8, 1)
NAMED_CHARACTER_REFERENCE(2096, 'x' _ 'l' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x27f5, 1)
NAMED_CHARACTER_REFERENCE(2097, 'x' _ 'm' _ 'a' _ 'p' _ ';', 5, 0x27fc, 1)
NAMED_CHARACTER_REFERENCE(2098, 'x' _ 'n' _ 'i' _ 's' _ ';', 5, 0x22fb, 1)
NAMED_CHARACTER_REFERENCE(2099, 'x' _ 'o' _ 'd' _ 'o' _ 't' _ ';', 6, 0x2a00, 1)
NAMED_CHARACTER_REFERENCE(2100, 'x' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd69, 2)
NAMED_CHARACTER_REFERENCE(2101, 'x' _ 'o' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 7, 0x2a01, 1)
NAMED_CHARACTER_REFERENCE(2102, 'x' _ 'o' _ 't' _ 'i' _ 'm' _ 'e' _ ';', 7, 0x2a02, 1)
NAMED_CHARACTER_REFERENCE(2103, 'x' _ 'r' _ 'A' _ 'r' _ 'r' _ ';', 6, 0x27f9, 1)
NAMED_CHARACTER_REFERENCE(2104, 'x' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 6, 0x27f6, 1)
NAMED_CHARACTER_REFERENCE(2105, 'x' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdccd, 2)
NAMED_CHARACTER_REFERENCE(2106, 'x' _ 's' _ 'q' _ 'c' _ 'u' _ 'p' _ ';', 7, 0x2a06, 1)
NAMED_CHARACTER_REFERENCE(2107, 'x' _ 'u' _ 'p' _ 'l' _ 'u' _ 's' _ ';', 7, 0x2a04, 1)
NAMED_CHARACTER_REFERENCE(2108, 'x' _ 'u' _ 't' _ 'r' _ 'i' _ ';', 6, 0x25b3, 1)
NAMED_CHARACTER_REFERENCE(2109, 'x' _ 'v' _ 'e' _ 'e' _ ';', 5, 0x22c1, 1)
NAMED_CHARACTER_REFERENCE(2110, 'x' _ 'w' _ 'e' _ 'd' _ 'g' _ 'e' _ ';', 7, 0x22c0, 1)
NAMED_CHARACTER_REFERENCE(2111, 'y' _ 'a' _ 'c' _ 'u' _ 't' _ 'e', 6, 0x00fd, 1)
NAMED_CHARACTER_REFERENCE(2112, 'y' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x00fd, 1)
NAMED_CHARACTER_REFERENCE(2113, 'y' _ 'a' _ 'c' _ 'y' _ ';', 5, 0x044f, 1)
NAMED_CHARACTER_REFERENCE(2114, 'y' _ 'c' _ 'i' _ 'r' _ 'c' _ ';', 6, 0x0177, 1)
NAMED_CHARACTER_REFERENCE(2115, 'y' _ 'c' _ 'y' _ ';', 4, 0x044b, 1)
NAMED_CHARACTER_REFERENCE(2116, 'y' _ 'e' _ 'n', 3, 0x00a5, 1)
NAMED_CHARACTER_REFERENCE(2117, 'y' _ 'e' _ 'n' _ ';', 4, 0x00a5, 1)
NAMED_CHARACTER_REFERENCE(2118, 'y' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd36, 2)
NAMED_CHARACTER_REFERENCE(2119, 'y' _ 'i' _ 'c' _ 'y' _ ';', 5, 0x0457, 1)
NAMED_CHARACTER_REFERENCE(2120, 'y' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd6a, 2)
NAMED_CHARACTER_REFERENCE(2121, 'y' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdcce, 2)
NAMED_CHARACTER_REFERENCE(2122, 'y' _ 'u' _ 'c' _ 'y' _ ';', 5, 0x044e, 1)
NAMED_CHARACTER_REFERENCE(2123, 'y' _ 'u' _ 'm' _ 'l', 4, 0x00ff, 1)
NAMED_CHARACTER_REFERENCE(2124, 'y' _ 'u' _ 'm' _ 'l' _ ';', 5, 0x00ff, 1)
NAMED_CHARACTER_REFERENCE(2125, 'z' _ 'a' _ 'c' _ 'u' _ 't' _ 'e' _ ';', 7, 0x017a, 1)
NAMED_CHARACTER_REFERENCE(2126, 'z' _ 'c' _ 'a' _ 'r' _ 'o' _ 'n' _ ';', 7, 0x017e, 1)
NAMED_CHARACTER_REFERENCE(2127, 'z' _ 'c' _ 'y' _ ';', 4, 0x0437, 1)
NAMED_CHARACTER_REFERENCE(2128, 'z' _ 'd' _ 'o' _ 't' _ ';', 5, 0x017c, 1)
NAMED_CHARACTER_REFERENCE(2129, 'z' _ 'e' _ 'e' _ 't' _ 'r' _ 'f' _ ';', 7, 0x2128, 1)
NAMED_CHARACTER_REFERENCE(2130, 'z' _ 'e' _ 't' _ 'a' _ ';', 5, 0x03b6, 1)
NAMED_CHARACTER_REFERENCE(2131, 'z' _ 'f' _ 'r' _ ';', 4, 0xd835 _ 0xdd37, 2)
NAMED_CHARACTER_REFERENCE(2132, 'z' _ 'h' _ 'c' _ 'y' _ ';', 5, 0x0436, 1)
NAMED_CHARACTER_REFERENCE(2133, 'z' _ 'i' _ 'g' _ 'r' _ 'a' _ 'r' _ 'r' _ ';', 8, 0x21dd, 1)
NAMED_CHARACTER_REFERENCE(2134, 'z' _ 'o' _ 'p' _ 'f' _ ';', 5, 0xd835 _ 0xdd6b, 2)
NAMED_CHARACTER_REFERENCE(2135, 'z' _ 's' _ 'c' _ 'r' _ ';', 5, 0xd835 _ 0xdccf, 2)
NAMED_CHARACTER_REFERENCE(2136, 'z' _ 'w' _ 'j' _ ';', 4, 0x200d, 1)
NAMED_CHARACTER_REFERENCE(2137, 'z' _ 'w' _ 'n' _ 'j' _ ';', 5, 0x200c, 1)

#undef _
